//************************************************
//system/TOOL BOX constants
//************************************************

#define	kMoveToFront		(WindowPtr)-1

#define	kAddCheckMark		true
#define	kRemoveCheckMark	false

#define	kNotANormalMenu	-1

#define	kGestaltMask		1L

#define	kVisible			true
#define	kUnvisible			false

#define	kDisableItem		255
#define	kEnableItem		0

//char code
#define	kRet				0x0D
#define	kCR				0x0D
#define	kEnter			0x03
#define	kESC				0x1B
#define	kTAB			0x09

//key code
#define	kOptKey			0x3A
#define	kCmdKey			0x37

#define	kMinTextPosition	0
#define	kMaxTextPosition	32727
#define	kMaxTextSize		32727

//************************************************
// application constants
//************************************************

#define	kAppWindLeft		40
#define	kAppWindTop		80
#define	kSecsOfWeek		604800
#define	kSleep			200L

#define	kInactive		false
#define	kActive		true

//#define	kPrefDialogKind		55
//#define	kWarnDialogKind	56
//#define	kExceptDialogKind	57

#define	kFatal		true
#define	kNotFatal		false

#define	k128K					0x20000		//128K

//************************************************
//	game constant
//************************************************
//game ID
enum{
	rSame = 200,
	rMame = 210,
	rKome = 230,
	rChoi = 240,
	rTume = 250,
	rYori = 260,
	rOther = 500
};

//board size
#define	kMapSameX		20
#define	kMapSameY		12
#define	kMapMameX		40
#define	kMapMameY		24
#define	kMapKomeX		80
#define	kMapKomeY		48
#define	kMapChoiX		10
#define	kMapChoiY		10
#define	kMapTumeX		5
#define	kMapTumeY		5
#define	kMapYoriX		20
#define	kMapYoriY		12

//character file format
enum{
	fError	= 0,
	fSame	= 1,
	fSame2,
	fMaru
};

//size of character PICT
#define	kCharaSizeMin	4
#define	kCharaSizeMax	32
#define	kIconSize		32
#define	kNumOfKind	5		//fixed to 5
#define	kNumOfColor	50		//count of variable color; maru same format
#define 	kHeight		64		//height of maru format

//count of character on the PICT
#define	kSameIconV	2	//samegame format
#define	kSameIconH	5
#define	kSame2IconV	2	//samegame2 format
#define	kSame2IconH	6
#define	kMaruIconV	2	//maru format
#define	kMaruIconH	8

//height and width of the PICT
#define	kSameV	kIconSize*kSameIconV	//32*2
#define	kSameH	kIconSize*kSameIconH	//32*5
#define	kSame2V	kIconSize*kSame2IconV	//32*2
#define	kSame2H	kIconSize*kSame2IconH	//32*6
#define	kMaruV	kIconSize*kMaruIconV+1	//32*2+1  add 1 for color table
#define	kMaruH	kIconSize*kMaruIconH	//32*8

//size of gWorld for character picture
#define	kGWorldH		256		//32*8
#define	kGWorldV		321		//64*5+1

//memory for map
#define	kMaxMapY		48
#define	kMaxMapX		80
#define	kMapMemorySize	82*50
#define	kMapH			82					//row byte for map memory
#define	kHistoryMap		kMapSameX*kMapSameY
#define	kHistoryMaxStep	120
#define	kPlayHistorySize	kHistoryMap*kHistoryMaxStep		//size of undo memory	20*12*120

//level of aim hi-score
#define	kAimHSAvail1		3000
#define	kAimHSAvail2		4000
#define	kAimHSAvail3		5000
#define	kAimHSLv0		0
#define	kAimHSLv1		1
#define	kAimHSLv2		2
#define	kAimHSLv3		3
#define	kAimHSLoop0		1		//loop count to make new game in aim hi-score mode
#define	kAimHSLoop1		3
#define	kAimHSLoop2		5
#define	kAimHSLoop3		10

//rType and rID for data save
#define	kGameDataType		'gamD'
#define	kGameValue		128
#define	kGameValue_bak	129
#define	kMapData			130
#define	kMapData_bak		131
#define	kMapDataOrg		132
#define	kMapDataOrg_bak	133
#define	kGameHistory		140
#define	kGameHistory_bak	141

//flag for map data
#define	kMapBlank		0
#define	kMapCaraMask	0x07
#define	kMapChecked	0x80
#define	kMapUnCheck	(0xff - kMapChecked)

//size of window header
#define	kHeaderHeight		16
#define	kHeaderPosV		12

#define	kHeaderGetH		10
#define	kHeaderThumbSize	12
#define	kHeaderThumbH		320
#define	kHeaderThumbDelta	30

//game status
enum{
	kNoFlag		= 0,
//	kCanUndo		= 1,
	kGameStart	= 2,
	kGameEnd		= 4,
	kShowTake	= 8,
	kTumeSolution	= 16,
	kFlagFull		= 0xffff
};

//*************************************
//Hi Score Resource
//*************************************
#define	kHiScoreNameMaxCount	15
#define	kRankMax				10
#define	kHiScoreHeight			16
#define	kHiScoreLineHeight		12

#define	kHandleTempSize		1024
#define	kRemainMax			999

//**************
// Button on Window
//**************
#ifdef TARGET_API_MAC_CARBON
#define	kButtonDistance	10
#define	kButtonMargin		20
#define	kButtonHeight		24
#define	kButtonActualHeight		17
#else
#define	kButtonDistance	2
#define	kButtonMargin		10
#define	kButtonHeight		20
#endif
