/*
#ifdef	_global
	#define	global
#else
	#define	global	extern
#endif
*/
#define TRAGET_API_MAC_CARBON 1

#if !BUILDING_FOR_CARBON_8
	#include <Carbon/Carbon.h>
#else
	#include <Carbon.h>
#endif

#ifdef TRAGET_API_MAC_CARBON
#define topLeft(aRect) (* (Point *) &(aRect).top)
#define botRight(aRect) (* (Point *) &(aRect).bottom)
#endif

/******* struct definition *********************/
#ifndef TRAGET_API_MAC_CARBON
#pragma options align=mac68k
#endif

typedef struct {
	Str255		hiScoreName;
	Rect			windowPos;
	//
	RGBColor		defaultColor;
	short		aimHSAvail;
	short		aimHSSelect;
	Boolean		isMonkeyMode;
	Boolean		isAutoSize;
	short		charaSize;
	//
	short		reservedS1;
	short		reservedS2;
	short		reservedS3;
	short		reservedS4;
	long			reservedL1;
	long			reservedL2;
	long			reservedL3;
	long			reservedL4;
	Str255		reservedStr1;
	Str255		reservedStr2;
}prefVal, *prefValPtr;

//modeless dialog record
typedef struct {
#ifndef TRAGET_API_MAC_CARBON
	DialogRecord	theDialog;
#endif
	short		resNumber;
	//
	prefVal		tempPref;
	short		prevItem;
	//
	TEHandle		hTE;
	short		lineHeight;
	//
//	RgnHandle		textItemRgn;
//	RgnHandle		fingerRgn;
	//
	short		rankID;
	short		rankScore;
	short		rankRemain;
	Handle		hiscoreData;
	Handle		hiscoreRemain;
	MenuHandle	popupMenu;
	//
#ifdef TARGET_API_MAC_CARBON
} DialogDataRec, *DialogDataPtr;
#else
} myDlgRec, *myDlgPeek;
#endif

typedef struct {
	short		gameID;
	short		mapX;
	short		mapY;
	short		komaSize;
	//
	Boolean		canGameUndo;	//flag : can game undo
	unsigned long	gameStatus;	//
	short		tumeStage;
	long			remain;		//remain count at game ending
	unsigned long	score;
	unsigned long	bonus;
	unsigned long	get;
}gameVal, *gameValPtr;

typedef struct {
	unsigned long	score;
	long			remain;
	unsigned long	dateSecs;
	long			reserved1;
	long			reserved2;
	Str255		name;
	unsigned short	checkSum;
}scoreVal, *scoreValPtr;

typedef struct{
	long			newGameCount;
	long			endingCount;
	unsigned long	playTimeSec;
	unsigned long	scoreSum;
	unsigned long	remainSum;
	long			reserved;
}playStatics, *playStaticsPtr;
typedef struct {
#ifndef TARGET_API_MAC_CARBON
	WindowRecord	theWindow;
#endif
	//display position of score and thumbnail
	short		headerHeight;	//total header height
	short		scoreTop;
	short		thumbTop;
	short		thumbH;
	short		clusterH;
	//display count
	unsigned char	startCara;		//search chara
	unsigned long	clusterCount;
	//draw maru character at nullEvent
	short		charaType;
	Boolean		drawIt;
	short		startY;
	short		drawY;
	//
	RGBColor		backColor;
	//GWorld
	GWorldPtr		charaGWPtr;	//display piece data
	PixMapHandle	charaPm;		//PixMapHandle of GWorld
	GWorldPtr		scoreGWPtr;	//thumbnail piece data
	PixMapHandle	scorePm;		//PixMapHandle of GWorld
	//map data
	Ptr			mapData;		//now map data
	Ptr			mapData_bak;
	Ptr			mapDataOrg;	//original map data
	Ptr			mapDataOrg_bak;
	//game value
	unsigned long	gameEndSecs;
	gameVal		gv;
	gameVal		gv_bak;
	//hiscore data
	Handle		hiscoreData;
	Handle		hiscoreRemain;
#ifdef TARGET_API_MAC_CARBON
} WindowDataRec, *WindowDataPtr;
#else
} myWindowRec, *myWindow_Peek;
#endif

#ifndef TRAGET_API_MAC_CARBON
#pragma options align=reset
#endif

#include	"applicationConstants.h"
#include	"applicationRsrc.h"

#include	"main.h"
#include	"doAppleEvent.h"
#include	"dialogUtilities.h"
#include	"doAbout.h"
#include	"doPreferences.h"
#include	"doModelessDialog.h"
#include	"showOSError.h"

#include	"doMyPrefDLG.h"
#include	"doNew.h"
#include	"doPlay.h"
#include	"preparation.h"
#include	"drawWindow.h"
#include	"doGameEnding.h"
#include	"doMenuButton.h"
#include	"doCharacter.h"
#include	"doSaveOpen.h"

//access to data
#ifdef TARGET_API_MAC_CARBON
#define	WIN_DATA(wp, x)			(getWindowDataPtr(wp)->x)
#define	GAME_VAL(wp, x)			(getWindowDataPtr(wp)->gv.x)
#else
#define	WIN_DATA(wp, x)			(((myWindowPeek)wp)->x)
#define	GAME_VAL(wp, x)			(((myWindowPeek)wp)->gv.x)
#endif
#define	GAME_STATUS(wp, x)		(((GAME_VAL(wp, gameStatus))&(x))!=0)
#define	MAP_DATA(wp, x, y)		(*((unsigned char *)(WIN_DATA(wp, mapData) + (unsigned long)x + (unsigned long)kMapH*(unsigned long)(y))))
#define	MAP_DATA_PREV(wp, x, y)	(*((unsigned char *)(WIN_DATA(wp, mapData_bak) + (unsigned long)x + (unsigned long)kMapH*(unsigned long)(y))))
#ifdef TARGET_API_MAC_CARBON
#define	DLG_DATA(theDialog, x)		(getDialogDataPtr(theDialog)->x)
#else
#define	DLG_DATA(theDialog, x)		(((myDlgPeek)theDialog)->x)
#endif
#define	SCORE_VAL(scoreH, rank, x)	(((scoreValPtr)(*(scoreH)+(rank-1)*sizeof(scoreVal)))->x)

#ifndef TARGET_API_MAC_CARBON
/*application globals **************/
global	Boolean	gDone;
//
global	SysEnvRec	gMac;			/* set up by Initialize */
global	Boolean	gHasWaitNextEvent;		/* set up by Initialize */
global	Boolean	gDragAndDropAvailable;	/* set up by Initialize */
global	Boolean	gHasTextServices;
global	Boolean	gHasTSMTE;

/*	catalog search global	*/
//global	CInfoPBRec	gPB;			//for the PBGetCatInfo call
//global	Str255		gFileName;	//for gPB filename buffer
//
//
global	short	gAppRsrcFRefNum;	//application fRefNum
//global	FSSpec	gAppFSSpec;		//application FSSpec
//
//global	FSSpec	gPrefFSSpec;		//preference FSSpec
//global	short	gPrefFRefNum;		//preference fRefNum
//
global	short		gCursorCount;
global	unsigned long	gCursorTicks;
//
global	prefVal	gPrefVal;				//globals for pref
//
#endif

