/*dialog utilities.c*/

#include	"applicationGlobals.h"

#define	kAlertNumberRangeDLOG		1810
#define	kDefaultAlert				1

#ifndef TARGET_API_MAC_CARBON
void drawDefaultButtonFrame(DialogPtr theDialog, short item)
{
	Rect		iRect;
	short	iType;
	Handle	iHandle;
	GrafPtr	savePort;
	PenState	thePnState;

/*
#ifdef TRAGET_API_MAC_CARBON
        Pattern gray;
#endif
*/
	GetPort(&savePort);
	SetPort((GrafPtr)theDialog);
	GetPenState(&thePnState);

	GetDialogItem(theDialog, item, &iType, &iHandle, &iRect);
	
	InsetRect(&iRect, -4, -4);
	
	PenNormal();
	PenSize(3,3);
	if((iType & itemDisable) != 0)

/*
#ifdef TRAGET_API_MAC_CARBON
        {
                GetQDGlobalsGray(&gray);
		PenPat(&gray);
        }
#else
*/
		PenPat(&qd.gray);
//#endif
	
	FrameRoundRect(&iRect, 16,16);
	
	SetPenState(&thePnState);
	SetPort(savePort);
}
#endif

ControlHandle getCtlHandle(DialogPtr theDialog, short item)
{
#ifdef TRAGET_API_MAC_CARBON
        ControlHandle iHandle;
        OSErr err = noErr;
        
        err = GetDialogItemAsControl(theDialog, item, &iHandle);
	if (( iHandle == nil ) || ( err != noErr ))
		DebugStr((ConstStr255Param)"\pGetDItem in GetCtlHandle failed");
	return iHandle;
#else
	Rect		iRect;
	short	iType;
	Handle	iHandle;
	
	GetDialogItem(theDialog, item, &iType, &iHandle, &iRect);
	if (iHandle == nil )
		DebugStr((StringPtr)"\pGetDItem in GetCtlHandle failed");
	return( (ControlHandle)iHandle);
#endif
}


void fakeButtonHilite(DialogPtr theDialog, short item)
{
	unsigned long finalTick;
	ControlHandle	cHandle;

	cHandle = getCtlHandle(theDialog, item);
	if ( cHandle != nil )
	{
		HiliteControl(cHandle, true);
		Delay(8,&finalTick);
		HiliteControl(cHandle, false);
	}

}

#pragma mark -

void selectTextItem(DialogPtr theDialog, short item)
{
	SelectDialogItemText (theDialog, item, 0, 32767);
}

void setText (DialogPtr theDialog, short item, Str255 text)
{	
	Rect		iRect;
	short	iType;
	Handle	iHandle;
	
	GetDialogItem (theDialog, item, &iType, &iHandle, &iRect);
	SetDialogItemText (iHandle, text);
}

void setTextToControl (DialogPtr theDialog, short item, Str255 text)
{	
#ifdef TARGET_API_MAC_CARBON
	ControlHandle iHandle;
	
        GetDialogItemAsControl(theDialog, item, &iHandle);
	SetControlTitle(iHandle,text);
#else
	Rect		iRect;
	short	iType;
	Handle	iHandle;
	
	GetDialogItem (theDialog, item, &iType, &iHandle, &iRect);
	SetControlTitle((ControlHandle)iHandle,text);
#endif
}

void getText(DialogPtr theDialog, short item, Str255 text)
{	
	Rect		iRect;
	short	iType;
	Handle	iHandle;
	
	GetDialogItem (theDialog, item, &iType, &iHandle, &iRect);	
	GetDialogItemText (iHandle, text);
}

void getControlText(DialogPtr theDialog, short item, Str255 text)
{
#ifdef TARGET_API_MAC_CARBON
	ControlHandle iHandle;
	
        GetDialogItemAsControl(theDialog, item, &iHandle);
	GetControlTitle(iHandle,text);
#else
	Rect		iRect;
	short	iType;
	Handle	iHandle;

	GetDialogItem (theDialog, item, &iType, &iHandle, &iRect);
	GetControlTitle((ControlHandle)iHandle,text);	
#endif
}

#pragma mark -

//#define	kAlertNumberRangeDLOG		1810
//#define	kDefaultAlert				1

Boolean	getNumberTextRange(DialogPtr theDialog, short item, long *value, long min, long max, Str255 itemTitle)
{
	Boolean	result = true;
	Str255	theString, minStr, maxStr;
	short	itemHit;
	
	result = getNumberText(theDialog, item, value);

	if(result)
	{
		if(*value<min)
			result = false;
	
		if(*value>max)
			result = false;
	}

	if(!result)
	{
		NumToString(min,minStr);
		NumToString(max,maxStr);
		setMyCursor(kArrowCURS);
		if(itemTitle == nil)
		{
			GetIndString(theString, kAlertNumberRangeDLOG, kDefaultAlert);
			ParamText(theString, minStr, maxStr, nil);
		}
		else
			ParamText(itemTitle, minStr, maxStr, nil);

		setMyCursor(kArrowCURS);
		itemHit = Alert(kAlertNumberRangeDLOG, nil);

		selectTextItem (theDialog, item);
	}


	return(result);
}

Boolean getNumberText(DialogPtr theDialog, short item, long *value)
{
	Boolean	result;
	Str255 	theString;

	getText(theDialog,  item, theString);
	result = stringToNumber(theString, value);

	return(result);
}

void setNumberText(DialogPtr theDialog, short item, long value)
{
	
	Str255 s;
		
	NumToString (value, s);	
	setText (theDialog, item, s);
}

Boolean stringToNumber (Str255 s, long *value)
{	
	short i;
	short j;
	long x;
	Boolean negative = false;
	Boolean isNumber = true;
	Boolean trailingBlanks = false;
	
	for (i = 1, j = 0; i <= StrLength (s) && isNumber; ++i)
	{
		if (j == 0 && s [i] == ' ')
			; // Do nothing: Leading blanks
		else if (j > 0 && s [i] == ' ')
			trailingBlanks = true;			
		else if (trailingBlanks && s [i] != ' ')
			isNumber = false;
		else if (j == 0 && !negative && s [i] == '-')
			negative = true;
		else if (s [i] < '0' || s [i] > '9')
			isNumber = false;
		else
			s [++j] = s [i];
	}
		
	if (j == 0)
		isNumber = false;
	else
		s [0] = (unsigned char) j;
	
	if (isNumber)
	{	
		if (j <= 9)
			StringToNum (s, &x);
		else
			x = 0x7FFFFFFF;
		
		if (negative)
			x = -x;
			
		*value = x;		
	}
		
	return(isNumber);
}

#pragma mark -

void setCheckBoxState (DialogPtr theDialog, short item, Boolean checkIt)
{
#ifdef TARGET_API_MAC_CARBON
	ControlHandle iHandle;
	short	oldValue, newValue;
	
        GetDialogItemAsControl(theDialog, item, &iHandle);

	oldValue =  GetControlValue (iHandle);
	
	newValue = checkIt ? 1 : 0;

	if (oldValue != newValue)
		SetControlValue (iHandle, newValue);
#else
	Rect		iRect;
	Handle	iHandle;
	short	iType;
	short	oldValue, newValue;
	
	GetDialogItem (theDialog, item, &iType, &iHandle, &iRect);

	oldValue =  GetControlValue ((ControlHandle) iHandle);
	
	newValue = checkIt ? 1 : 0;

	if (oldValue != newValue)
		SetControlValue ((ControlHandle) iHandle, newValue);
#endif
}


Boolean getCheckBoxState (DialogPtr theDialog, short item)
{
#ifdef TARGET_API_MAC_CARBON
	ControlHandle iHandle;
	short	value;
	
        GetDialogItemAsControl(theDialog, item, &iHandle);

	value = GetControlValue (iHandle);
#else
	Rect		iRect;
	Handle	iHandle;
	short	iType;
	short	value;
	
	GetDialogItem (theDialog, item, &iType, &iHandle, &iRect);

	value = GetControlValue ((ControlHandle) iHandle);
#endif
	return (value != kControlCheckBoxUncheckedValue);
}

#pragma mark -

void setRadioGroupState (DialogPtr theDialog, short first, short last, short item)
{
	short	i;
	
	for (i = first; i <= last; ++i)
		setCheckBoxState (theDialog, i, i == item);

}

short getRadioGroupState (DialogPtr theDialog, short first, short last)
{
	
	short	i;
	
	for (i = first; i <= last; ++i)
		if (getCheckBoxState (theDialog, i))
			return (i);
			
	return (0);
	
}

#pragma mark -


void enableControl (DialogPtr theDialog, short item)
{
	Rect		iRect;
	Handle	iHandle;
	short	iType;
	
	GetDialogItem (theDialog, item, &iType, &iHandle, &iRect);

	iType &= ~itemDisable;

	HiliteControl ((ControlHandle) iHandle, 0);

	SetDialogItem (theDialog, item, iType, iHandle, &iRect);
}

void	enableAllControls(DialogPtr theDialog)
{
	short	i, num;
	Rect		iRect;
	Handle	iHandle;
	short	iType;

	num = CountDITL(theDialog);

	for(i = 1;i<=num;i++)
	{
		GetDialogItem(theDialog,i,&iType,&iHandle,&iRect);
		if((iType & ctrlItem)!=0)						//iType is control item
			enableControl (theDialog, i);
	}
}

void	enableControlGroup(DialogPtr theDialog, short first, short last)
{	
	short	i;
	
	for (i = first; i <= last; ++i)
		enableControl (theDialog, i);

}

void disableControl (DialogPtr theDialog, short item)
{

	Rect		iRect;
	Handle	iHandle;
	short	iType;
	
	GetDialogItem (theDialog, item, &iType, &iHandle, &iRect);

	iType |= itemDisable;

//	oldValue = GetControlValue ((ControlHandle) iHandle);
//	if (oldValue != 0)
//		SetControlValue ((ControlHandle) iHandle, 0);

	HiliteControl ((ControlHandle) iHandle, 255);
	SetDialogItem (theDialog, item, iType, iHandle, &iRect);
}

void	disableAllControls(DialogPtr theDialog)
{
	short	i, num;
	Rect		iRect;
	Handle	iHandle;
	short	iType;

	num = CountDITL(theDialog);

	for(i = 1;i<=num;i++)
	{
		GetDialogItem(theDialog,i,&iType,&iHandle,&iRect);
		if((iType & ctrlItem)!=0)						//iType is control item
			disableControl (theDialog, i);
	}
}

void	disableControlGroup(DialogPtr theDialog, short first, short last)
{
	short	i;
	
	for (i = first; i <= last; ++i)
		disableControl (theDialog, i);

}

#pragma mark -

Boolean	isControlActive(DialogPtr theDialog, short item)
{
	ControlHandle	theControl;
	Boolean		result = true;

	theControl = getCtlHandle( theDialog,  item);

#ifdef TRAGET_API_MAC_CARBON
	if(GetControlHilite(theControl) == 255)
#else
	if((*theControl)->contrlHilite == 255)
#endif
		result = false;

	return(result);
}

Boolean	isControlEnable(DialogPtr theDialog, short item)
{
	Rect		iRect;
	Handle	iHandle;
	short	iType;
	Boolean	result = true;
	
	GetDialogItem (theDialog, item, &iType, &iHandle, &iRect);
	if((iType & itemDisable)!=0)
		result = false;

	return(result);
}

#pragma mark -
#ifdef TARGET_API_MAC_CARBON
void	moveStaticText(DialogRef theDialog, short item, short diffWide, short diffHigh)
#else
void	moveStaticText(WindowPtr theDialog, short item, short diffWide, short diffHigh)
#endif
{
	Rect		iRect;
	short	iType;
	Handle	iHandle;
        
#ifdef TRAGET_API_MAC_CARBON
	GetDialogItem (theDialog, item, &iType, &iHandle, &iRect);
#else
	GetDialogItem (theDialog, item, &iType, &iHandle, &iRect);
#endif
	OffsetRect(&iRect, diffWide, diffHigh);
#ifdef TRAGET_API_MAC_CARBON
	SetDialogItem (theDialog, item, iType, iHandle, &iRect);
#else
	SetDialogItem (theDialog, item, iType, iHandle, &iRect);
#endif
}

#ifdef TARGET_API_MAC_CARBON
void	moveButton(DialogRef theDialog, short item, short diffWide, short diffHigh)
#else
void	moveButton(WindowPtr theDialog, short item, short diffWide, short diffHigh)
#endif
{
	Rect		iRect;
	short	iType;
	Handle	iHandle;

#ifdef TRAGET_API_MAC_CARBON
	GetDialogItem (theDialog, item, &iType, &iHandle, &iRect);
#else
	GetDialogItem (theDialog, item, &iType, &iHandle, &iRect);
#endif
	OffsetRect(&iRect, diffWide, diffHigh);
#ifdef TRAGET_API_MAC_CARBON
	SetDialogItem (theDialog, item, iType, iHandle, &iRect);
#else
	SetDialogItem (theDialog, item, iType, iHandle, &iRect);
#endif
	MoveControl((ControlHandle)iHandle, iRect.left, iRect.top);			
}

