
#define useMorFiles

#include	"applicationGlobals.h"

#ifdef TARGET_API_MAC_CARBON
#define	MY_DLOG(x)	DLG_DATA(theDialog,x)
#else
#define	MY_DLOG(x)	(((myDlgPeek)theDialog)->x)
#endif

#define	kAboutScrollbarAdjust	16
#define	iAboutText		128
#define	kDstRight		500
#define	kOverRange		-10
#define	kSlowScroll		10
#define	kFastScroll		30
#define	kCurUp		132
#define	kCurDown		133
#define	kCurStay		134

#define	kMoveAmountFast	24
#define	kMoveAmountSlow	12

void		getTERect(Rect *iRect,Rect *destRect,Rect *viewRect);
void 		doAmountToScrollBar(ControlHandle control, short *amount);
short	calcAmount(Rect *iRect, Point savedPt, Point localPt);
TEHandle 	setUpAboutDialog(DialogPtr theDialog);
void		doAboutTextScroll(DialogPtr theDialog, TEHandle hTE);
pascal void 	doVActionProc(ControlHandle control,short part);
void		saveAboutText(FSSpecPtr fileSpec);
void		showModelessAboutDLG(void);

#ifdef TARGET_API_MAC_CARBON
extern void setArrowCursor();
extern WindowDataPtr getWindowDataPtr(WindowRef winodw);
extern DialogDataPtr getDialogDataPtr(DialogRef dialog);
#endif


void	showModelessAboutDLG(void)
{
	DialogPtr		theDialog;

	theDialog = createMyDialog(rShowAbout);
#ifdef TARGET_API_MAC_CARBON
	ShowWindow(GetDialogWindow(theDialog));
	SelectWindow(GetDialogWindow(theDialog));
        setArrowCursor();
#else
	ShowWindow((WindowPtr)theDialog);
	SelectWindow((WindowPtr)theDialog);
	SetCursor(&qd.arrow);
#endif
}

void	doModelessAboutDLGEvent(DialogPtr theDialog, short theItem)
{
	Boolean	dialogDone = false;

	switch(theItem)
	{
		case	ok:
			dialogDone = true;
		break;
	}

	if(dialogDone){
		disposeMyDialog(theDialog);
	}
}

#pragma mark -

void	drawExplanationDLG(DialogPtr theDialog)
{
	short	iType;
	Handle	iHandle;
	Rect		iRect;
        
#ifdef TARGET_API_MAC_CARBON
        Rect portRect;
#endif

	DrawDialog(theDialog);
	GetDialogItem(theDialog,rAboutDialog_TextEdit,&iType,&iHandle,&iRect);	//TextEdit item
	FrameRect(&iRect);										//draw frame
#ifdef TARGET_API_MAC_CARBON
        GetPortBounds(GetDialogPort(theDialog), &portRect);
	TEUpdate(&portRect,MY_DLOG(hTE));
#else
	TEUpdate(&theDialog->portRect,MY_DLOG(hTE));
#endif
}


void	showModelessExplanationDLG(void)
{
	DialogPtr		theDialog;

	theDialog = createMyDialog(rModelessExplanationDialog);
        
#ifdef TARGET_API_MAC_CARBON
	ShowWindow(GetDialogWindow(theDialog));
	SetPortDialogPort(theDialog);
#else
	ShowWindow((WindowPtr)theDialog);
	SetPort((GrafPtr)theDialog);
#endif
	MY_DLOG(hTE) = setUpAboutDialog(theDialog);

#ifdef TARGET_API_MAC_CARBON
	SelectWindow(GetDialogWindow(theDialog));

        setArrowCursor();
#else
	SelectWindow((WindowPtr)theDialog);

	SetCursor(&qd.arrow);
#endif
}

void	doModelessExplanationDLGEvent(DialogPtr theDialog, short theItem)
{
	Boolean	dialogDone = false;
	GrafPtr	savePort;
#ifdef TARGET_API_MAC_CARBON
	OSErr		theErr = noErr;
        NavReplyRecord    theReply;
        NavDialogOptions dialogOptions;
#else
	StandardFileReply	reply;
#endif
	GetPort(&savePort);
        
#ifdef TARGET_API_MAC_CARBON
	SetPortDialogPort(theDialog);
#else
	SetPort((WindowPtr)theDialog);
#endif

	switch(theItem)
	{
		case	ok:
			dialogDone = true;
			break;
		case	rAboutDialog_TextEdit:
		case	rAboutDialog_VScroll:
			doAboutTextScroll(theDialog, MY_DLOG(hTE));
			break;
		case	rAboutDialog_Save:
#ifdef TARGET_API_MAC_CARBON
                        theReply.validRecord = false;
                        theErr = NavGetDefaultDialogOptions(&dialogOptions);
                        PLstrcpy((StringPtr)&dialogOptions.savedFileName, "\pRead Me");
                        theErr = NavPutFile(NULL, &theReply, &dialogOptions, NULL, kTeachTextType, kTeachTextReadOnly, NULL);        
                        if (theReply.validRecord && theErr == noErr)
                        {
                            FSSpec	finalFSSpec;	
                            AEDesc 	resultDesc;	
                            resultDesc.dataHandle = 0L;
                            
                            if ((theErr = AEGetNthDesc(&(theReply.selection),1,typeFSS,NULL,&resultDesc)) == noErr)
                            {
                                BlockMoveData(*resultDesc.dataHandle,&finalFSSpec,sizeof(FSSpec));
/*
                                if (theReply.replacing)
                                        theErr = FSpDelete(&finalFSSpec);
                                if (theErr == noErr)
                                {
                                    if ((theErr = FSpCreate(&finalFSSpec,kTeachTextType,kTeachTextReadOnly,smSystemScript)) == noErr)
                                    {
*/
                                        saveAboutText(&finalFSSpec);
/*
                                    }
                                }
*/
                                AEDisposeDesc(&resultDesc);
                            }
                        }
                        NavDisposeReply(&theReply);
#else
			StandardPutFile("\pFile Name:", "\pRead Me", &reply);
			if(reply.sfGood){
				saveAboutText(&reply.sfFile);
			}
#endif
		break;
		default:
		break;
	}

	SetPort(savePort);
	
	if(dialogDone){
		disposeMyDialog(theDialog);
	}
}

#pragma mark -

void		saveAboutText(FSSpecPtr fileSpecP)
{
	OSErr		iErr = noErr;
	FSSpec	fileSpec;
	Handle	hRsrc;
#ifdef TARGET_API_MAC_CARBON
	short		fRefNum = 0;
#else
	short		fRefNum;
#endif
	long		length;
	ResType 	rType;
	short		rID;
	Str255	rName;
	short	savedRefNum;

	savedRefNum = CurResFile();

	iErr = FSMakeFSSpec(fileSpecP->vRefNum, fileSpecP->parID,fileSpecP->name,&fileSpec);
	if(iErr==noErr){		//	if old file exist
		iErr = FSpDelete(&fileSpec);
		showOSError(fileSpecP->name,  errorFileManager, iErr, kNotFatal);
		if(iErr != noErr)
			return;
	}
	
	iErr = FSpCreate(&fileSpec, kTeachTextType, kTeachTextReadOnly,smSystemScript);
	showOSError(fileSpec.name,  errorFileManager, iErr, kFatal);

	//write text
	hRsrc = GetResource('TEXT',iAboutText);				//read TEXT resource
	iErr = ResError();
	if(iErr!=noErr)
		return;

	iErr = FSpOpenDF(&fileSpec,fsCurPerm,&fRefNum);	
	showOSError(fileSpec.name,  errorFileManager, iErr, kFatal);

	HLock(hRsrc);
	length = GetHandleSize(hRsrc);
	iErr = FSWrite(fRefNum, &length, *hRsrc);
	HUnlock(hRsrc);
	iErr = FSClose(fRefNum);
	showOSError(fileSpec.name,  errorFileManager, iErr, kFatal);

	iErr = FlushVol(nil,fileSpec.vRefNum);
	showOSError(fileSpec.name,  errorFileManager, iErr, kFatal);

	//write style

	hRsrc	= GetResource('styl',iAboutText);
	iErr = ResError();
	if(iErr!=noErr)
		return;

	GetResInfo(hRsrc,&rID,&rType,rName);
	DetachResource(hRsrc);
	
	FSpCreateResFile(&fileSpec,kTeachTextType,kTeachTextReadOnly,smSystemScript);
	showOSError(fileSpec.name,  errorResourceManager, ResError(), kFatal);

	fRefNum = FSpOpenResFile(&fileSpec,fsCurPerm);
	showOSError(fileSpec.name,  errorResourceManager, ResError(), kFatal);

	UseResFile(fRefNum);

	AddResource(hRsrc,rType,rID,rName);
	showOSError(fileSpec.name,  errorResourceManager, ResError(), kFatal);
	UpdateResFile(fRefNum);

	UseResFile(fRefNum);

	CloseResFile(fRefNum);
	showOSError(fileSpec.name,  errorResourceManager, ResError(), kFatal);
	
	iErr = FlushVol(nil,fileSpec.vRefNum);
	showOSError(fileSpec.name,  errorFileManager, iErr, kFatal);

}

#pragma mark -

short	calcAmount(Rect *iRect, Point savedPt, Point localPt)
{
	short	amount = 0;


	if(PtInRect(localPt,iRect)) {
		if(savedPt.v > localPt.v){
			if((savedPt.v - localPt.v) > kFastScroll)
				amount = kMoveAmountFast;
			else if((savedPt.v - localPt.v) > kSlowScroll)
				amount = kMoveAmountSlow;
		}else{
			if((localPt.v - savedPt.v) > kFastScroll)
				amount = -kMoveAmountFast;
			else if((localPt.v - savedPt.v) > kSlowScroll)
				amount = -kMoveAmountSlow;			
		}		
	}
	return(amount)	;
}

void doAmountToScrollBar(ControlHandle control, short *amount)
{
	short		value, max;
	
	value = GetControlValue(control);	/* get current value */
	max = GetControlMaximum(control);		/* and maximum value */
	*amount = value - *amount;
	if ( *amount < 0 )
		*amount = 0;
	else if ( *amount > max )
		*amount = max;
	SetControlValue(control, *amount);
	*amount = value - *amount;		/* calculate the real change */
}

pascal void doVActionProc(ControlHandle control,short part)
{
	short		amount;
	WindowPtr	window;
	TEHandle		hTE;
	TextStyle		theStyle;
	short		lineHeight,ascent;

	if ( part != 0 ) {				/* if it was actually in the control */
#ifdef TARGET_API_MAC_CARBON
		window = GetControlOwner(control);
                GetWindowProperty(window, 'SaMe', 'TEhl', sizeof(TEHandle), NULL, &hTE);
#else
		window = (*control)->contrlOwner;
		hTE = (TEHandle)GetWRefCon(window);
#endif
                
		TEGetStyle(0,&theStyle,&lineHeight,&ascent,hTE);
		switch ( part ) {
			case kControlUpButtonPart:						//inUpButton
			case kControlDownButtonPart:		/* one line */		//inDownButton
				amount = kMoveAmountSlow;
				break;
			case kControlPageUpPart:			/* one page */		//inPageUp
			case kControlPageDownPart:						//inPageDown
				amount = (*hTE)->viewRect.bottom - (*hTE)->viewRect.top;
				break;
		}
		if ( (part == kControlDownButtonPart) || (part == kControlPageDownPart) )
			amount = -amount;		/* reverse direction for a downer */
		doAmountToScrollBar(control, &amount);
		if ( amount != 0 )
			TEScroll(0, amount, hTE);
	}
}

void	getTERect(Rect *iRect,Rect *destRect,Rect *viewRect)
{
	*destRect = *iRect;
	InsetRect(destRect, 1, 1);								/* adjust for margin */
	destRect->left += 4;
	*viewRect = *destRect;
	viewRect->right = viewRect->right - kAboutScrollbarAdjust;		/* and for the scrollbars */
	destRect->right = kDstRight;
} 

TEHandle setUpAboutDialog(DialogPtr theDialog)
{
	short	iType;
	Handle	iHandle;
	Rect		iRect;
	OSErr	iErr;
	Rect		destRect, viewRect;
	TEHandle	hTE = nil;
	Handle	textH, stylH;
	long		length;
	short	max;


	textH = GetResource('TEXT',iAboutText);				//read TEXT resource
	iErr = ResError();
	if(iErr!=noErr)	{
		alertUser(eResErr);
	}else{
		length = GetHandleSize(textH);

		stylH = GetResource('styl',iAboutText);
		iErr = ResError();
		
		GetDialogItem(theDialog,rAboutDialog_TextEdit,&iType,&iHandle,&iRect);	//make style-aware TextEdit
		getTERect(&iRect,&destRect,&viewRect);
		hTE = (TEHandle)TEStyleNew(&destRect,&viewRect);		//TEStylNew
		if(hTE==nil){
			alertUser(eAppMemSmall);
		}else{	
			TEAutoView(true,hTE);
		
			if(iErr==noErr){
				HLock(textH);									//set Edit Text record
				TEStyleInsert(*textH,length,(StScrpHandle)stylH,hTE);	//TEStylInsert
				HUnlock(textH);
			}else{
				HLock(textH);									//set Edit Text record
				TESetText(*textH,length,hTE);
				HUnlock(textH);
			}
			TESetSelect(0,0,hTE);
			TEUpdate(&viewRect,hTE);
			
			HLock((Handle)hTE);								//set scroll bar
			GetDialogItem(theDialog,rAboutDialog_VScroll,&iType,&iHandle,&iRect);
			max = TEGetHeight((*hTE)->nLines,0, hTE) - ((*hTE)->viewRect.bottom - (*hTE)->viewRect.top) ;
			if ( max < 0 ) max = 0;
			SetControlMaximum((ControlHandle)iHandle, max);
			SetControlValue((ControlHandle)iHandle,0);
			HUnlock((Handle)hTE);

#ifdef TARGET_API_MAC_CARBON
                        SetWindowProperty(GetDialogWindow(theDialog), 'SaMe', 'TEhl', sizeof(TEHandle), &hTE);
#else
			SetWRefCon((WindowPtr)theDialog,(long)hTE);			//save TEHandle to Refcon
#endif
		
		}
	}
	return(hTE);
}

void	doAboutTextScroll(DialogPtr theDialog, TEHandle hTE)
{
	short	iType;
	Handle	iHandle;
	Rect		iRect;
	Point		localPt, savedPt;
	Rect		destRect;
	short	iCtlPart,iCtlValue;
	ControlHandle	whichCtl;
	ControlActionUPP upp;
	short	amount;
	short	cursNum;
	Cursor		cursRec;
	CursHandle	cursH;

	GetMouse(&localPt);
	iCtlPart = FindControl(localPt,GetDialogWindow(theDialog),&whichCtl);
	if(whichCtl != nil)
	{
		switch ( iCtlPart )
		{
			case 0:			/* do nothing for viewRect case */
				break;
			case kControlIndicatorPart:			//inThumb
				iCtlValue = GetControlValue(whichCtl);
				iCtlPart = TrackControl(whichCtl, localPt, nil);
				if ( iCtlPart != 0 )
				{
					iCtlValue -= GetControlValue(whichCtl);		//calculate difference of value
					if ( iCtlValue != 0 )
						TEScroll(0, iCtlValue, hTE);
				}
				break;
			default:			/*  clicked in an arrow, so track & scroll */
#ifdef TARGET_API_MAC_CARBON
				upp = NewControlActionUPP((ControlActionProcPtr)doVActionProc);
#else
				upp = NewControlActionProc(doVActionProc);
#endif
				iCtlValue = TrackControl(whichCtl, localPt, upp);
				DisposeRoutineDescriptor(upp);
				break;
		}
	}
	else
	{
		savedPt = localPt;
		GetDialogItem(theDialog,rAboutDialog_TextEdit,&iType,&iHandle,&iRect);	//make style-aware TextEdit
		destRect = iRect;
		InsetRect(&destRect,kOverRange,kOverRange);
		GetDialogItem(theDialog,rAboutDialog_VScroll,&iType,&iHandle,&iRect);		//make style-aware TextEdit

		while(Button()) 
		{
			GetMouse(&localPt);
			amount = calcAmount(&destRect, savedPt, localPt);
			doAmountToScrollBar((ControlHandle)iHandle, &amount);
			if ( amount != 0 )
			{
				TEScroll(0, amount, hTE);
				if(amount<0)
					cursNum = kCurDown;
				else
					cursNum = kCurUp;
			}
			else
				cursNum = kCurStay;
			cursH = GetCursor( cursNum );
			HLock ((Handle) cursH);
			cursRec = **cursH;				/* copy the data */
			HUnlock ((Handle) cursH);
			SetCursor( &cursRec );
		}
#ifdef TARGET_API_MAC_CARBON
                setArrowCursor();
#else
		SetCursor( &qd.arrow);
#endif
	}

}


/*
#define NewModalFilterProc(userRoutine)	
typedef pascal Boolean (*ModalFilterProcPtr)(DialogPtr theDialog, EventRecord *theEvent, short *itemHit);
typedef ModalFilterProcPtr ModalFilterUPP;
*/

