/**/
#include	"applicationGlobals.h"

#ifdef TARGET_API_MAC_CARBON
extern short	gAppRsrcFRefNum;	//application fRefNum
extern prefVal	gPrefVal;		//globals for pref
#endif

#define	rOpenDialogID		700
#define 	kPICTHeaderSize	512 
#define	kOrgPictSize		200
#define	kDummyPictSize	10

//Item of Custum Get File Dialog
#define		rCG_PictItem	10
#define		rCG_NameItem	11


typedef struct{
#ifdef TARGET_API_MAC_CARBON
//        NavReplyRecord		*reply;
#else
	StandardFileReply	*reply;
#endif
	FSSpec			prevSpec;
	PicHandle			thePicture;
	Boolean 			isGImporterAvailable;
}myFileData, *myFileDataPtr;


OSErr	loadPictFromFile(FSSpecPtr spec, PicHandle thePicture);
OSErr	fspDrawPicture(FSSpecPtr spec, Boolean isGImporterAvailable);
OSErr	fspGetPictureRect(FSSpecPtr spec, Rect *picRect, Boolean isGImporterAvailable);
OSErr	changeCharacterPict(PicHandle thePicture);

#ifdef TARGET_API_MAC_CARBON
pascal Boolean myFileFilterProc(AEDesc* theItem, void* info, NavCallBackUserData callBackUD, NavFilterModes filterMode);
#else
pascal	Boolean	myFileFilterProc(CInfoPBPtr pb, void *myDataPtr);
pascal 	short	myDialogHookProc(short theItem, DialogRef theDialog, void *myDataPtr);
pascal	Boolean	myModalFilterProc(DialogPtr theDialog, EventRecord *event, short *itemHit);
#endif

Boolean	equalFSSpec(FSSpecPtr specA, FSSpecPtr specB);

#ifdef TARGET_API_MAC_CARBON
extern WindowDataPtr getWindowDataPtr(WindowRef winodw);
extern DialogDataPtr getDialogDataPtr(DialogRef dialog);
#endif

Boolean	equalFSSpec(FSSpecPtr specA, FSSpecPtr specB)
{
	Boolean	result = true;

	if(specA->vRefNum != specB->vRefNum)
		result = false;
	if(specA->parID != specB->parID)
		result = false;
	if(!EqualString(specA->name, specB->name,false,false))
		result = false;
	
	return(result);
}

#pragma mark -

void	drawOnePiece(WindowPtr wp,short x,short y, unsigned char mapData)
{
/*	Attention !!!!!!
	LockPixels of  WIN_DATA(wp, charaPm) before call
	SetPort(wp)
*/
	Rect		srcRect, dstRect;
	RGBColor	saveColor;
	short	savePenMode;
	
	//destination rect
	mapXYToPieceRect(wp,  x,  y,  &dstRect);	

	switch(WIN_DATA(wp, charaType))
	{
		case	fSame:
			if((mapData & kMapCaraMask) == 0)		//now pos chara is not piece
			{
				GetForeColor(&saveColor);
				RGBForeColor(&(gPrefVal.defaultColor));
				PaintRect(&dstRect);
				RGBForeColor(&saveColor);
			}
			else
			{
				SetRect(&srcRect,0,0,GAME_VAL(wp, komaSize),GAME_VAL(wp, komaSize));
				OffsetRect(&srcRect, GAME_VAL(wp, komaSize)*((mapData & kMapUnCheck)-1),0);
				if((mapData & kMapChecked)!=0)
					OffsetRect(&srcRect, 0, GAME_VAL(wp, komaSize));
#ifdef TARGET_API_MAC_CARBON
				CopyBits((BitMap *)(*WIN_DATA(wp, charaPm)), GetPortBitMapForCopyBits(GetWindowPort(wp)), 
                                  &srcRect,&dstRect,srcCopy,nil);	
#else
				CopyBits((BitMap *)(*WIN_DATA(wp, charaPm)),&(wp->portBits),&srcRect,&dstRect,srcCopy,nil);	
#endif
			}		
		break;
		case	fSame2:
			SetRect(&srcRect,0,0,GAME_VAL(wp, komaSize),GAME_VAL(wp, komaSize));
			OffsetRect(&srcRect, GAME_VAL(wp, komaSize)*(mapData & kMapUnCheck),0);
			if((mapData & kMapChecked)!=0)
				OffsetRect(&srcRect, 0, GAME_VAL(wp, komaSize));
			else if(GAME_STATUS(wp, kGameEnd)&&(GAME_VAL(wp, remain) == 0))
				OffsetRect(&srcRect, 0, GAME_VAL(wp, komaSize));
#ifdef TARGET_API_MAC_CARBON
			CopyBits((BitMap *)(*WIN_DATA(wp, charaPm)), GetPortBitMapForCopyBits(GetWindowPort(wp)), 
                          &srcRect,&dstRect,srcCopy,nil);
#else			
			CopyBits((BitMap *)(*WIN_DATA(wp, charaPm)),&(wp->portBits),&srcRect,&dstRect,srcCopy,nil);
#endif
		break;
		case	fMaru:
			if((mapData & kMapCaraMask) == 0)
			{	//now pos chara is not piece
				GetForeColor(&saveColor);
				RGBForeColor(&(WIN_DATA(wp, backColor)));
				PaintRect(&dstRect);
				RGBForeColor(&saveColor);
			}
			else
			{	//set srcRect
				SetRect(&srcRect, 0, 0, GAME_VAL(wp, komaSize), GAME_VAL(wp, komaSize));
				OffsetRect(&srcRect,0,GAME_VAL(wp, komaSize)*2*((mapData & kMapUnCheck)-1));
				if((mapData & kMapUnCheck) == (MAP_DATA(wp, x, y+1)&kMapUnCheck))			
					OffsetRect(&srcRect,GAME_VAL(wp, komaSize),0);
				if((mapData & kMapUnCheck) == (MAP_DATA(wp, x+1, y)&kMapUnCheck))			
					OffsetRect(&srcRect,GAME_VAL(wp, komaSize)*2,0);
				if((mapData & kMapUnCheck) == (MAP_DATA(wp, x, y-1)&kMapUnCheck))			
					OffsetRect(&srcRect,GAME_VAL(wp, komaSize)*4,0);
				if((mapData & kMapUnCheck) == (MAP_DATA(wp, x-1, y)&kMapUnCheck))			
					OffsetRect(&srcRect,0,GAME_VAL(wp, komaSize));
				//copy it
#ifdef TARGET_API_MAC_CARBON
				CopyBits((BitMap *)(*WIN_DATA(wp, charaPm)), GetPortBitMapForCopyBits(GetWindowPort(wp)),
                                  &srcRect,&dstRect,srcCopy,nil);
#else
				CopyBits((BitMap *)(*WIN_DATA(wp, charaPm)),&(wp->portBits),&srcRect,&dstRect,srcCopy,nil);
#endif
				//frame piece when checked
				if((mapData & kMapChecked)!=0)
				{
#ifdef TARGET_API_MAC_CARBON
					savePenMode = GetPortPenMode(GetWindowPort(wp));
#else
					savePenMode = wp->pnMode;
#endif
					PenMode(patXor);
					FrameRect(&dstRect);
					PenMode(savePenMode);
				}
			}
		break;
	}
}

#pragma mark -

void	makeMaruCharacter(PixMapHandle myPM)
{	//**********************
	//attention!!
	//pixmap must lock before call
	//**********************

	short		i,j;
	long			*srcAddr;
	long			*dstAddr1;
	long			*dstAddr2;
	long			*dstAddr3;
	long			*dstAddr4;
	long			*srcBaseAddr;
	long			srcColor;
	SInt8		mmuMode;
	short		row, column;
	long			myColorFast[kNumOfColor][kNumOfKind];
	short		width;
	long			srcRowBytes;
	short		maxNum;

	// set the MMU to 32-bit mode 
	mmuMode = true32b;
 	SwapMMUMode ( &mmuMode);	
		
	// get the address of the pixmap
	srcBaseAddr = (long *) GetPixBaseAddr ( myPM );			
	width = (**myPM).bounds.right - (**myPM).bounds.left;
	srcRowBytes = (long)((**myPM).rowBytes & 0x3fff);			//row increment 

	//read color table
	srcAddr = srcBaseAddr;
	for(j=0;j<kNumOfColor;j++)
	{
		for(i=0;i<kNumOfKind;i++)
		{
			myColorFast[j][i] = *srcAddr;
			srcAddr++;
		}
	}

	//for(j=1;(j<kNumOfColor)&&(myColorFast[j][0]!=myColorFast[j-1][0]);j++)
	//	;
	maxNum = kNumOfColor;

	//move to next row
	srcBaseAddr = (long *) ( (char *) srcBaseAddr + srcRowBytes );
	for ( row = 0; row < kHeight; row++ ) 
	{
		srcAddr = srcBaseAddr;
		dstAddr1 = (long *) ( (char *) srcAddr  + (long)srcRowBytes*(long)kHeight );
		dstAddr2 = (long *) ( (char *) dstAddr1 + (long)srcRowBytes*(long)kHeight );
		dstAddr3 = (long *) ( (char *) dstAddr2 + (long)srcRowBytes*(long)kHeight );
		dstAddr4 = (long *) ( (char *) dstAddr3 + (long)srcRowBytes*(long)kHeight );
		for ( column = 0; column < width; column++ ) 
		{
			srcColor = *srcAddr;
			i=0;
			do
			{
				if(srcColor == myColorFast[i][0])					
					break;
				i++;
			}while(i<maxNum);

			if(i == maxNum)
			{
				*dstAddr1 = srcColor;
				*dstAddr2 = srcColor;
				*dstAddr3 = srcColor;
				*dstAddr4 = srcColor;
			}
			else
			{
				*dstAddr1 = myColorFast[i][1];
				*dstAddr2 = myColorFast[i][2];
				*dstAddr3 = myColorFast[i][3];
				*dstAddr4 = myColorFast[i][4];
			}
			srcAddr ++;	
			dstAddr1++;
			dstAddr2++;
			dstAddr3++;
			dstAddr4++;
		}
		srcBaseAddr = (long *) ( (char *) srcBaseAddr + srcRowBytes );
	}
 	// restore the previous MMU mode
 	SwapMMUMode ( &mmuMode );	
}


#pragma mark -

OSErr	loadPictFromFile(FSSpecPtr spec, PicHandle thePicture)
{
	short	refNum ; 
	long		fileSize, headerSize; 
	char		pictHeader[kPICTHeaderSize];
	OSErr	iErr = noErr;
	char		cMemTags;
	FInfo		fndrInfo;

	iErr = FSpGetFInfo(spec,&fndrInfo);
	if(fndrInfo.fdType != ftPICTFile)
		return(-1);					//not a picture

	iErr = FSpOpenDF(spec,fsRdPerm,&refNum);
	if(iErr == noErr)
	{
		iErr = GetEOF(refNum,&fileSize);
		if(iErr == noErr)
		{
			headerSize = kPICTHeaderSize; 
			iErr = FSRead(refNum,&headerSize,pictHeader);
			if(iErr == noErr)
			{
				fileSize -= kPICTHeaderSize;
				cMemTags = HGetState((Handle)thePicture);
				showOSError(nil,  errorMemoryManager, MemError(), kFatal);
				HUnlock((Handle)thePicture);
				showOSError(nil,  errorMemoryManager, MemError(), kFatal);
				SetHandleSize((Handle)thePicture,fileSize);
				iErr = MemError();
				if(iErr == noErr)
				{
					HLock((Handle)thePicture); 
					iErr = FSRead(refNum,&fileSize,*thePicture);
				}
				else
					showOSError(nil,  errorMemoryManager, iErr, kFatal);
				HSetState((Handle)thePicture,cMemTags);	
				showOSError(nil,  errorMemoryManager, MemError(), kFatal);
			}
		}
		FSClose(refNum);		
	}

	return(iErr);
}

OSErr	fspChangeCharacter(FSSpecPtr spec)
{
	PicHandle	thePicture;
	OSErr	iErr = noErr;

	thePicture = (PicHandle)NewHandle(kDummyPictSize);

	iErr = loadPictFromFile(spec, thePicture);
	if(iErr != noErr)
		return(-1);

	//check if the PICT data is suitable for Macigame
	if(getCharacterType(&((*thePicture)->picFrame)) == fError)
		return(-1);

	iErr = changeCharacterPict(thePicture);

	DisposeHandle((Handle)thePicture);
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);

	return(iErr);
}

OSErr	fspDrawPicture(FSSpecPtr spec, Boolean isGImporterAvailable)
{
	OSErr	iErr = noErr;
	PicHandle thePicture;
	
	if(isGImporterAvailable)
	{
	}
	else
	{
		thePicture = (PicHandle)NewHandle(kDummyPictSize);
		iErr = loadPictFromFile(spec,  thePicture);
		if(iErr == noErr)
			DrawPicture(thePicture,&((*thePicture)->picFrame));

		DisposeHandle((Handle)thePicture);
		showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	}

	return(iErr);
}

OSErr	fspGetPictureRect(FSSpecPtr spec, Rect *picRect, Boolean isGImporterAvailable)
{	//in: spec, isGImporterAvailable
	//out:picRect
	OSErr	iErr = noErr;
	PicHandle thePicture;
	
	if(isGImporterAvailable)
	{
	}
	else
	{
		thePicture = (PicHandle)NewHandle(kDummyPictSize);
		iErr = loadPictFromFile(spec,  thePicture);
		if(iErr == noErr)
			*picRect = (*thePicture)->picFrame;
		DisposeHandle((Handle)thePicture);
		showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	}

	return(iErr);
}

short	getCharacterType(Rect *picRect)
{
	short	theType = fError;
	short	height, width;

	height = picRect->bottom - picRect->top;
	width = picRect->right - picRect->left;

	if((height == kSameV)&&(width == kSameH))
		theType = fSame;
	else if((height == kSame2V)&&(width == kSame2H))
		theType = fSame2;
	else if((height == kMaruV)&&(width == kMaruH))
		theType = fMaru;

	return(theType);
}

#pragma mark -

#ifndef TARGET_API_MAC_CARBON
pascal short	myDialogHookProc(short theItem, DialogRef theDialog, void *myDataPtr)
{
	OSErr		iErr = noErr ;
	myFileData	myData;
	Boolean		drawIt = true;
	Rect			picRect;
	short		iType;
	Handle		iHandle;
	Rect			iRect;
	GrafPtr		savePort;

	myData = *(myFileData*)myDataPtr;
        
	if(equalFSSpec(&(myData.prevSpec), &(myData.reply->sfFile)))
		drawIt = false;

	if(drawIt)
	{
		GetPort(&savePort);
		SetPort(theDialog);
		GetDialogItem ( theDialog, rCG_PictItem, &iType, &iHandle, &iRect) ;		//GetDItem
		iErr = fspGetPictureRect(&(myData.reply->sfFile), &picRect, myData.isGImporterAvailable);
		if(iErr == noErr)
		{
			EraseRect(&iRect);
			OffsetRect(&picRect,iRect.left-picRect.left,iRect.top-picRect.top);
			loadPictFromFile(&(myData.reply->sfFile), myData.thePicture);
			SetDialogItem(theDialog,rCG_PictItem,iType,(Handle)myData.thePicture,&picRect);
                        
			InvalRect(&picRect);
			//DrawDialog(theDialog);
		}
		else
			EraseRect(&iRect);
		//save displayd file FSSpec
		((myFileData*)myDataPtr)->prevSpec = ((myFileData*)myDataPtr)->reply->sfFile;

		SetPort(savePort);

	}
	return(theItem) ;
}
#endif

#ifdef TARGET_API_MAC_CARBON
pascal Boolean myFileFilterProc(AEDesc* theItem, void* info, NavCallBackUserData callBackUD, NavFilterModes filterMode)
{
	OSErr		theErr = noErr;
//	FSSpec		finalFSSpec;
	Boolean		filterIt = FALSE;
        myFileData	*myDataPtr;
	Rect			picRect;
	short		charaType = fError;
	NavFileOrFolderInfo* theInfo = (NavFileOrFolderInfo*)info;
        
	myDataPtr = (myFileData*)callBackUD;

	if ( theItem->descriptorType == typeFSS )
        {
            if ( theInfo->isFolder )
            {
                 filterIt = TRUE;
            } else {
                if (theInfo->fileAndFolder.fileInfo.finderInfo.fdType == ftPICTFile)
                {
                    FSSpec	fileSpec;
                    if ((theErr = AEGetDescData ( theItem, &fileSpec, sizeof ( FSSpec ) )) == noErr)
                    {
                        if((theErr = fspGetPictureRect(&fileSpec, &picRect, myDataPtr->isGImporterAvailable)) == noErr)
                        {
                            if((charaType = getCharacterType(&picRect)) != fError)
                                filterIt = TRUE;
                        }
                    }
                }
            }
	}
	return filterIt;
}
#else
pascal	Boolean	myFileFilterProc(CInfoPBPtr pb, void *myDataPtr)
{
	OSErr		iErr = noErr;
	FSSpec		fileSpec;
	Boolean		filterIt = TRUE;
	Rect			picRect;
	myFileData	myData;
	short		charaType = fError;

	myData = *(myFileData*)myDataPtr;

	iErr = FSMakeFSSpec(pb->hFileInfo.ioVRefNum, pb->hFileInfo.ioFlParID,
			  pb->hFileInfo.ioNamePtr, &fileSpec);
	if(iErr != noErr)
		return(filterIt);		//don't display

	if(((pb->hFileInfo.ioFlAttrib >> 4) & 0x01) == 1)		// found a directory -> do nothing
	{
		filterIt = FALSE;
	}
	else
	{
		if(pb->hFileInfo.ioFlFndrInfo.fdType == ftPICTFile)
		{
			iErr = fspGetPictureRect(&fileSpec, &picRect, myData.isGImporterAvailable);
			if(iErr == noErr)
			{
				charaType = getCharacterType(&picRect);
				if(charaType != fError)
					filterIt = FALSE;
			}
		}
	}
	
	return(filterIt);
}
#endif

#ifndef TARGET_API_MAC_CARBON
pascal Boolean myModalFilterProc(DialogPtr theDialog, EventRecord *event, short *itemHit)
{

	ModalFilterUPP 		theProc ;
	Boolean				retVal ;

	static	Boolean		isDisabled = false ;
	OSErr				iErr = noErr ;


	// get the std filter proc
	
	iErr = GetStdFilterProc( &theProc ) ;
	
	if( iErr != noErr )
		ExitToShell() ;
		
	// try to call the standard filter, if it handles the event, we don't
	if( !(retVal = CallModalFilterProc(theProc, theDialog, event, itemHit)) )
	{
		switch (event->what) 
		{
	
			case nullEvent:
				break;
	
			case keyDown:
			case autoKey:
				retVal = false;
				break ;
	
			case updateEvt:
				// get the text item we are drawing in
/*				GetDialogItem ( dlg, kUserTextArea, &iKind, &iHandle, &iRect) ;
				GetDialogItemText ( iHandle, theItem );
				isDisabled = theItem[0] == '\0' ;
				
				// enable or disable the OK button depending on whether 
				// we made a selection yet
				GetDialogItem(  dlg, ok, &iKind, &iHandle, &iRect) ;
				if( isDisabled )
					HiliteControl( (ControlHandle)iHandle, 255 ) ;
				else
					HiliteControl( (ControlHandle)iHandle, 0 ) ;
*/			
				retVal = false;
				break ;
	
			default:
				retVal = false;
				break ;
		}
	}

	return retVal ;
}
#endif

Boolean	openCustumCharacter(void)
{	//return true if Koma OK
#ifdef TARGET_API_MAC_CARBON
	Boolean		result = false;

	OSErr		theErr = noErr;
        NavReplyRecord    theReply;
        NavDialogOptions dialogOptions;
	myFileData	myData;
	OSErr		iErr = noErr;
	NavObjectFilterUPP	filterUPP = NewNavObjectFilterUPP(myFileFilterProc);

	myData.isGImporterAvailable = false;
	myData.thePicture = (PicHandle)NewHandle(kDummyPictSize);

	theReply.validRecord = false;
        theErr = NavGetDefaultDialogOptions(&dialogOptions);

	theErr = NavGetFile(NULL,	// use system's default location
				&theReply,
				&dialogOptions,
				NULL,
				NULL,
				filterUPP,
				NULL,
				(NavCallBackUserData)&myData);

	DisposeNavObjectFilterUPP(filterUPP);
 
        if (theReply.validRecord && theErr == noErr)
        {
            AEDesc 	resultDesc;
            resultDesc.dataHandle = 0L;
                            
            if ((theErr = AEGetNthDesc(&(theReply.selection),1,typeFSS,NULL,&resultDesc)) == noErr)
            {
                FSSpec	fileSpec;
                
                if ((theErr = AEGetDescData ( &resultDesc, &fileSpec, sizeof ( FSSpec ) )) == noErr)
                {
                    loadPictFromFile(&fileSpec, myData.thePicture);
                    if ((iErr = changeCharacterPict(myData.thePicture)) == noErr)
                        result = true;
                }
                 AEDisposeDesc(&resultDesc);
            }
	}
	NavDisposeReply(&theReply);

	DisposeHandle((Handle)myData.thePicture);
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);

#else
	FileFilterYDUPP		myFileFilterUPP = nil;
	DlgHookYDUPP		myDialogHookUPP = nil;
	Point			thePoint = {-1,-1};
	myFileData	myData;
	StandardFileReply 	reply;

	short		numTypes;
	Boolean		result = false;
	SFTypeList	typeList;
	OSErr		iErr = noErr;

	reply.sfGood = false;
	myData.reply = &reply;
	myData.isGImporterAvailable = false;
	myData.thePicture = (PicHandle)NewHandle(kDummyPictSize);

	numTypes = -1; 

	myFileFilterUPP 	= NewFileFilterYDProc(myFileFilterProc);
	myDialogHookUPP	= NewDlgHookYDProc(myDialogHookProc);

	if ((myFileFilterUPP != nil) && (myDialogHookUPP != nil)) 
	{
		CustomGetFile(myFileFilterUPP, numTypes, typeList,&reply, rOpenDialogID, thePoint,
			myDialogHookUPP, nil, nil,nil,&myData) ;

		DisposeRoutineDescriptor(myFileFilterUPP);
		DisposeRoutineDescriptor(myDialogHookUPP);
	}
	
	if(reply.sfGood)
	{			
		iErr = changeCharacterPict(myData.thePicture);
		if(iErr == noErr)
			result = true;
	}

	DisposeHandle((Handle)myData.thePicture);
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
#endif

	return(result);
}

void		setDefaultPicture(void)
{
	short	savedRefNum;
	PicHandle	hPic;
	OSErr		iErr = noErr;

	savedRefNum = CurResFile();

	UseResFile(gAppRsrcFRefNum);
	hPic = (PicHandle)Get1Resource(ftPICTFile,kKomaPICT);
	if(hPic != nil)
	{
		//save PICT	
		iErr = changeCharacterPict(hPic);		
	}
	UseResFile(savedRefNum);
}

OSErr	changeCharacterPict(PicHandle thePicture)
{
	WindowPtr	theWindow;
	OSErr		iErr = noErr;

#ifdef TARGET_API_MAC_CARBON	
        RgnHandle visRgn;
#endif
	
	if(thePicture == nil)
		return(-1);	

	theWindow = findMyWindow();
	if(theWindow == nil)
		return(-1);

	iErr = savePICT2Pref(thePicture);
	if(iErr == noErr)
	{
		drawCharaPICTtoGWorld(theWindow, thePicture);
#ifdef TARGET_API_MAC_CARBON	
                visRgn = NewRgn();
                GetPortVisibleRegion(GetWindowPort(theWindow), visRgn);
                InvalWindowRgn(theWindow, visRgn);
#else
		InvalRgn(theWindow->visRgn);
#endif
	}
	return(iErr);
}
