/*	doGameEnding	*/
#include	"applicationGlobals.h"

#ifdef TARGET_API_MAC_CARBON
extern short	gAppRsrcFRefNum;	//application fRefNum
extern prefVal	gPrefVal;				//globals for pref
#endif

typedef struct{
	Rect		itemRect;
	short	textHeight;
	short	textLineBase;
}textDraw, *textDrawPtr;

void		selectTextItemRight (DialogPtr theDialog, short item);
void		getPopUpSelectText(DialogPtr theDialog, short theItem, Str255 theString);
void		addNewHiName(Str255 newName);
void		getRanking(WindowPtr theWindow, unsigned long score, long remain, short *theRankScore, short *theRankRemain);
void		addNameToScore(short gameID, unsigned long score, long remain, Str255 name);
void		moveToLeftJustify(short theRank, short posIndex, textDraw *td);
void		moveToRightJustify(short theRank, short posIndex, Str255 theString, textDraw *td);
short	getHiScoreNamePopUpItemID(MenuHandle hMenu,  Str255 theString);

void		addBonus(WindowPtr wp);
MenuHandle	makePopUpMenu4HiscoreDialog(void);


#ifdef TARGET_API_MAC_CARBON
extern WindowDataPtr getWindowDataPtr(WindowRef winodw);
extern DialogDataPtr getDialogDataPtr(DialogRef dialog);
#endif

Boolean	isGameEnding(WindowPtr wp)
{	//check if there is 
	Boolean result = true;
	long		x,y;
	unsigned char	c;

	//
	//check if the neighboring piece is the same
	//
	for(y = 1;(y<=GAME_VAL(wp,mapY))&&result;y++)
	{
		for(x = 1;(x<=GAME_VAL(wp,mapX))&&result;x++)
		{
			c = MAP_DATA(wp, x, y);

			if((c & kMapCaraMask) != 0)	//now pos is piece
			{
				if(c == MAP_DATA(wp, x,y+1))
					result = false;
				else if(c == MAP_DATA(wp, x+1,y))
					result = false;
				else if(c == MAP_DATA(wp, x, y-1))
					result = false;
				else if(c == MAP_DATA(wp, x-1, y))
					result = false;
			}
		}
	}
	
	//
	//when map cleared at tumegame
	//
	if(result && GAME_VAL(wp, gameID)==rTume)
	{	
		result = tumeNextStage(wp);		//true: game is end
	}

	return(result);
}

void	doGameEnding(WindowPtr wp)
{
	long		cCount[6];
	DialogPtr	theDialog = nil;
	short	theRankScore, theRankRemain;
	unsigned long	secs;

#ifdef TARGET_API_MAC_CARBON	
        RgnHandle visRgn;
#endif

	setMyCursor(kArrowCURS);						//arrow cursor
	GAME_VAL(wp, gameStatus) |= kGameEnd;			//set game end flag
	GAME_VAL(wp, canGameUndo) = false;				//clear undo flag
	GAME_VAL(wp, remain) = countCharactors(wp, cCount);	//count remain pieces	
	//calculate bonus, get ranking
	addBonus(wp);
	getRanking(wp,  GAME_VAL(wp, score), GAME_VAL(wp, remain), &theRankScore, &theRankRemain);
	//show perfect wall paper
	if(GAME_VAL(wp, remain) == 0)
	{
		waitSeconds(1);
		drawAllCharactersOnWindow(wp);
	}
	showGameEndComment(wp);	//show 'game end' or 'perfect'
	waitSeconds(2);
	//	
	if((theRankScore != 0)||(theRankRemain != 0))
	{
		getHiScoreName(wp, GAME_VAL(wp, remain));			//get gVal.hiScoreName
		addNameToScore(GAME_VAL(wp, gameID), GAME_VAL(wp, score), GAME_VAL(wp, remain), gPrefVal.hiScoreName);
		readHiScoreDataToWindowRec(GAME_VAL(wp, gameID), wp);
		//
		theDialog = showMyDialog(rHiScoreDialog);
#ifdef TARGET_API_MAC_CARBON
		SetPortDialogPort(theDialog);
                visRgn = NewRgn();
                GetPortVisibleRegion(GetDialogPort(theDialog), visRgn);
                InvalWindowRgn(GetDialogWindow(theDialog), visRgn);
#else
		SetPort(theDialog);
		InvalRgn(theDialog->visRgn);
#endif
		DLG_DATA(theDialog, rankID) = GAME_VAL(wp, gameID);
		DLG_DATA(theDialog, rankScore) = theRankScore;
		DLG_DATA(theDialog, rankRemain) = theRankRemain;
		//set pop up menu
		SetControlValue (getCtlHandle(theDialog, rHiScoreDialog_PopUp), gameID2MenuID(GAME_VAL(wp, gameID)));

		//read hi-score data
		readHiScoreDataToDialogRec(GAME_VAL(wp, gameID),  theDialog);
#ifdef TARGET_API_MAC_CARBON
		SelectWindow(GetDialogWindow(theDialog));
#else
		SelectWindow(theDialog);
#endif
	}

	//*******************************
	//	get now time sec for monkey mode
	//	doMonkeyMode() is called in doNullEvent()
	//*******************************
	GetDateTime(&secs);
	WIN_DATA(wp, gameEndSecs) = secs;

}

#pragma mark -

void		showHiScoreDialog(void)
{
	DialogPtr		theDialog = nil;
	WindowPtr	theWindow = nil;
        
#ifdef TARGET_API_MAC_CARBON	
        RgnHandle visRgn;
#endif

	theDialog  = findDialog(rHiScoreDialog);
	if(theDialog==nil)
	{
		theDialog = createMyDialog(rHiScoreDialog);
		//set popup menu
		theWindow = findMyWindow();
		if(theWindow != nil)
		{
			SetControlValue (getCtlHandle(theDialog, rHiScoreDialog_PopUp), gameID2MenuID(GAME_VAL(theWindow, gameID)));
			readHiScoreDataToDialogRec(GAME_VAL(theWindow, gameID),  theDialog);
		}
	}
	//
#ifdef TARGET_API_MAC_CARBON
	SelectWindow(GetDialogWindow(theDialog));
	SetPortDialogPort(theDialog);
        visRgn = NewRgn();
        GetPortVisibleRegion(GetDialogPort(theDialog), visRgn);
        InvalWindowRgn(GetDialogWindow(theDialog), visRgn);
#else
	SelectWindow(theDialog);
	SetPort(theDialog);
	InvalRgn(theDialog->visRgn);
#endif
}

void	doHiScoreDLGEvent(DialogPtr theDialog, short itemHit)
{
	GrafPtr	savedPort;
	short	gameID;

#ifdef TARGET_API_MAC_CARBON	
        RgnHandle visRgn;
#endif
	
	GetPort (&savedPort);
#ifdef TARGET_API_MAC_CARBON
	SetPortDialogPort (theDialog);
#else
	SetPort (theDialog);
#endif

	switch ( itemHit )
	{
		case ok:
		break;
		case rHiScoreDialog_PopUp:
			gameID = menuID2GameID(GetControlValue(getCtlHandle(theDialog, rHiScoreDialog_PopUp)));
			readHiScoreDataToDialogRec(gameID,  theDialog);
#ifdef TARGET_API_MAC_CARBON
                        visRgn = NewRgn();
                        GetPortVisibleRegion(GetDialogPort(theDialog), visRgn);
                        InvalWindowRgn(GetDialogWindow(theDialog), visRgn);
#else
			InvalRgn(theDialog->visRgn);
#endif
			//drawHiScoreDialog(theDialog);
		break;
	}

	SetPort (savedPort);

	if(itemHit == ok)
		disposeMyDialog(theDialog);

}

void	moveToRightJustify(short theRank, short posIndex, Str255 pStr, textDraw *td)
{	//read position from resource and fit the string
	Str255	theString;
	long		theNum;
	short	theSNum;
	short	iWidth;
	
	GetIndString(theString,hiScoreStr,posIndex);
	StringToNum(theString, &theNum);
	theSNum = (short)theNum;

	iWidth = StringWidth(pStr);

	MoveTo(td->itemRect.left + theSNum - iWidth, td->itemRect.top+td->textHeight*(theRank-1)+td->textLineBase);
}

void	moveToLeftJustify(short theRank, short posIndex, textDraw *td)
{	//read position from resource and fit the string
	Str255	theString;
	long		theNum;
	short	theSNum;
	
	GetIndString(theString,hiScoreStr,posIndex);
	StringToNum(theString, &theNum);
	theSNum = (short)theNum;
	MoveTo(td->itemRect.left + theSNum, td->itemRect.top+td->textHeight*(theRank-1)+td->textLineBase);
}

void	readHiScoreDataToDialogRec(short gameID, DialogPtr theDialog)
{
	short	fRefNum;

	fRefNum = openPreferenceFile();
	if(fRefNum != kResFileNotOpened)
	{
		DisposeHandle(DLG_DATA(theDialog, hiscoreData));
		showOSError(nil,  errorMemoryManager, MemError(), kFatal);
		DLG_DATA(theDialog, hiscoreData) = getHiScore(gameID, kRankScoreType);
		DetachResource(DLG_DATA(theDialog, hiscoreData));
		showOSError(nil,  errorResourceManager, ResError(), kFatal);
		//
		DisposeHandle(DLG_DATA(theDialog, hiscoreRemain));
		showOSError(nil,  errorMemoryManager, MemError(), kFatal);
		DLG_DATA(theDialog, hiscoreRemain) = getHiScore(gameID, kRankRemainType);
		DetachResource(DLG_DATA(theDialog, hiscoreRemain));
		showOSError(nil,  errorResourceManager, ResError(), kFatal);
		//
		closePreferences(fRefNum);
	}

}


void	drawHiScoreDialog(DialogPtr theDialog)
{
#ifndef TARGET_API_MAC_CARBON
	OSErr	iErr = noErr;
#endif
	char		cMemTags;
	short	i;
	GrafPtr	savedPort;
	short	gameID;
	Rect		iRect;
	short	iType;
	Handle	iHandle;
	Str255	theString;
	long		theNum;
	textDraw	td;

	//set port
	GetPort (&savedPort);
        
#ifdef TARGET_API_MAC_CARBON
	SetPortDialogPort (theDialog);
#else
	SetPort (theDialog);
#endif
	//if gameID is current game, then color the data
	gameID = menuID2GameID(GetControlValue(getCtlHandle(theDialog, rHiScoreDialog_PopUp)));
	//read Text Size, Line Height
	GetIndString(theString,hiScoreStr,hiScoreStr_DispLineHeight);
	StringToNum(theString, &theNum);
	td.textHeight = (short)theNum;							//text height
	GetIndString(theString,hiScoreStr,hiScoreStr_DispTextSize);
	StringToNum(theString, &theNum);
	td.textLineBase = (short)theNum;						//text line base
	//***************************************
	//draw Score
	//***************************************
	GetDialogItem (theDialog, rHiScoreDialog_Score, &iType, &iHandle, &iRect);	
	EraseRect(&iRect);
	FrameRect(&iRect);
	td.itemRect = iRect;
	//open pre existing rsrc
	cMemTags = HGetState(DLG_DATA(theDialog, hiscoreData));
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	HLock(DLG_DATA(theDialog, hiscoreData));
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	//read data and draw
	for(i=1; i<=kRankMax;i++)
	{
		//set color of now ranking
		if((gameID == DLG_DATA(theDialog, rankID))&&(DLG_DATA(theDialog, rankScore) == i))
			ForeColor(blueColor);
		else
			ForeColor(blackColor);
		//rank
		NumToString(i, theString);
		moveToRightJustify(i, hiScoreStr_ScoreA_Rank, theString, &td);
		DrawString(theString);
		//score
		theNum = (long)SCORE_VAL(DLG_DATA(theDialog, hiscoreData), i, score);
		if(theNum == 0)
			GetIndString(theString,hiScoreStr,hiScoreStr_BlankText);	//blank string '---'
		else
			NumToString(theNum, theString);
		moveToRightJustify(i, hiScoreStr_ScoreA_Score, theString, &td);
		DrawString(theString);
		//name
		moveToLeftJustify(i, hiScoreStr_ScoreA_Name, &td);
		copyString(theString, SCORE_VAL(DLG_DATA(theDialog, hiscoreData), i, name));
		if(theString[0] == 0)
			GetIndString(theString,hiScoreStr,hiScoreStr_BlankText);
		DrawString(theString);
		//date
		if(SCORE_VAL(DLG_DATA(theDialog, hiscoreData), i, dateSecs) == 0)
			GetIndString(theString,hiScoreStr,hiScoreStr_BlankText);
		else
#ifdef TARGET_API_MAC_CARBON
			DateString((long)SCORE_VAL(DLG_DATA(theDialog, hiscoreData), i, dateSecs),shortDate,theString,GetIntlResource(0));		//IUGetIntl
#else
			IUDatePString((long)SCORE_VAL(DLG_DATA(theDialog, hiscoreData), i, dateSecs),shortDate,theString,GetIntlResource(0));		//IUGetIntl
#endif
		moveToLeftJustify(i, hiScoreStr_ScoreA_Date, &td);
		DrawString(theString);
	}
	HSetState(DLG_DATA(theDialog, hiscoreData),cMemTags);
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	ForeColor(blackColor);
	//***************************************
	//draw remain
	//***************************************
	GetDialogItem (theDialog, rHiScoreDialog_Remain, &iType, &iHandle, &iRect);	
	EraseRect(&iRect);
	FrameRect(&iRect);
	td.itemRect = iRect;
	//open pre existing rsrc
	cMemTags = HGetState(DLG_DATA(theDialog, hiscoreRemain));
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	HLock(DLG_DATA(theDialog, hiscoreRemain));
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	//read data and draw
	for(i=1; i<=kRankMax;i++)
	{
		//
		if((gameID == DLG_DATA(theDialog, rankID))&&(DLG_DATA(theDialog, rankRemain) == i))
			ForeColor(blueColor);
		else
			ForeColor(blackColor);
		//rank
		NumToString(i, theString);
		moveToRightJustify(i, hiScoreStr_ScoreA_Rank, theString, &td);
		DrawString(theString);
		//remain
		theNum = SCORE_VAL(DLG_DATA(theDialog, hiscoreRemain), i, remain);
		if(theNum == kRemainMax)
			GetIndString(theString,hiScoreStr,hiScoreStr_BlankText);
		else
			NumToString(theNum, theString);
		moveToRightJustify(i, hiScoreStr_ScoreB_Remain, theString, &td);
		DrawString(theString);
		//name
		moveToLeftJustify(i, hiScoreStr_ScoreB_Name, &td);
		copyString(theString, SCORE_VAL(DLG_DATA(theDialog, hiscoreRemain), i, name));
		if(theString[0] == 0)
			GetIndString(theString,hiScoreStr,hiScoreStr_BlankText);
		DrawString(theString);
		//date
		if(SCORE_VAL(DLG_DATA(theDialog, hiscoreRemain), i, dateSecs) == 0)
			GetIndString(theString,hiScoreStr,hiScoreStr_BlankText);
		else
#ifdef TARGET_API_MAC_CARBON
			DateString((long)SCORE_VAL(DLG_DATA(theDialog, hiscoreRemain), i, dateSecs),shortDate,theString,GetIntlResource(0));		//IUGetIntl
#else
			IUDatePString((long)SCORE_VAL(DLG_DATA(theDialog, hiscoreRemain), i, dateSecs),shortDate,theString,GetIntlResource(0));		//IUGetIntl
#endif
		moveToLeftJustify(i, hiScoreStr_ScoreB_Date, &td);
		DrawString(theString);
	}
	HSetState(DLG_DATA(theDialog, hiscoreRemain),cMemTags);
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	ForeColor(blackColor);

	SetPort (savedPort);

}


#pragma mark -

void		addNameToScore(short gameID, unsigned long score, long remain, Str255 name)
{
#ifndef TARGET_API_MAC_CARBON
	OSErr	iErr = noErr;
#endif
	short	savedRefNum;
	scoreVal	nowScore, scoreA, scoreB;
	Handle	scoreH;
	char		cMemTags;
	short	i;
	short	fRefNum;

	savedRefNum = CurResFile();
	fRefNum = openPreferenceFile();
	if(fRefNum == kResFileNotOpened)
		return;

	UseResFile(fRefNum);
	showOSError(nil,  errorResourceManager, ResError(), kFatal);
	//make now score data
	nowScore.score = score;
	nowScore.remain = remain;
	GetDateTime(&nowScore.dateSecs);
	copyString(nowScore.name, name);
	nowScore.checkSum = (unsigned short)(HiWord(nowScore.score) + LoWord(nowScore.score) 
				+  HiWord(nowScore.dateSecs) + LoWord(nowScore.dateSecs)
				+  HiWord(nowScore.reserved1) + LoWord(nowScore.reserved1)
				+  HiWord(nowScore.reserved2) + LoWord(nowScore.reserved2)
				+  HiWord(nowScore.remain) + LoWord(nowScore.remain));
	//
	//open pre existing Score rsrc
	//
	scoreH = getHiScore(gameID, kRankScoreType);
	cMemTags = HGetState(scoreH);
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	HLock(scoreH);	
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	//compare to data
	scoreA = nowScore;
	for(i=1; i<=kRankMax;i++)
	{
		if(scoreA.score > SCORE_VAL(scoreH, i, score))
		{
			scoreB = *((scoreValPtr)(*scoreH + (i-1)*sizeof(scoreVal)));
			*((scoreValPtr)(*scoreH + (i-1)*sizeof(scoreVal))) = scoreA;
			scoreA = scoreB;
		}
	}
	HSetState(scoreH,cMemTags);
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	//make handle rsrc
	ChangedResource(scoreH);
	showOSError(nil,  errorResourceManager, ResError(), kFatal);
	//
	//open pre existing remain rsrc
	//
	scoreH = getHiScore(gameID, kRankRemainType);
	cMemTags = HGetState(scoreH);
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	HLock(scoreH);	
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	//compare to data
	scoreA = nowScore;
	for(i=1; i<=kRankMax;i++)
	{
		if(scoreA.remain < SCORE_VAL(scoreH, i, remain))
		{
			scoreB = *((scoreValPtr)(*scoreH + (i-1)*sizeof(scoreVal)));
			*((scoreValPtr)(*scoreH + (i-1)*sizeof(scoreVal))) = scoreA;
			scoreA = scoreB;
		}
	}
	HSetState(scoreH,cMemTags);
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	//make handle rsrc
	ChangedResource(scoreH);
	showOSError(nil,  errorResourceManager, ResError(), kFatal);
	//update pref file
	UpdateResFile(fRefNum);
	showOSError(nil,  errorResourceManager, ResError(), kFatal);
	//
	UseResFile(savedRefNum);
	closePreferences(fRefNum);
}



void	checkAimHiScoreAvail(void)
{
	long		topScore;

	topScore = getTopScore(rSame);

	if(topScore > kAimHSAvail3)
		gPrefVal.aimHSAvail = kAimHSLv3;
	else if(topScore > kAimHSAvail2)
		gPrefVal.aimHSAvail = kAimHSLv2;
	else if(topScore > kAimHSAvail1)
		gPrefVal.aimHSAvail = kAimHSLv1;
	else
		gPrefVal.aimHSAvail = kAimHSLv0;
		
}

long	getTopScore(short gameID)
{
	Handle	scoreH;
	long		topScore;
	short	savedRefNum, fRefNum;

	savedRefNum = CurResFile();
	fRefNum = openPreferenceFile();

	scoreH = getHiScore(gameID, kRankScoreType);
	topScore = (long)SCORE_VAL(scoreH, 1, score);

	UseResFile(savedRefNum);
	closePreferences(fRefNum);
	
	return(topScore);
}

void	getRanking(WindowPtr theWindow,  unsigned long score, long remain, short *theRankScore, short *theRankRemain)
{
	short	i;
	Handle	scoreH;
	char		cMemTags;

	*theRankScore = 0;
	*theRankRemain = 0;
	//get score ranking
	scoreH = WIN_DATA(theWindow, hiscoreData);
	cMemTags = HGetState(scoreH);
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	HLock(scoreH);	
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	for(i=1; (i<=kRankMax)&&(*theRankScore == 0);i++)
	{
		if(score > SCORE_VAL(scoreH, i, score))
			*theRankScore = i;
	}
	HSetState(scoreH,cMemTags);
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	//get remain ranking
	scoreH = WIN_DATA(theWindow, hiscoreRemain);
	cMemTags = HGetState(scoreH);
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	HLock(scoreH);	
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	for(i=1; (i<=kRankMax)&&(*theRankRemain == 0);i++)
	{
		if(remain < SCORE_VAL(scoreH, i, remain))
			*theRankRemain = i;
	}
	HSetState(scoreH,cMemTags);
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);

}

void	addBonus(WindowPtr wp)
{
	switch(GAME_VAL(wp, gameID))
	{
		case	rSame:
			if(GAME_VAL(wp, remain) == 0)
				GAME_VAL(wp, bonus) = 1000;			//perfect bonus
			else if(GAME_VAL(wp, remain)<100)
				GAME_VAL(wp, bonus) = (unsigned long)(100 - GAME_VAL(wp, remain));
			else
				GAME_VAL(wp, bonus) = 0;
		break;
		case	rMame:
			if(GAME_VAL(wp, remain) == 0)
				GAME_VAL(wp, bonus) = 10000;		//perfect bonus
			else if(GAME_VAL(wp, remain)<100)
				GAME_VAL(wp, bonus) = (unsigned long)(100 - GAME_VAL(wp, remain));
			else
				GAME_VAL(wp, bonus) = 0;
		break;
		case	rKome:
			if(GAME_VAL(wp, remain) == 0)
				GAME_VAL(wp, bonus) = 50000;		//perfect bonus
			else if(GAME_VAL(wp, remain)<100)
				GAME_VAL(wp, bonus) = (unsigned long)(100 - GAME_VAL(wp, remain));
			else
				GAME_VAL(wp, bonus) = 0;
		break;
		case	rChoi:
			if(GAME_VAL(wp, remain) == 0)
				GAME_VAL(wp, bonus) = 200;			//perfect bonus
			else if(GAME_VAL(wp, remain)<20)
				GAME_VAL(wp, bonus) = (unsigned long)(20 - GAME_VAL(wp, remain));
			else
				GAME_VAL(wp, bonus) = 0;
		break;
		case	rTume:
			//GAME_VAL(wp, bonus) = 0;
		break;
		case	rYori:
			GAME_VAL(wp, bonus) = 0;
		break;
		default:
			GAME_VAL(wp, bonus) = 0;
		break;
	}
	
	GAME_VAL(wp, score) = GAME_VAL(wp, score) + GAME_VAL(wp, bonus);
}


#pragma mark -


/*	from Universal Header

struct PopupPrivateData {
	MenuHandle 						mHandle;
	SInt16 							mID;
};
typedef struct PopupPrivateData			PopupPrivateData;
typedef PopupPrivateData *				PopupPrivateDataPtr;
typedef PopupPrivateDataPtr *			PopupPrivateDataHandle;

*/

void selectTextItemRight (DialogPtr theDialog, short item)
{
	SelectDialogItemText (theDialog, item, 32767, 32767);
}

void	getPopUpSelectText(DialogPtr theDialog, short theItem, Str255 theString)
{	//in: theDialog, theItem(popup)
	//out: theString
	//

#ifdef TARGET_API_MAC_CARBON
	ControlRef  controlRef;
        MenuRef     menuRef;
	Size        actualSize;

	controlRef = getCtlHandle(theDialog, theItem);
        GetControlData(controlRef,kControlEntireControl,kControlPopupButtonMenuHandleTag,
                   sizeof(menuRef),&menuRef,&actualSize);
        GetMenuItemText(menuRef, GetControlValue(controlRef), theString);
#else
	PopupPrivateDataHandle	thePopUpHandle;
	MenuHandle			thePopupMenuHdl ;
	ControlHandle			theControlHdl;

	theControlHdl = getCtlHandle(theDialog, theItem);
	thePopUpHandle = (PopupPrivateDataHandle)(**theControlHdl).contrlData ; 
	thePopupMenuHdl = (**thePopUpHandle).mHandle ;
	GetMenuItemText(thePopupMenuHdl,GetControlValue(theControlHdl),theString);		//GetItem		(old name)
#endif
}

void	addNewHiName(Str255 newName)
{
	MenuHandle	hMenu, newMenuH;
	Str255	theString, strA;
	Handle	hRsrc;
	short	iItemCnt, newMenuCnt, i, j;
#ifndef TARGET_API_MAC_CARBON
	OSErr	iErr = noErr;
#endif

#ifdef TARGET_API_MAC_CARBON
        Handle hsRsrc;
        Str255 hiName[kHiScoreNameMaxCount];
#endif

	Boolean	isCopy = false;
	short	fRefNum;
	
	copyString(gPrefVal.hiScoreName, newName);			//save default HiScore Name

	//make sure app rsrc is current
	hMenu = GetMenu(mHiScoreName);		//read menu data from application resource
	if(hMenu == nil)
		showOSError(nil,  errorResourceManager, resNotFound, kFatal);
	//make new Menu
	newMenuH = NewMenu(mHiScoreName,"\pHi Score Name");
	if(newMenuH == nil)
		bigBadError(eAppMemSmall);
	//copy menu item
#ifdef TARGET_API_MAC_CARBON
        isCopy = true;
	iItemCnt = CountMenuItems(hMenu);
	for( i = 1 ; i <= iItemCnt ; i++ )	
	{
		GetMenuItemText(hMenu, i, theString);		//GetItem		(old name)
		AppendMenuItemText(newMenuH, theString);	
		if(EqualString(newName, theString, true, true))
			isCopy = false;				
	}

	//add new one
        if(isCopy)
            AppendMenuItemText(newMenuH,newName);	
#else
	iItemCnt = CountMItems(hMenu);
	for(i=1; i<=iItemCnt; i++)	
	{
		GetMenuItemText(hMenu,i,theString);		//GetItem		(old name)
		AppendMenu(newMenuH,theString);	
	}
	ReleaseResource((Handle)hMenu);
	showOSError(nil,  errorResourceManager, ResError(), kFatal);

	//add new one
            AppendMenu(newMenuH,newName);	
#endif
	//make sure pref file is current
	fRefNum = openPreferenceFile();
	if(fRefNum == kResFileNotOpened)
		return;
                
#ifdef TARGET_API_MAC_CARBON
        hsRsrc = Get1Resource(kRankNameType, mHiScoreName);
        if(hsRsrc != nil)
        {
            HLock(hsRsrc);
            BlockMove(*hsRsrc, &hiName[0], sizeof(Str255) * kHiScoreNameMaxCount);
            HUnlock(hsRsrc);
            i = 0;
            isCopy = true;
            while(( i < kHiScoreNameMaxCount) && (PLstrcmp(hiName[i],"\p") != 0) && isCopy)
            {
                if(EqualString(newName, hiName[i], true, true))
                    isCopy = false;
                i++;
            }

            if ( isCopy && (i < kHiScoreNameMaxCount))
                PLstrcpy(hiName[i], newName);
        } else {

            //make sure MENU rsrc is in pref file
            hRsrc = Get1Resource(kMENUType,mHiScoreName);
            if(hRsrc == nil)
            {
		copyResource(fRefNum, gAppRsrcFRefNum, kMENUType, mHiScoreName);
            }
            //read menu data from preference resource
            hMenu = GetMenu(mHiScoreName);	
            if(hMenu == nil)
		showOSError(nil,  errorResourceManager, resNotFound, kFatal);
            //compare menu strings and add one

            iItemCnt = CountMenuItems(hMenu);
            for(i=1; (i<=iItemCnt)&&(CountMenuItems(newMenuH)<kHiScoreNameMaxCount); i++)
            {
		isCopy = true;
		GetMenuItemText(hMenu,i,theString);		//GetItem		(old name)
		newMenuCnt = CountMenuItems(newMenuH);
		for(j=1; j<=newMenuCnt;j++)
		{
			GetMenuItemText(newMenuH,j,strA);
			if(EqualString(strA,theString,true,true))
				isCopy = false;				
		}
		if(isCopy)
			AppendMenuItemText(newMenuH,theString);	
            }
        
            iItemCnt = CountMenuItems(newMenuH);
            for( i = 0 ; i < kHiScoreNameMaxCount ; i++)
            {
                PLstrcpy(hiName[i], "\p");
            }
            for( i = 0 ; i < iItemCnt ; i++)
            {
                GetMenuItemText(newMenuH, i+1, strA);
                PLstrcpy(hiName[i], strA);
            }
        }
        
	hsRsrc = Get1Resource(kRankNameType, mHiScoreName);
	if(hsRsrc != nil)
	{
            RemoveResource(hsRsrc);			//RmveResource(rHandle);
            showOSError(nil,  errorResourceManager,  ResError(), kFatal);
        }
        hsRsrc = NewHandleClear(sizeof(Str255) * kHiScoreNameMaxCount);
        HLock(hsRsrc);
        BlockMove(&hiName[0], *hsRsrc, sizeof(Str255) * kHiScoreNameMaxCount);

	AddResource(hsRsrc,kRankNameType,mHiScoreName,"\pHi Score Name");	
	showOSError(nil,  errorResourceManager,  ResError(), kFatal);
	UpdateResFile(fRefNum);
	showOSError(nil,  errorResourceManager, ResError(), kFatal);
        HUnlock(hsRsrc);
#else
	//make sure MENU rsrc is in pref file
	hRsrc = Get1Resource(kMENUType,mHiScoreName);
	if(hRsrc == nil)
	{
		copyResource(fRefNum, gAppRsrcFRefNum, kMENUType, mHiScoreName);
	}
	//read menu data from preference resource
	hMenu = GetMenu(mHiScoreName);	
	if(hMenu == nil)
		showOSError(nil,  errorResourceManager, resNotFound, kFatal);
	//compare menu strings and add one
	iItemCnt = CountMItems(hMenu);
	for(i=1; (i<=iItemCnt)&&(CountMItems(newMenuH)<kHiScoreNameMaxCount); i++)
	{
		isCopy = true;
		GetMenuItemText(hMenu,i,theString);		//GetItem		(old name)
		newMenuCnt = CountMItems(newMenuH);
		for(j=1; j<=newMenuCnt;j++)
		{
			GetMenuItemText(newMenuH,j,strA);
			if(EqualString(strA,theString,true,true))
				isCopy = false;				
		}
		if(isCopy)
			AppendMenu(newMenuH,theString);	
	}
	RemoveResource((Handle)hMenu);			//RmveResource(rHandle);
	showOSError(nil,  errorResourceManager,  ResError(), kFatal);
	DisposeHandle((Handle)hMenu);
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	//
	AddResource((Handle)newMenuH,kMENUType,mHiScoreName,"\pHi Score Name");	
	showOSError(nil,  errorResourceManager,  ResError(), kFatal);
	UpdateResFile(fRefNum);
	showOSError(nil,  errorResourceManager, ResError(), kFatal);
#endif	
	//
	closePreferences(fRefNum);
}

short	getHiScoreNamePopUpItemID(MenuHandle hMenu,  Str255 theString)
{
	short		iItemCnt, i;
	Str255		itemString;
	
	//copy menu item
#ifdef TARGET_API_MAC_CARBON
	iItemCnt = CountMenuItems(hMenu);
#else
	iItemCnt = CountMItems(hMenu);
#endif
	for(i=1; i<=iItemCnt; i++)	
	{
		GetMenuItemText(hMenu,i, itemString);		//GetItem		(old name)
		if(EqualString(theString,itemString,true,true))
			return(i);
	}

	return(1);
}


MenuHandle	makePopUpMenu4HiscoreDialog(void)
{
	MenuHandle	hMenu, popUpMenuHandle;
	short		fRefNum;
	short		iItemCnt, popUpMenuCnt, i, j;
	Boolean		isCopy;
	Str255		popUpString;
	Str255		theString;

#ifdef TARGET_API_MAC_CARBON
        Str255 hiName[kHiScoreNameMaxCount];
        Handle hsRsrc;
#endif
	popUpMenuHandle = GetMenu(mHiScoreName);		//GetMHandle
	if(popUpMenuHandle == nil)
		showOSError(nil,  errorResourceManager, resNotFound, kFatal);

	fRefNum = openPreferenceFile();
	if(fRefNum != kResFileNotOpened)
	{
#ifdef TARGET_API_MAC_CARBON
            hsRsrc = Get1Resource(kRankNameType, mHiScoreName);
            if(hsRsrc != nil)
            {
                HLock(hsRsrc);
                BlockMove(*hsRsrc, &hiName[0], sizeof(Str255) * kHiScoreNameMaxCount);
                HUnlock(hsRsrc);
                for( i = 0 ; i < kHiScoreNameMaxCount ; i++)
                {
                    if((PLstrcmp(hiName[i],"\p") != 0) && (PLstrcmp(hiName[i],"\p-") != 0))
                    {
                        popUpMenuCnt = CountMenuItems(popUpMenuHandle);
                        isCopy = true;
			for(j=1; (j<=popUpMenuCnt)&&isCopy;j++)
			{
				GetMenuItemText(popUpMenuHandle, j, popUpString);
				if(EqualString(popUpString, hiName[i], true, true))
					isCopy = false;				
			}
			if(isCopy)
				AppendMenuItemText(popUpMenuHandle,hiName[i]);	
                    }
                }
            } else {
#endif
                
		hMenu = GetMenu(mHiScoreName);	
		if(hMenu == nil)
			showOSError(nil,  errorResourceManager, resNotFound, kFatal);
		//compare menu strings and add one
#ifdef TARGET_API_MAC_CARBON
		iItemCnt = CountMenuItems(hMenu);
#else
		iItemCnt = CountMItems(hMenu);
#endif
		for(i=1; i<=iItemCnt; i++)
		{
			isCopy = true;
			GetMenuItemText(hMenu,i,theString);		//GetItem		(old name)
#ifdef TARGET_API_MAC_CARBON
			popUpMenuCnt = CountMenuItems(popUpMenuHandle);
#else
			popUpMenuCnt = CountMItems(popUpMenuHandle);
#endif
			for(j=1; (j<=popUpMenuCnt)&&isCopy;j++)
			{
				GetMenuItemText(popUpMenuHandle,j,popUpString);
				if(EqualString(popUpString,theString,true,true))
					isCopy = false;				
			}
			if(isCopy)
#ifdef TARGET_API_MAC_CARBON
				AppendMenuItemText(popUpMenuHandle,theString);	
#else
				AppendMenu(popUpMenuHandle,theString);	
#endif
		}

		ReleaseResource((Handle)hMenu);
#ifdef TARGET_API_MAC_CARBON
                }
		InsertMenu(popUpMenuHandle, kInsertHierarchicalMenu);
#else
		InsertMenu(popUpMenuHandle, hierMenu);
#endif

#ifdef TARGET_API_MAC_CARBON
// get menu item from string resource
#endif
		closePreferences(fRefNum);
	}else
		bigBadError(eResErr);			

	return(popUpMenuHandle);
}

void	getHiScoreName(WindowPtr wp,  long remain)
{
	Boolean		dialogDone = false;
	short		itemHit;
	DialogPtr		theDialog;
	GrafPtr		savePort;
	Str255		theString, newName;
	MenuHandle	popUpMenuHandle;
	Str255		mes1, mes2, mes3, mes4;
	short		fRefNum;
#ifdef TARGET_API_MAC_CARBON	
        RgnHandle visRgn;
#endif

	GetPort(&savePort);
	//make pop up menu record, before GetNewDialog()
	popUpMenuHandle = makePopUpMenu4HiscoreDialog();
	//
	theDialog = GetNewDialog(rHiScoreNameDialog,nil,kMoveToFront);	//get theDialog
	if (theDialog == nil){	alertUser(eResErr);		return;	}
#ifdef TARGET_API_MAC_CARBON
	SetPortDialogPort(theDialog);
#else
	SetPort((GrafPtr)theDialog);
#endif
	//set default HiScore Name	
	SetControlValue (getCtlHandle(theDialog, rHiScoreNameDialog_PopUp), getHiScoreNamePopUpItemID(popUpMenuHandle,  gPrefVal.hiScoreName));
	setText (theDialog, rHiScoreNameDialog_Name, gPrefVal.hiScoreName);
	SelectDialogItemText (theDialog, rHiScoreNameDialog_Name, 32767, 32767);
	//set some fixed text paramator
	NumToString((long)GAME_VAL(wp, score), mes4);
	NumToString((long)GAME_VAL(wp, bonus), mes3);
	NumToString(remain, mes1);
	mes2[0] = 0;
	ParamText(mes1,nil,mes3,mes4);
	//
#ifdef TARGET_API_MAC_CARBON
	ShowWindow(GetDialogWindow(theDialog));
	SelectWindow(GetDialogWindow(theDialog));
        visRgn = NewRgn();
        GetPortVisibleRegion(GetDialogPort(theDialog), visRgn);
        if(QDIsPortBuffered(GetDialogPort(theDialog)))
            QDFlushPortBuffer(GetDialogPort(theDialog), visRgn);
#else
	ShowWindow((WindowPtr)theDialog);
	SelectWindow((WindowPtr)theDialog);
#endif
	setMyCursor(kArrowCURS);
	while(!dialogDone)
	{
		ModalDialog(nil, &itemHit);
		switch(itemHit)
		{
			case	ok:
				dialogDone = true;
				break;
			case	rHiScoreNameDialog_PopUp:
				//get name from popup item
				getPopUpSelectText(theDialog, itemHit, theString);
				setText (theDialog, rHiScoreNameDialog_Name, theString);
				SelectDialogItemText (theDialog, rHiScoreNameDialog_Name, 32767, 32767);
				break;
			default:
				break;
		}
	}
	setMyCursor(kArrowCURS);
	//get hi-score name
	getText (theDialog, rHiScoreNameDialog_Name, newName);
	//
	DisposeDialog(theDialog);
	//dispose popup menu handle
#ifdef TARGET_API_MAC_CARBON
	DeleteMenu(mHiScoreName);
//        DisposeHandle((Handle)popUpMenuHandle);
#else
	DeleteMenu(mHiScoreName);
	ReleaseResource((Handle)popUpMenuHandle);
#endif
	SetPort(savePort);
	//
	if(newName[0]==0)		//default "no name"
		GetIndString(newName, hiScoreStr, hiScoreStr_noName);
	if(newName[0]>60)
		newName[0] =60;
	addNewHiName(newName);
	//save  hiscore name
	fRefNum = openPreferenceFile();
	if(fRefNum != kResFileNotOpened)
	{
		saveGlobalToPref();	
		closePreferences(fRefNum);
	}
}
