//Menu Button on Window
#include	"applicationGlobals.h"

Boolean	isMenuButtonActive(WindowPtr wp, long theCntlID);

#ifdef TARGET_API_MAC_CARBON
extern WindowDataPtr getWindowDataPtr(WindowRef winodw);
extern DialogDataPtr getDialogDataPtr(DialogRef dialog);
#endif

void	adjustMenuButton(WindowPtr theWindow)
{
	//this routine must call only if my window is front

//	pWindow = FrontWindow();
//	if(!isAppWindow(pWindow))
//		return;

	if((GAME_VAL(theWindow, gameID) == rTume)&&((GAME_VAL(theWindow, gameStatus) & kTumeSolution)!=0))
	{
		hiliteMenuButton(theWindow, kWB_Undo, kDisableItem);
		hiliteMenuButton(theWindow, kWB_Reset, kDisableItem);
		hiliteMenuButton(theWindow, kWB_Find, kDisableItem);
	}
	else
	{
		hiliteMenuButton(theWindow, kWB_Find, kEnableItem);
		
		if(GAME_VAL(theWindow, canGameUndo))
			hiliteMenuButton(theWindow, kWB_Undo, kEnableItem);
		else
			hiliteMenuButton(theWindow, kWB_Undo, kDisableItem);
					
		if(GAME_STATUS(theWindow, kGameStart))
			hiliteMenuButton(theWindow, kWB_Reset, kEnableItem);
		else
			hiliteMenuButton(theWindow, kWB_Reset, kDisableItem);
	}


}

void	setupMenuButton(WindowPtr theWindow)
{
	Str255		theString;
	Rect			r;
	ControlHandle	hCtl;
	GrafPtr		savePort;
	
	GetPort(&savePort);
#ifdef TARGET_API_MAC_CARBON
	SetPortWindowPort(theWindow );
#else
	SetPort(theWindow );
#endif
	//*************************
	//create a push button on the window
	//*************************
	//new button
	GetIndString(theString, kWindowButton, kWB_New);
#ifdef TARGET_API_MAC_CARBON
	SetRect(&r,kButtonDistance,0,StringWidth(theString)+kButtonMargin,kButtonActualHeight);
#else
	SetRect(&r,kButtonDistance,0,StringWidth(theString)+kButtonMargin,kButtonHeight);
#endif
	hCtl=NewControl( theWindow, &r, theString, true,0,0,0,pushButProc | kControlUsesOwningWindowsFontVariant, kWB_New);		//refCon: kWB_New
	//undo button
	GetIndString(theString,kWindowButton, kWB_Undo);
#ifdef TARGET_API_MAC_CARBON
	SetRect(&r,r.right+kButtonDistance,0,r.right+kButtonDistance+StringWidth(theString)+kButtonMargin,kButtonActualHeight);
#else
	SetRect(&r,r.right+kButtonDistance,0,r.right+kButtonDistance+StringWidth(theString)+kButtonMargin,kButtonHeight);
#endif
	hCtl=NewControl( theWindow, &r, theString, true,0,0,0,pushButProc | kControlUsesOwningWindowsFontVariant, kWB_Undo);
	//reset button
	GetIndString(theString,kWindowButton, kWB_Reset);
#ifdef TARGET_API_MAC_CARBON
	SetRect(&r,r.right+kButtonDistance,0,r.right+kButtonDistance+StringWidth(theString)+kButtonMargin,kButtonActualHeight);
#else
	SetRect(&r,r.right+kButtonDistance,0,r.right+kButtonDistance+StringWidth(theString)+kButtonMargin,kButtonHeight);
#endif
	hCtl=NewControl( theWindow, &r, theString, true,0,0,0,pushButProc | kControlUsesOwningWindowsFontVariant, kWB_Reset);
	//find button
	GetIndString(theString,kWindowButton, kWB_Find);
#ifdef TARGET_API_MAC_CARBON
	SetRect(&r,r.right+kButtonDistance,0,r.right+kButtonDistance+StringWidth(theString)+kButtonMargin,kButtonActualHeight);
#else
	SetRect(&r,r.right+kButtonDistance,0,r.right+kButtonDistance+StringWidth(theString)+kButtonMargin,kButtonHeight);
#endif
	hCtl=NewControl( theWindow, &r, theString, true,0,0,0,pushButProc | kControlUsesOwningWindowsFontVariant, kWB_Find);
	
	SetPort(savePort );
}

void	handleWindowMenu(WindowPtr wp, long theCntlID)
{
	switch(theCntlID)
	{
		case kWB_New:
			if(wp != nil)
			{
				GAME_VAL(wp, canGameUndo) = true;
				newGame(wp);
			}
			break;
		case kWB_Undo:
			doUndo(wp);
			break;
		case kWB_Reset:
			resetMap();
			break;
		case kWB_Find:
			showTakablePiece();
			break;
	}
}

void	hiliteWindowControls(WindowPtr wp, short hiliteCode)
{
	ControlHandle	hCtl;
        
#ifdef TARGET_API_MAC_CARBON
        UInt16 numChildren;
        UInt16 i;
        ControlHandle subControl;
        
        GetRootControl(wp, &hCtl);
        CountSubControls (hCtl, &numChildren);
        for (i = 1; i <= numChildren; i++) {
            GetIndexedSubControl (hCtl, i, &subControl);
            HiliteControl(subControl, hiliteCode);
        }
#else
	hCtl = (ControlHandle)((WindowPeek)wp)->controlList;
	while(hCtl!=nil)
	{
		HiliteControl(hCtl, hiliteCode);
		hCtl = (**hCtl).nextControl;
	}
#endif
}

void	hiliteMenuButton(WindowPtr wp, long theCntlID, short hiliteCode)
{
	ControlHandle	hCtl;

#ifdef TARGET_API_MAC_CARBON
        UInt16 numChildren;
        UInt16 i;
        ControlHandle subControl;
        
        GetRootControl(wp, &hCtl);
        CountSubControls (hCtl, &numChildren);
        for (i = 1; i <= numChildren; i++) {
            GetIndexedSubControl (hCtl, i, &subControl);
            if(theCntlID== GetControlReference(subControl))
                    HiliteControl(subControl, hiliteCode);
        }
        
#else
	hCtl = (ControlHandle)((WindowPeek)wp)->controlList;

	while(hCtl!=nil)
	{
		if(theCntlID== GetControlReference(hCtl))
			HiliteControl(hCtl, hiliteCode);
		hCtl = (**hCtl).nextControl;
	}
#endif
}

Boolean	isMenuButtonActive(WindowPtr wp, long theCntlID)
{
	ControlHandle	hCtl;
	Boolean		result = true;

#ifdef TARGET_API_MAC_CARBON
        UInt16 numChildren;
        UInt16 i;
        ControlHandle subControl;
        
        GetRootControl(wp, &hCtl);
        CountSubControls (hCtl, &numChildren);
        for (i = 1; i <= numChildren; i++) {
            GetIndexedSubControl (hCtl, i, &subControl);
            if(theCntlID == GetControlReference(subControl))
            {
                if(GetControlHilite(subControl) == kDisableItem)
                        result = false;
            }
        }
#else
	hCtl = (ControlHandle)((WindowPeek)wp)->controlList;

	while(hCtl!=nil)
	{
		if(theCntlID== GetControlReference(hCtl))
		{
			if((*hCtl)->contrlHilite == kDisableItem)
				result = false;
		}
		hCtl = (**hCtl).nextControl;
	}
#endif
	return(result);
}

void	showMenuButton(WindowPtr theWindow)
{
	ControlHandle	theCH;

#ifdef TARGET_API_MAC_CARBON
        UInt16 numChildren;
        UInt16 i;
        ControlHandle subControl;
        
        GetRootControl(theWindow, &theCH);
        CountSubControls (theCH, &numChildren);
        for (i = 1; i <= numChildren; i++) {
            GetIndexedSubControl (theCH, i, &subControl);
            ShowControl(subControl);
        }
#else
	theCH = (ControlHandle)((WindowPeek)theWindow)->controlList;

	while(theCH!=nil)
	{
		ShowControl(theCH);
		theCH = (**theCH).nextControl;
	}
#endif
}

void	hideMenuButton(WindowPtr theWindow)
{
	ControlHandle	theCH;

#ifdef TARGET_API_MAC_CARBON
        UInt16 numChildren;
        UInt16 i;
        ControlHandle subControl;
        
        GetRootControl(theWindow, &theCH);
        CountSubControls (theCH, &numChildren);
        for (i = 1; i <= numChildren; i++) {
            GetIndexedSubControl (theCH, i, &subControl);
            HideControl(subControl);
        }
#else
	//	if(GetControlOwningWindowControlList(gameWindow)==nil)
	//		return;
	theCH = (ControlHandle)((WindowPeek)theWindow)->controlList;

	while(theCH!=nil)
	{
		HideControl(theCH);
		theCH = (**theCH).nextControl;
	}
#endif
}
