
#include	"applicationGlobals.h"

#ifndef TARGET_API_MAC_CARBON
extern	void StandardGetFolder(const short numTypes, ConstSFTypeListPtr typeList, StandardFileReply *theReply);
#endif

#ifdef TARGET_API_MAC_CARBON
extern prefVal	gPrefVal;				//globals for pref
#endif

#define	MY_DLOG(x)	(((myDlgPeek)theDialog)->x)

#define	kIsHideItem	0x6000

//
#ifdef TARGET_API_MAC_CARBON
Boolean	eventFilter(EventRecord *eventPtr, DialogRef theFrontWindow);
#else
Boolean	eventFilter(EventRecord *eventPtr, WindowPtr theFrontWindow);
#endif
Boolean	pointInItemRect(DialogPtr theDialog, short item, Point thePoint);
//
void	subItemRgn(DialogPtr theDialog, short itemNum, RgnHandle theRgn);
void	doMyDialogItem(DialogPtr theDialog, short itemHit);
void	doMyDimEditText(DialogPtr theDialog);
Boolean	doBypassMouseDown(Point globalPt);

#ifdef TARGET_API_MAC_CARBON
extern WindowDataPtr getWindowDataPtr(WindowRef winodw);
extern DialogDataPtr getDialogDataPtr(DialogRef dialog);
extern void setDialogDataPtr(DialogRef dialog, Ptr ptr);
#endif

//
//
//
//
void		adjustMenu4Dialogs(WindowPtr wp)
{
	MenuHandle	menuHandle;

	//***********************************************
	//if the front window is dialog
	//***********************************************
	menuHandle = GetMenuHandle(mEdit);
	if(menuHandle != nil)
	{
		switch(getDialogResNum(wp))
		{
			case	rHiScoreDialog:
			case	rShowAbout:
			case	rModelessExplanationDialog:
#ifdef TARGET_API_MAC_CARBON
				DisableMenuItem(menuHandle, iCut);
				DisableMenuItem(menuHandle, iCopy);
				DisableMenuItem(menuHandle, iPaste);
				DisableMenuItem(menuHandle, iClear);
#else
				DisableItem(menuHandle, iCut);
				DisableItem(menuHandle, iCopy);
				DisableItem(menuHandle, iPaste);
				DisableItem(menuHandle, iClear);
#endif
			break;
			default:
#ifdef TARGET_API_MAC_CARBON
			EnableMenuItem(menuHandle, iCut);
			EnableMenuItem(menuHandle, iCopy);
			EnableMenuItem(menuHandle, iPaste);
			EnableMenuItem(menuHandle, iClear);
#else
			EnableItem(menuHandle, iCut);
			EnableItem(menuHandle, iCopy);
			EnableItem(menuHandle, iPaste);
			EnableItem(menuHandle, iClear);
#endif
		}
	}
	
	//file menu
	menuHandle = GetMenuHandle(mFile);
	if(menuHandle != nil)
	{
#ifdef TARGET_API_MAC_CARBON
		DisableMenuItem(menuHandle, iNew);
		DisableMenuItem(menuHandle, iOpen);
		EnableMenuItem(menuHandle, iClose);
		DisableMenuItem(menuHandle, iSave);
		EnableMenuItem(menuHandle, iQuit);
#else
		DisableItem(menuHandle, iNew);
		DisableItem(menuHandle, iOpen);
		EnableItem(menuHandle, iClose);
		DisableItem(menuHandle, iSave);
		EnableItem(menuHandle, iQuit);
#endif
	}

	//game type
	menuHandle = GetMenuHandle(mGameType);
	if(menuHandle != nil)
	{
#ifdef TARGET_API_MAC_CARBON
		DisableMenuItem(menuHandle, iSame);
		DisableMenuItem(menuHandle, iMame);
		DisableMenuItem(menuHandle, iKome);
		DisableMenuItem(menuHandle, iTume);
		DisableMenuItem(menuHandle, iChoi);
#else
		DisableItem(menuHandle, iSame);
		DisableItem(menuHandle, iMame);
		DisableItem(menuHandle, iKome);
		DisableItem(menuHandle, iTume);
		DisableItem(menuHandle, iChoi);
#endif
	}

	//setting menu
	menuHandle = GetMenuHandle(mOther);
	if(menuHandle != nil)
	{
#ifdef TARGET_API_MAC_CARBON
		DisableMenuItem(menuHandle, mOther_Find);
		DisableMenuItem(menuHandle, mOther_ResetMap);
#else
		DisableItem(menuHandle, mOther_Find);
		DisableItem(menuHandle, mOther_ResetMap);
#endif
	}
}

Boolean	doBypassMouseDown(Point globalPt)
{
	Boolean	doNext = true;
	WindowPtr	whichWin = nil;
	short	thePart;
	Rect		iRect;
	short	iType;
	Handle	iHandle;
 	GrafPtr	savePort;
 	Point		thePoint;
		
	thePart = FindWindow(globalPt,&whichWin);
	
	switch(getDialogResNum(whichWin))
	{
		case	rPrefDLG:

			GetPort(&savePort);
#ifdef TARGET_API_MAC_CARBON
			SetPortWindowPort(whichWin);
#else
			SetPort(whichWin);
#endif
			thePoint = globalPt;
		        GlobalToLocal(&thePoint);
#ifdef TARGET_API_MAC_CARBON
		        GetDialogItem(GetDialogFromWindow(whichWin), rPrefDLG_CharaSize, &iType, &iHandle, &iRect);
#else
		        GetDialogItem(whichWin, rPrefDLG_CharaSize, &iType, &iHandle, &iRect);
#endif
			if(PtInRect(thePoint,&iRect))
			{
#ifdef TARGET_API_MAC_CARBON
				if(rPrefDLG_AutoSize==getRadioGroupState (GetDialogFromWindow(whichWin), rPrefDLG_AutoSize, rPrefDLG_FixedSize))
#else
				if(rPrefDLG_AutoSize==getRadioGroupState (whichWin, rPrefDLG_AutoSize, rPrefDLG_FixedSize))
#endif
					doNext = false;
			}
			SetPort(savePort);

		break;
	}
	
	return(doNext);
}


void	drawMyDialog(DialogPtr theDialog)
{
	Rect		iRect;
	short	iType;
	Handle	iHandle;
	PenState	thePnState;
	GrafPtr	savePort;
        
#ifdef TRAGET_API_MAC_CARBON
        Pattern gray;
	long 	version = 0;
	OSErr	theErr = noErr;
#endif

	//store grafport
	GetPort(&savePort);
#ifdef TARGET_API_MAC_CARBON
	SetPortDialogPort(theDialog);
#else
	SetPort(theDialog);
#endif
	GetPenState(&thePnState);

	//draw default dialog item
	DrawDialog(theDialog);

	//draw line, string etc.

#ifdef TARGET_API_MAC_CARBON
	switch(getDialogResNum(GetDialogWindow(theDialog)))
#else
	switch(getDialogResNum(theDialog))
#endif
	{
		case	rModelessExplanationDialog:
			drawExplanationDLG(theDialog);
		break;
		case	rPrefDLG:
			drawPrefDLGItem(theDialog);
		break;
		case	rHiScoreDialog:
			drawHiScoreDialog(theDialog);
		break;
	}
#ifdef TARGET_API_MAC_CARBON
        SetDialogDefaultItem(theDialog, ok);
	theErr = Gestalt(gestaltSystemVersion,&version);
	if (version <= 0x0760)		// this look is only for Systems after 7.6.0
        {
#endif
	//draw default Button Border
	GetDialogItem(theDialog, ok, &iType, &iHandle, &iRect);
	InsetRect(&iRect, -4, -4);
	PenNormal();
	PenSize(3,3);
	if((iType & itemDisable) != 0)
#ifdef TRAGET_API_MAC_CARBON
        {
                GetQDGlobalsGray(&gray);
		PenPat(&gray);
        }
#else
		PenPat(&qd.gray);
#endif
	FrameRoundRect(&iRect, 16,16);
#ifdef TRAGET_API_MAC_CARBON
        }
#endif

	//restore grafport
	SetPenState(&thePnState);
	SetPort(savePort);
}

void	doMyDialogItem(DialogPtr theDialog, short itemHit)
{
#ifdef TRAGET_API_MAC_CARBON
	switch(getDialogResNum(GetDialogWindow(theDialog)))
#else
	switch(getDialogResNum(theDialog))
#endif
	{
		case	rModelessExplanationDialog:
			doModelessExplanationDLGEvent( theDialog, itemHit);
		break;
		case	rShowAbout:
			doModelessAboutDLGEvent( theDialog, itemHit);
		break;
		case	rPrefDLG:
			doPrefDLGEvent( theDialog, itemHit);
		break;
		case	rHiScoreDialog:
			doHiScoreDLGEvent( theDialog, itemHit);
		break;
	}
}

void	doMyDimEditText(DialogPtr theDialog)
{
#ifdef TRAGET_API_MAC_CARBON
	switch(getDialogResNum(GetDialogWindow(theDialog)))
#else
	switch(getDialogResNum(theDialog))
#endif
	{
		case	rPrefDLG:
			buttonDimEditText(theDialog, rPrefDLG_FixedSize, rPrefDLG_CharaSize);
		break;
	}
}


#pragma mark -

DialogPtr	findDialog(short rsrcNum)
{
	WindowPtr	theWindow = nil;
	Boolean	findIt = false;
	
	theWindow = FrontWindow();
	while((theWindow != nil)&&(! findIt))
	{
#ifdef TARGET_API_MAC_CARBON
		if(GetWindowKind(theWindow) == kDialogWindowKind)
			if(DLG_DATA(GetDialogFromWindow(theWindow),resNumber) == rsrcNum)
//			if(DLG_DATA((DialogRef)theWindow,resNumber) == rsrcNum)
#else
		if((((WindowPeek) theWindow)->windowKind == dialogKind))
			if(((myDlgPeek)theWindow)->resNumber == rsrcNum)
#endif
				findIt = true;

		if(!findIt)
			theWindow = GetNextWindow(theWindow);
	}

	if(!findIt)
		theWindow = nil;
#ifdef TARGET_API_MAC_CARBON
	return(GetDialogFromWindow(theWindow));
#else
	return((DialogPtr)theWindow);
#endif
}

#pragma mark -

//*********************************************************
// eventFilter() is called directry after IsDialogEvent()
// eventFilter() will do additional task with dialog event
// When eventFilter() returns false, all event has processed and DialogSelect() will not be called
// When eventFilter() returns true, DialogSelect() will be called for default control action
//*********************************************************
#ifdef TARGET_API_MAC_CARBON
Boolean		eventFilter(EventRecord *eventPtr, DialogRef theFrontWindow)
#else
Boolean		eventFilter(EventRecord *eventPtr, WindowPtr theFrontWindow)
#endif
{
	char 		theKey;
#ifndef TARGET_API_MAC_CARBON        
	Boolean	result = true;		// true: process continue and go to DialogSelect
#endif

	switch ( eventPtr->what )
	{	
		case mouseDown:
		case mouseUp:
			//****************************
			// you can bypass mouseDown event here
			//
			// for expample,  when you wish to bypass mouseDown at inactive editText field 
			// returns false
			//****************************
			return(doBypassMouseDown(eventPtr->where));
		break;
		case keyDown:
		case autoKey:	
			theKey = (char)(eventPtr->message & charCodeMask);
			if ( (eventPtr->modifiers & cmdKey) != 0 ) 
			{	
				long menuResult;
			
				adjustMenus();
				menuResult = MenuKey(theKey);
		
				if ( (menuResult  >> 16) != 0 )
				{
					Boolean processDone = doMenuCommand(menuResult);
					
					if ( processDone == true )
						//***************************
						//when we already handled edit text through doMenuCommand()
						//return false to process finished
						//DialogSelect() will performs some automatic handling for
						// editText, when return true
						//***************************
						return false;	// process finished
				}
			}
			else
			{
				switch(theKey)
				{
					case	kESC:
#ifdef TARGET_API_MAC_CARBON
						switch(getDialogResNum(GetDialogWindow(theFrontWindow)))
#else
						switch(getDialogResNum(theFrontWindow))
#endif
						{
							case	rPrefDLG:
#ifdef TARGET_API_MAC_CARBON
								fakeButtonHilite(theFrontWindow, cancel);
								disposeMyDialog(theFrontWindow);
#else
								fakeButtonHilite((DialogPtr)theFrontWindow, cancel);
								disposeMyDialog((DialogPtr)theFrontWindow);
#endif
							break;
						}
						return false;	// process finished
					break;
					case	kRet:
					case	kEnter:
						if(isControlActive(theFrontWindow, ok))
						{
#ifdef TARGET_API_MAC_CARBON
							fakeButtonHilite(theFrontWindow, ok);
							doMyDialogItem(theFrontWindow, ok);
#else                                                
							fakeButtonHilite((DialogPtr)theFrontWindow, ok);
							doMyDialogItem(theFrontWindow, ok);
#endif
						}
						return false;	// process finished
					break;					
				}
			}
				//***************************
				//if any non-command keystrokes were 
				// entered and the edit field is disabled, exit. 
				//***************************
	
				//if ( (((DialogPeek)theFrontWindow)->editField + 1 == kEditTextField) 
				//	&& (GetControlValue(GetCtlHandle((DialogPtr)theFrontWindow, kEditCheckItem)) == false) )
				//	return false;

		break;
		case activateEvt:
			if ( (eventPtr->modifiers & activeFlag) == true )
#ifdef TARGET_API_MAC_CARBON
				hiliteAllControls(GetDialogFromWindow((WindowRef)eventPtr->message), kEnableItem);
			else
				hiliteAllControls(GetDialogFromWindow((WindowRef)eventPtr->message), kDisableItem);
#else
				hiliteAllControls((WindowPtr)eventPtr->message, kEnableItem);
			else
				hiliteAllControls((WindowPtr)eventPtr->message, kDisableItem);
#endif			
			return false;	// process finished
		break;
		case updateEvt:
			doUpdate(eventPtr);
#ifdef TARGET_API_MAC_CARBON
			doMyDimEditText(GetDialogFromWindow((WindowRef)eventPtr->message));
#else
			doMyDimEditText((WindowPtr)eventPtr->message);
#endif
		break;
		default:	//additional function for other event
		break;
	}

	//************
	// When eventFilter() returns true, DialogSelect() will be called for default control action
	//  update the window, deal with an item hit, etc.	
	//************
	return true;
}


//*********************************************************
// after the additional process at eventFilter()
// DialogSelect() check the default control process
//*********************************************************
void		doDialogEvent(EventRecord *eventPtr)
{

#ifdef TARGET_API_MAC_CARBON
	DialogPtr		theDialog = GetDialogFromWindow(FrontWindow());
#else
	DialogPtr		theDialog = (DialogPtr)FrontWindow();
#endif
	short		theItem;

	//SetPort(theDialog);
	if ( eventFilter(eventPtr, theDialog) != false )
	{
		if ( DialogSelect(eventPtr, &theDialog, &theItem) == true )
		{
			//***********************
			//DialogSelect() will handle
			// updateEvt and activateEvt: return false
			// mouseDown on disabled item and no item: return false
			// track enabled control: return true when control selected
			// activate and hilite selection of editText field
			// handle keystroke in exitText field
			// call TEIdle() to blink cursor
			//***********************			
		
			if ( theDialog != nil )
			{
				doMyDialogItem(theDialog, theItem);
			}
		}
	}

	return;

#ifndef TARGET_API_MAC_CARBON
BailOut:
	DebugStr((StringPtr)"\pGetCtlHandle in DoDialogEvent failed");
#endif
}



//******************************************************
//	DoDialogNullEvent()
//	modify cursor shape as it flys over some item on dialog.
//	blink cursor in exit Text field by calling DialogSelect()
//******************************************************
void		doDialogNullEvent(EventRecord *eventPtr)
{
	WindowPtr	wp;
	short		itemHit;

#ifdef TARGET_API_MAC_CARBON
        DialogPtr	aDialog;
#endif

	wp = FrontWindow();
	if(!isDialogWindow(wp))
		return;

	//modify cursor shape
	switch(getDialogResNum(wp))
	{
		case	rPrefDLG:
#ifdef TARGET_API_MAC_CARBON
			doPrefDLGNullEvent(GetDialogFromWindow(wp));
#else
			doPrefDLGNullEvent(wp);
#endif
		break;
	}

	//blink cursor in exit field
#ifdef TARGET_API_MAC_CARBON
        aDialog = GetDialogFromWindow(wp);
	DialogSelect(eventPtr, &aDialog, &itemHit);	
#else
	DialogSelect(eventPtr, &wp, &itemHit);	
#endif
}

#pragma mark -

void	addItemRgn(DialogPtr theDialog, short itemNum, RgnHandle theRgn)
{
	RgnHandle	srcRgnA,srcRgnB;
	Rect		iRect;
	short	iType;
	Handle	iHandle;

	srcRgnA = NewRgn();
	srcRgnB = NewRgn();
	GetDialogItem(theDialog, itemNum, &iType, &iHandle, &iRect);
	RectRgn(srcRgnA,&iRect);
	CopyRgn(theRgn,srcRgnB);
	UnionRgn(srcRgnA,srcRgnB,theRgn);
	DisposeRgn(srcRgnA);
	DisposeRgn(srcRgnB);
}

void	subItemRgn(DialogPtr theDialog, short itemNum, RgnHandle theRgn)
{
	RgnHandle	srcRgnA,srcRgnB;
	Rect		iRect;
	short	iType;
	Handle	iHandle;

	srcRgnA = NewRgn();
	srcRgnB = NewRgn();
	GetDialogItem(theDialog, itemNum, &iType, &iHandle, &iRect);
	RectRgn(srcRgnB,&iRect);	
	CopyRgn(theRgn,srcRgnA);
	DiffRgn(srcRgnA,srcRgnB,theRgn);
	DisposeRgn(srcRgnA);
	DisposeRgn(srcRgnB);
}


DialogPtr	createMyDialog(short rID)
{
	DialogPtr		theDialog;
	Ptr			storage;
	MenuHandle	hMenu;

	//make pop up menu record, before GetNewDialog()
	switch(rID)
	{
		case	rHiScoreDialog:
			hMenu = GetMenu(mHiScoreMenu);
#ifdef TARGET_API_MAC_CARBON
			InsertMenu(hMenu, kInsertHierarchicalMenu);
#else
			InsertMenu(hMenu, hierMenu);
#endif
		break;
	}

#ifdef TARGET_API_MAC_CARBON
	storage = NewPtrClear(sizeof(DialogDataRec));
#else
	storage = NewPtr(sizeof(myDlgRec));
#endif
	showOSError(nil,  errorMemoryManager, MemError(), kNotFatal);
	if ( storage == nil )
		bigBadError(eAppMemSmall);

#ifdef TARGET_API_MAC_CARBON
	theDialog = GetNewDialog(rID, nil, kMoveToFront);
#else
	theDialog = GetNewDialog(rID, storage, kMoveToFront);
#endif
	if ( theDialog == nil )
		showOSError(nil,  errorResourceManager, resNotFound, kFatal);

#ifdef TARGET_API_MAC_CARBON
        setDialogDataPtr(theDialog, storage);
//        SetWindowProperty(GetDialogWindow(theDialog), myCreator, 'DDat', sizeof(Ptr), &storage);
#endif

	if ( theDialog != nil )
	{	
#ifdef TARGET_API_MAC_CARBON
                DLG_DATA(theDialog, resNumber) = rID;
#else
		((myDlgPeek)theDialog)->resNumber = rID;
#endif
		switch(rID)
		{
			case	rPrefDLG:
				setUpPrefDLG(theDialog);
			break;
			case	rHiScoreDialog:
				DLG_DATA(theDialog, rankID) = 1;
				DLG_DATA(theDialog, rankScore) = 0;
				DLG_DATA(theDialog, rankRemain) = 0;
				DLG_DATA(theDialog, hiscoreData) = NewHandle(kHandleTempSize);
				DLG_DATA(theDialog, hiscoreRemain) = NewHandle(kHandleTempSize);
				DLG_DATA(theDialog, popupMenu) = hMenu;
				readHiScoreDataToDialogRec(rSame,  theDialog);
			break;
		}
	}

	return(theDialog);
}


short	disposeMyDialog(DialogPtr theDialog)
{
	short	itemHit = ok;

#ifdef TARGET_API_MAC_CARBON
	switch(getDialogResNum(GetDialogWindow(theDialog)))
#else
	switch(getDialogResNum(theDialog))
#endif
	{
		case	rModelessExplanationDialog:
			setMyCursor(kArrowCURS);
#ifdef TARGET_API_MAC_CARBON
			TEDispose(DLG_DATA(theDialog, hTE));
                        DisposePtr((Ptr)getDialogDataPtr(theDialog)); 
#else
			TEDispose(MY_DLOG(hTE));
#endif
			DisposeDialog(theDialog);
		break;
		case	rHiScoreDialog:
			DisposeHandle(DLG_DATA(theDialog, hiscoreData));
			showOSError(nil,  errorMemoryManager, MemError(), kFatal);
			DisposeHandle(DLG_DATA(theDialog, hiscoreRemain));
			showOSError(nil,  errorMemoryManager, MemError(), kFatal);
#ifdef TARGET_API_MAC_CARBON
                        DisposePtr((Ptr)getDialogDataPtr(theDialog)); 
#endif
			DisposeDialog(theDialog);
			//dispose popup menu
#ifndef TARGET_API_MAC_CARBON
			DeleteMenu(mHiScoreMenu);
			ReleaseResource((Handle)DLG_DATA(theDialog, popupMenu));
#endif
		break;
		default:
#ifdef TARGET_API_MAC_CARBON
                        DisposePtr((Ptr)getDialogDataPtr(theDialog)); 
#endif
			DisposeDialog(theDialog);
		break;
	}

	return(itemHit);
}

#pragma mark -

short getDialogResNum(WindowPtr window)
{
	short	result = 0;

	if ( window != nil )
	{
#ifdef TARGET_API_MAC_CARBON
		if(GetWindowKind(window) == kDialogWindowKind)
			result = DLG_DATA(GetDialogFromWindow(window), resNumber);				
#else
		if(((WindowPeek) window)->windowKind == dialogKind)
			result = ((myDlgPeek)window)->resNumber;				
#endif
	}
	return(result);
}

Boolean isDialogWindow(WindowPtr pWindow)
{
	Boolean	result = false;

	if(pWindow == nil)
		result = false;
#ifdef TARGET_API_MAC_CARBON
	else if (GetWindowKind(pWindow) == kDialogWindowKind )
#else
	else if ( ((WindowRecord *)pWindow)->windowKind == dialogKind )
#endif
		result = true;

	return(result);
} 


#pragma mark -

#ifdef TARGET_API_MAC_CARBON
void	growListDialog(DialogRef theDialog, short diffWide, short diffHigh)
#else
void	growListDialog(WindowPtr theDialog, short diffWide, short diffHigh)
#endif
{
	//change list size
	//changeListSize( theDialog, diffWide, diffHigh);
	//move button
	moveButton(theDialog, ok,  diffWide,  diffHigh);
	//move static text
//	moveStaticText( theDialog,  diToday,  diffWide,  diffHigh);
}
/*
#pragma mark -

static void	drawSizeBox(WindowPtr win)
{
#ifdef TARGET_API_MAC_CARBON
	Rect		sizeBox;
#else
	Rect		sizeBox = win->portRect;
#endif
	GrafPtr	sv;
	RgnHandle	svRgn;

#ifdef TARGET_API_MAC_CARBON
        GetPortBounds(GetWindowPort(win),&sizeBox);
#endif

	sizeBox.top = sizeBox.bottom - 15;
	sizeBox.left = sizeBox.right - 15;
	svRgn = NewRgn();
	GetPort(&sv);
	SetPort(win);
	GetClip(svRgn);
	
	ClipRect(&sizeBox);
	DrawGrowIcon(win);
	
	SetClip(svRgn);
	SetPort(sv);
	DisposeRgn(svRgn);
	
	return;
}
*/

Boolean pointInItemRect(DialogPtr theDialog, short item, Point thePoint)
{
	Handle	iHandle;
	short	iType;
	Rect		iRect;
	
	GetDialogItem (theDialog, item, &iType, &iHandle, &iRect);
	return(PtInRect(thePoint,&iRect));
}

void invalThisItemRect(DialogPtr theDialog, short theEditItem)
{
	Handle		editTextItem;
	short			aType;
	Rect			editTextRect;
	GrafPtr		oldPort;

	GetPort(&oldPort);
#ifdef TARGET_API_MAC_CARBON
	SetPortDialogPort(theDialog);
#else
	SetPort(theDialog);
#endif
	
	GetDialogItem(theDialog, theEditItem, &aType, &editTextItem, &editTextRect);
	InsetRect(&editTextRect, -5, -5);
#ifdef TARGET_API_MAC_CARBON
	InvalWindowRect(GetDialogWindow(theDialog), &editTextRect);
#else
	InvalRect(&editTextRect);
#endif	
	SetPort(oldPort);
}


void hiliteAllControls(DialogPtr theDialog, short hiliteCode)
{	//activate or inactivate all controls on dialog
	//called from activateEvt in eventFilter(), resumeEvent(), suspendEvent()
	GrafPtr	savePort;

	GetPort(&savePort);
#ifdef TARGET_API_MAC_CARBON
	SetPortDialogPort(theDialog);
#else
	SetPort(theDialog);
#endif
	if(hiliteCode == kEnableItem)
	{
		enableAllControls(theDialog);
		switch(getDialogResNum(GetDialogWindow(theDialog)))
		{
			case	rPrefDLG:
				if(gPrefVal.aimHSAvail == kAimHSLv3)
				{
				}
				else if(gPrefVal.aimHSAvail == kAimHSLv2)
				{
					disableControl(theDialog, rPrefDLG_AimHS3);
				}
				else if(gPrefVal.aimHSAvail == kAimHSLv1)
				{
					disableControl(theDialog, rPrefDLG_AimHS3);
					disableControl(theDialog, rPrefDLG_AimHS2);
				}
				else
				{
					disableControl(theDialog, rPrefDLG_AimHS3);
					disableControl(theDialog, rPrefDLG_AimHS2);
					disableControl(theDialog, rPrefDLG_AimHS1);
				}
				drawPrefDLGItem(theDialog);//setValueToPrefDialog(theDialog);
			break;
		}
	}else{
		disableAllControls(theDialog);
	}
//	InvalRect(&(theDialog->portRect));
//	if(getDialogResNum((WindowPtr)theDialog) == rPrefDialog)
//		invalThisItemRect(theDialog, diPrefLogMax);
	invalThisItemRect(theDialog, ok);
	/*switch(getDialogResNum((WindowPtr)theDialog)){
		case rListDialog:
			drawSizeBox(theDialog);
			break;
	}*/
	SetPort(savePort);
}

void hiliteEditText(DialogPtr theDialog, short item, short isActive)
{
	#pragma unused(theDialog, item, isActive)
/*	RgnHandle	srcRgnB,destRgn;
	Rect		iRect;
	Handle	iHandle;
	short		iType;
	
	srcRgnB = NewRgn();
	destRgn = NewRgn();

	GetDialogItem(theDialog, item, &iType, &iHandle, &iRect);
	RectRgn(srcRgnB,&iRect);

	if(isActive){
		//ShowDialogItem(theDialog,item);
		SelectDialogItemText(theDialog, item, 0, 0);
		UnionRgn(((myDlgPeek)theDialog)->textItemRgn,srcRgnB,destRgn);
	}else{
		SelectDialogItemText(theDialog, -1, 0, 0);
		DiffRgn(((myDlgPeek)theDialog)->textItemRgn,srcRgnB,destRgn);
		//HideDialogItem(theDialog,item);
	}
	CopyRgn(destRgn,((myDlgPeek)theDialog)->textItemRgn);
	DisposeRgn(srcRgnB);
	DisposeRgn(destRgn);
	invalThisItemRect(theDialog, item);*/
}

void	buttonDimEditText(DialogPtr theDialog, short buttonItem, short editTextItem)
{
    ControlHandle theControl;

    theControl = getCtlHandle(theDialog, buttonItem);

    // only do it if the checkbox is false
    if ( GetControlValue(theControl) == false )
    {
	    doDimEditText(theDialog, editTextItem);
    }
}

void doDimEditText(DialogPtr theDialog, short theItem)
{
        PenState 	thePen;
	Rect		iRect;
	short	iType;
	Handle	iHandle;
 	GrafPtr	savePort;

#ifdef TRAGET_API_MAC_CARBON
        Pattern gray;
#endif

	GetPort(&savePort);

#ifdef TRAGET_API_MAC_CARBON
	SetPortDialogPort(theDialog);
#else
	SetPort(theDialog);
#endif
 
        // Save and restore the pen state
        GetPenState(&thePen);
        // drawing routines
        GetDialogItem(theDialog, theItem, &iType, &iHandle, &iRect);
        PenMode(notPatBic);
#ifdef TRAGET_API_MAC_CARBON
        GetQDGlobalsGray(&gray);
        PenPat(&gray);
#else
        PenPat(&qd.gray);
#endif
        PaintRect(&iRect);
        //restore pen state
        SetPenState(&thePen);
	SetPort(savePort);
}

#pragma mark -

/*
	DoCut - Zero out the scrap and cut the current selection from the current edit text
	field.  Done in response to the Cut menu command (either by key or mouse).

	Note that we don't have to worry about putting the TEScrap->DeskScrap stuff
	in response to suspend/resume events, because the desk scrap is always
	kept up-to-date.
*/
void doCut(DialogPtr theDialog)
{
	HiliteMenu(mEdit);
#ifdef TARGET_API_MAC_CARBON
        ClearCurrentScrap();
#else
	(void)ZeroScrap();
#endif
	DialogCut(theDialog);
	if ( TEToScrap() != noErr )
		DebugStr((StringPtr)"\pProblem going from TE->desk scrap");
}


/*-------------------------------------------------------------------------------------*/
/*
	DoCut - Zero out the scrap and copy the current selection from the current edit text
	field.  Done in response to the Copy menu command (either by key or mouse).

	Note that we don't have to worry about putting the TEScrap->DeskScrap stuff
	in response to suspend/resume events, because the desk scrap is always
	kept up-to-date.
*/
void doCopy(DialogPtr theDialog)
{
	HiliteMenu(mEdit);
#ifdef TARGET_API_MAC_CARBON
        ClearCurrentScrap();
#else
	(void)ZeroScrap();
#endif
	DialogCopy(theDialog);
	if ( TEToScrap() != noErr )
		DebugStr((StringPtr)"\pProblem going from TE->desk scrap");
}


/*-------------------------------------------------------------------------------------*/
/*
	DoPaste - Paste the current selection from the current edit text
	field.  Done in response to the Paste menu command (either by key or mouse).

	Note that we don't have to worry about putting the TEScrap->DeskScrap stuff
	in response to suspend/resume events, because the desk scrap is always
	kept up-to-date.
*/
void doPaste(DialogPtr theDialog)
{
	if ( TEFromScrap() != noErr )
		DebugStr((StringPtr)"\pProblem going from desk scrap->TE");
	HiliteMenu(mEdit);
	DialogPaste(theDialog);

}


/*-------------------------------------------------------------------------------------*/
/*
	DoClear - Cut the current selection from the current edit text field, but don't
	add it to the scrap.  Done in response to the Cut menu command (either by key 
	or mouse).
*/
void doClear(DialogPtr theDialog)
{
	HiliteMenu(mEdit);
	DialogDelete(theDialog);
}

