/*	doMyPref.c	*/

#include	"applicationGlobals.h"

#ifdef TARGET_API_MAC_CARBON
extern prefVal	gPrefVal;				//globals for pref
#endif

#ifdef TARGET_API_MAC_CARBON
#define	DLOG_TEMP(theDialog, x)		(DLG_DATA(theDialog, tempPref).x)
#else
#define	DLOG_TEMP(theDialog, x)		(((myDlgPeek)theDialog)->tempPref.x)
#endif

#ifdef TARGET_API_MAC_CARBON
extern WindowDataPtr getWindowDataPtr(WindowRef winodw);
extern DialogDataPtr getDialogDataPtr(DialogRef dialog);
#endif

void	checkPrefDialog(void)
{
	DialogPtr	theDialog = nil;

	theDialog = findDialog(rPrefDLG);
	if(theDialog != nil)
#ifdef TARGET_API_MAC_CARBON
		SelectWindow(GetDialogWindow(theDialog));
#else
		SelectWindow(theDialog);
#endif
}

#pragma mark -

OSErr	doPrefDLGNullEvent(DialogPtr theDialog)
{
	GrafPtr		savePort;
	OSErr		iErr = noErr;
	short		dItem;
	Point			localPt;
	Rect		iRect;
	short	iType;
	Handle	iHandle;
	Str255	theString;
	
	GetPort(&savePort);

#ifdef TARGET_API_MAC_CARBON
	SetPortDialogPort(theDialog);
#else
	SetPort(theDialog);
#endif

	//set iBeamCursor when mouse is in textItemRgn
	GetMouse(&localPt);
	dItem = FindDialogItem(theDialog,localPt)+1;		//FindDItem

#ifdef TARGET_API_MAC_CARBON
	if(DLG_DATA(theDialog, prevItem) != dItem)
#else
	if(((myDlgPeek)theDialog)->prevItem != dItem)
#endif
	{
		if(dItem == 0)
		{
			setMyCursor(kArrowCURS);
			theString[0] = 0;
		}
		else
		{
			GetDialogItem(theDialog,dItem,&iType,&iHandle,&iRect);		//GetDItem
			if(iType == editText)
			{
				if(rPrefDLG_AutoSize==getRadioGroupState (theDialog, rPrefDLG_AutoSize, rPrefDLG_FixedSize))
					setMyCursor(kArrowCURS);
				else
					setMyCursor(iBeamCursor);
			}
			else
				setMyCursor(kArrowCURS);

			GetIndString(theString,rPrefDLG,dItem);
		}
		setText (theDialog, rPrefDLG_Explanation, theString);
                
#ifdef TARGET_API_MAC_CARBON
		InvalWindowRect(GetDialogWindow(theDialog), &iRect);
		DLG_DATA(theDialog, prevItem) = dItem;
#else
		InvalRect(&iRect);
		((myDlgPeek)theDialog)->prevItem = dItem;
#endif
	}

	SetPort(savePort);

	return(iErr);
}

void	doPrefDLGEvent(DialogPtr theDialog, short itemHit)
{
#ifndef TARGET_API_MAC_CARBON
	OSErr	iErr = noErr;
#endif
	GrafPtr	savedPort;
	Point		where;
	RGBColor	outColor;
	prefVal	tempVal;
	long		value;
	Boolean	valueOK = true;
	WindowPtr	theWindow;
	short	fRefNum;
	
	GetPort (&savedPort);

#ifdef TARGET_API_MAC_CARBON
	SetPortDialogPort (theDialog);
#else
	SetPort (theDialog);
#endif
	switch ( itemHit )
	{
		case ok:
			tempVal = gPrefVal;
			tempVal.defaultColor = DLOG_TEMP(theDialog, defaultColor);
			tempVal.aimHSSelect = getRadioGroupState (theDialog, rPrefDLG_AimHS0, rPrefDLG_AimHS3) - rPrefDLG_AimHS0;
			tempVal.isAutoSize = (rPrefDLG_AutoSize==getRadioGroupState (theDialog, rPrefDLG_AutoSize, rPrefDLG_FixedSize));
			if(getNumberTextRange(theDialog, rPrefDLG_CharaSize, &value, kCharaSizeMin, kCharaSizeMax, nil))
			{
				tempVal.charaSize = (short)value;
				valueOK = true;
			}
			else
				valueOK = false;				
			//
			if(valueOK)
			{
				gPrefVal = tempVal;
				fRefNum = openPreferenceFile();
				if(fRefNum != kResFileNotOpened)
				{
					saveGlobalToPref();
					closePreferences(fRefNum);
				}
				disposeMyDialog(theDialog);
				//
				theWindow = findMyWindow();
				setWindowDisplayParts(theWindow);
				drawAllCharactersOnWindow(theWindow);
			}
		break;
		case cancel:
			//
			disposeMyDialog(theDialog);
		break;
		case	rPrefDLG_Default:
			tempVal = gPrefVal;
			setInternalDefaultToGlogal();
			setUpPrefDLG(theDialog);
			gPrefVal = tempVal;			
		break;
		case rPrefDLG_AimHS0:
		case rPrefDLG_AimHS1:
		case rPrefDLG_AimHS2:
		case rPrefDLG_AimHS3:
			setRadioGroupState (theDialog, rPrefDLG_AimHS0, rPrefDLG_AimHS3, itemHit);
		break;
		case	rPrefDLG_BackColor:
		case	rPrefDLG_SetBackColor:
			SetPt(&where,0,0);			
			if(GetColor(where,"\p",&(gPrefVal.defaultColor),&outColor))
			{
				DLOG_TEMP(theDialog, defaultColor) = outColor;
				invalThisItemRect(theDialog, rPrefDLG_BackColor);
			}
		break;
		case rPrefDLG_AutoSize:
		case rPrefDLG_FixedSize:
			setRadioGroupState (theDialog, rPrefDLG_AutoSize, rPrefDLG_FixedSize, itemHit);
			invalThisItemRect(theDialog, rPrefDLG_CharaSize);
		break;
	}
	SetPort (savedPort);

}
#pragma mark -

void	drawPrefDLGItem(DialogPtr theDialog)
{	//setport before call

	Rect		iRect;
	Handle	iHandle;
	short	iType;
	RGBColor	saveColor;

	GetForeColor(&saveColor);
	//draw frame for explanation item
	GetDialogItem (theDialog, rPrefDLG_Explanation, &iType, &iHandle, &iRect);
	InsetRect(&iRect,-1,-1);
	FrameRect(&iRect);	

	//draw back ground
	RGBForeColor(&DLOG_TEMP(theDialog, defaultColor));
	GetDialogItem (theDialog, rPrefDLG_BackColor, &iType, &iHandle, &iRect);
	PaintRect(&iRect);
	ForeColor(blackColor);
	InsetRect(&iRect,-1,-1);
	FrameRect(&iRect);

	RGBForeColor(&saveColor);
}

void	setUpPrefDLG(DialogPtr theDialog)
{
	GrafPtr		savePort;
        
#ifdef TARGET_API_MAC_CARBON	
        RgnHandle visRgn;
#endif
	
	GetPort(&savePort);
        
#ifdef TARGET_API_MAC_CARBON
	SetPortDialogPort(theDialog);
	DLG_DATA(theDialog, tempPref) = gPrefVal;
#else
	SetPort(theDialog);
	((myDlgPeek)theDialog)->tempPref = gPrefVal;
#endif

	checkAimHiScoreAvail();		//enable or disable Radio Button at hiliteAllControls()

	setRadioGroupState (theDialog, rPrefDLG_AimHS0, rPrefDLG_AimHS3, gPrefVal.aimHSSelect + rPrefDLG_AimHS0);
	//
	setNumberText(theDialog, rPrefDLG_CharaSize, gPrefVal.charaSize);
	selectTextItem(theDialog, rPrefDLG_CharaSize);
	//
	if(gPrefVal.isAutoSize)
	{
		setRadioGroupState (theDialog, rPrefDLG_AutoSize, rPrefDLG_FixedSize, rPrefDLG_AutoSize);
	}
	else
	{
		setRadioGroupState (theDialog, rPrefDLG_AutoSize, rPrefDLG_FixedSize, rPrefDLG_FixedSize);
	}	

//	setCheckBoxState (theDialog, rDigI_Pref_ShutterApprox,gVal.cameraShutterApprox);
#ifdef TARGET_API_MAC_CARBON
        visRgn = NewRgn();
        GetPortVisibleRegion(GetDialogPort(theDialog), visRgn);
    
        InvalWindowRgn(GetDialogWindow(theDialog), visRgn);
#else
	InvalRgn(theDialog->visRgn);
#endif
	SetPort(savePort);
}

void	setInternalDefaultToGlogal(void)
{
	gPrefVal.defaultColor.red = 0xf000;
	gPrefVal.defaultColor.green = 0xf000;
	gPrefVal.defaultColor.blue = 0xf000;
	
	gPrefVal.aimHSAvail = kAimHSLv0;
	gPrefVal.aimHSSelect = kAimHSLv0;

	gPrefVal.isMonkeyMode = false;

	gPrefVal.isAutoSize = true;
	gPrefVal.charaSize = kIconSize;

	GetIndString(gPrefVal.hiScoreName,kAppStatement,kApp_HiScoreName);

}