/*	doCharacter	*/
#include	"applicationGlobals.h"

void		openPieceRec(WindowPtr wp, short x, short y);
void		takePieceRec(WindowPtr wp, short x, short y);
void		mouseToMapXY(WindowPtr wp, Point mouse, short *x, short *y);

#ifdef TARGET_API_MAC_CARBON
extern WindowDataPtr getWindowDataPtr(WindowRef winodw);
extern DialogDataPtr getDialogDataPtr(DialogRef dialog);
#endif

void		adjustMenu4Window(WindowPtr wp)
{
	MenuHandle	menuHandle;

	//***********************************************
	//the front window is Window
	//***********************************************

	//file menu
	menuHandle = GetMenuHandle(mFile);
	if(menuHandle != nil)
	{
#ifdef TARGET_API_MAC_CARBON
		EnableMenuItem(menuHandle, iNew);
		EnableMenuItem(menuHandle, iOpen);
		DisableMenuItem(menuHandle, iClose);
		EnableMenuItem(menuHandle, iSave);
		EnableMenuItem(menuHandle, iQuit);
#else
		EnableItem(menuHandle, iNew);
		EnableItem(menuHandle, iOpen);
		DisableItem(menuHandle, iClose);
		EnableItem(menuHandle, iSave);
		EnableItem(menuHandle, iQuit);
#endif
	}

	//edit menu
	menuHandle = GetMenuHandle(mEdit);
	if(menuHandle != nil)
	{
#ifdef TARGET_API_MAC_CARBON
		DisableMenuItem(menuHandle, iUndo);
		DisableMenuItem(menuHandle, iCut);
		DisableMenuItem(menuHandle, iCopy);
		DisableMenuItem(menuHandle, iPaste);
		DisableMenuItem(menuHandle, iClear);

		if(GAME_VAL(wp, canGameUndo))
			EnableMenuItem(menuHandle, iUndo);
			
		//when show solution for tumegame
		if((GAME_VAL(wp, gameID) == rTume)&&((GAME_VAL(wp, gameStatus) & kTumeSolution)!=0))
			DisableMenuItem(menuHandle, iUndo);
#else
		DisableItem(menuHandle, iUndo);
		DisableItem(menuHandle, iCut);
		DisableItem(menuHandle, iCopy);
		DisableItem(menuHandle, iPaste);
		DisableItem(menuHandle, iClear);

		if(GAME_VAL(wp, canGameUndo))
			EnableItem(menuHandle, iUndo);
			
		//when show solution for tumegame
		if((GAME_VAL(wp, gameID) == rTume)&&((GAME_VAL(wp, gameStatus) & kTumeSolution)!=0))
			DisableItem(menuHandle, iUndo);
#endif
	}

	//game type menu
	menuHandle = GetMenuHandle(mGameType);
	if(menuHandle != nil)
	{
#ifdef TARGET_API_MAC_CARBON
		EnableMenuItem(menuHandle, iSame);
		EnableMenuItem(menuHandle, iMame);
		EnableMenuItem(menuHandle, iKome);
		EnableMenuItem(menuHandle, iTume);
		EnableMenuItem(menuHandle, iChoi);
		EnableMenuItem(menuHandle, iYori);
		//
		CheckMenuItem(menuHandle,iSame, GAME_VAL(wp,gameID)==rSame);
		CheckMenuItem(menuHandle,iMame, GAME_VAL(wp,gameID)==rMame);
		CheckMenuItem(menuHandle,iKome, GAME_VAL(wp,gameID)==rKome);
		CheckMenuItem(menuHandle,iTume, GAME_VAL(wp,gameID)==rTume);
		CheckMenuItem(menuHandle,iChoi, GAME_VAL(wp,gameID)==rChoi);
		CheckMenuItem(menuHandle,iYori, GAME_VAL(wp,gameID)==rYori);
#else
		EnableItem(menuHandle, iSame);
		EnableItem(menuHandle, iMame);
		EnableItem(menuHandle, iKome);
		EnableItem(menuHandle, iTume);
		EnableItem(menuHandle, iChoi);
		EnableItem(menuHandle, iYori);
		//
		CheckItem(menuHandle,iSame, GAME_VAL(wp,gameID)==rSame);
		CheckItem(menuHandle,iMame, GAME_VAL(wp,gameID)==rMame);
		CheckItem(menuHandle,iKome, GAME_VAL(wp,gameID)==rKome);
		CheckItem(menuHandle,iTume, GAME_VAL(wp,gameID)==rTume);
		CheckItem(menuHandle,iChoi, GAME_VAL(wp,gameID)==rChoi);
		CheckItem(menuHandle,iYori, GAME_VAL(wp,gameID)==rYori);
#endif
	}

	//other, setting menu
	menuHandle = GetMenuHandle(mOther);
	if(menuHandle != nil)
	{
#ifdef TARGET_API_MAC_CARBON
		EnableMenuItem(menuHandle, mOther_HiScore);
		EnableMenuItem(menuHandle, mOther_ResetMap);
		EnableMenuItem(menuHandle, mOther_Monkey);
		EnableMenuItem(menuHandle, mOther_Find);
	
		if(GAME_STATUS(wp, kGameStart))
			EnableMenuItem(menuHandle, mOther_ResetMap);
		else
			DisableMenuItem(menuHandle, mOther_ResetMap);

		if(GAME_VAL(wp, gameID)==rTume)
			EnableMenuItem(menuHandle, mOther_Solution);
		else
			DisableMenuItem(menuHandle, mOther_Solution);

		//when show solution for tumegame
		if((GAME_VAL(wp, gameID) == rTume)&&((GAME_VAL(wp, gameStatus) & kTumeSolution)!=0))
		{
			DisableMenuItem(menuHandle, mOther_ResetMap);
			DisableMenuItem(menuHandle, mOther_Find);
		}
#else
		EnableItem(menuHandle, mOther_HiScore);
		EnableItem(menuHandle, mOther_ResetMap);
		EnableItem(menuHandle, mOther_Monkey);
		EnableItem(menuHandle, mOther_Find);
	
		if(GAME_STATUS(wp, kGameStart))
			EnableItem(menuHandle, mOther_ResetMap);
		else
			DisableItem(menuHandle, mOther_ResetMap);

		if(GAME_VAL(wp, gameID)==rTume)
			EnableItem(menuHandle, mOther_Solution);
		else
			DisableItem(menuHandle, mOther_Solution);

		//when show solution for tumegame
		if((GAME_VAL(wp, gameID) == rTume)&&((GAME_VAL(wp, gameStatus) & kTumeSolution)!=0))
		{
			DisableItem(menuHandle, mOther_ResetMap);
			DisableItem(menuHandle, mOther_Find);
		}
#endif
	}
}

Boolean	isAppWindow(WindowPtr window)
{
	short	windowKind;

	if ( window == nil )
		return(false);
	else 
	{	// application windows have windowKinds = userKind (8)
#ifdef TARGET_API_MAC_CARBON
		windowKind = GetWindowKind(window);
		return(windowKind == kApplicationWindowKind);
#else
		windowKind = ((WindowPeek) window)->windowKind;
		return(windowKind == userKind);
#endif
	}
}


WindowPtr	findMyWindow(void)
{
	WindowPtr	theWindow = nil;

	Boolean	findIt = false;

	theWindow = FrontWindow();
	while((theWindow != nil)&&(! findIt))
	{
		if(isAppWindow(theWindow))
			findIt = true;
		if(!findIt)
			theWindow = GetNextWindow(theWindow);
	}

	if(!findIt)
		theWindow = nil;

	return(theWindow);
}

void	activateAppWindow(WindowPtr wp, Boolean becomingActive)
{
        if(wp == nil)
		return;
        
	if(becomingActive)
	{
#ifdef TARGET_API_MAC_CARBON
		SetPortWindowPort(wp);
#else
		SetPort(wp);
#endif
		hiliteWindowControls(wp, kEnableItem);
		adjustMenuButton(wp);
	}
	else
	{
		//de-activate application window
		hiliteWindowControls(wp, kDisableItem);
		GAME_VAL(wp, gameStatus) &= (kFlagFull-kShowTake);		//clear show takable flag
		closePiece(wp);
		setMyCursor(kArrowCURS);
	}

}

#pragma mark -

void	resetMap(void)
{
	WindowPtr	theWindow = nil;
#ifndef TARGET_API_MAC_CARBON	
	OSErr	iErr = noErr;
#endif
        
#ifdef TARGET_API_MAC_CARBON	
        RgnHandle visRgn;
#endif

	theWindow = findMyWindow();
	if(theWindow == nil)
		return;

	if(!GAME_STATUS(theWindow, kGameStart))		//game not start: now map is original
		return;

	setMyCursor(kArrowCURS);
	if(Alert(rAlertOriginalMap, nil) != ok)
		return;

	//back up data
	setUndoBuffer(theWindow);
	GAME_VAL(theWindow, canGameUndo) = false;

	//original map
	BlockMoveData(WIN_DATA(theWindow, mapDataOrg),WIN_DATA(theWindow, mapData),kMapMemorySize);
	GAME_VAL(theWindow, gameStatus) = kNoFlag;
	GAME_VAL(theWindow, score) = 0;
	GAME_VAL(theWindow, get) = 0;
	//
	setWindowDisplayParts(theWindow);
#ifdef TARGET_API_MAC_CARBON
        visRgn = NewRgn();
        GetPortVisibleRegion(GetWindowPort(theWindow), visRgn);
        InvalWindowRgn(theWindow, visRgn);
#else
	InvalRgn(theWindow->visRgn);
#endif
	//
	adjustMenuButton(theWindow);
}


void	setUndoBuffer(WindowPtr wp)
{
	BlockMoveData(WIN_DATA(wp, mapData),WIN_DATA(wp, mapData_bak),kMapMemorySize);
	BlockMoveData(WIN_DATA(wp, mapDataOrg),WIN_DATA(wp, mapDataOrg_bak),kMapMemorySize);
	WIN_DATA(wp, gv_bak) = WIN_DATA(wp, gv);

	GAME_VAL(wp, canGameUndo) = true;
}

void	doUndo(WindowPtr theWindow)
{
	Ptr	pNew;
	gameVal	tempVal;
        
#ifdef TARGET_API_MAC_CARBON	
        RgnHandle visRgn;
#endif

	if(theWindow == nil)
		return;

	if(!GAME_VAL(theWindow, canGameUndo))
		return;

	//undo game value
	tempVal = WIN_DATA(theWindow, gv_bak);
	WIN_DATA(theWindow, gv_bak) = WIN_DATA(theWindow, gv);
	WIN_DATA(theWindow, gv) = tempVal;

	//***********************
	//undo map
	//***********************
	//allocate memory
	pNew = NewPtr(kMapMemorySize);
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	//undo now map
	BlockMoveData(WIN_DATA(theWindow, mapData),pNew,kMapMemorySize);
	BlockMoveData(WIN_DATA(theWindow, mapData_bak),WIN_DATA(theWindow, mapData),kMapMemorySize);
	BlockMoveData(pNew,WIN_DATA(theWindow, mapData_bak),kMapMemorySize);
	//undo original map
	BlockMoveData(WIN_DATA(theWindow, mapDataOrg),pNew,kMapMemorySize);
	BlockMoveData(WIN_DATA(theWindow, mapDataOrg_bak),WIN_DATA(theWindow, mapDataOrg),kMapMemorySize);
	BlockMoveData(pNew,WIN_DATA(theWindow, mapDataOrg_bak),kMapMemorySize);
	//releace memory
	DisposePtr(pNew);

	setWindowDisplayParts(theWindow);
#ifdef TARGET_API_MAC_CARBON
        visRgn = NewRgn();
        GetPortVisibleRegion(GetWindowPort(theWindow), visRgn);
        InvalWindowRgn(theWindow, visRgn);
#else
	InvalRgn(theWindow->visRgn);
#endif
	
	adjustMenuButton(theWindow);
}

#pragma mark -

void	takePieceRec(WindowPtr wp, short x, short y)
{
	unsigned char	c;
	
	c = MAP_DATA(wp, x, y);

	if(c != WIN_DATA(wp, startCara))
		return;

	GAME_VAL(wp, get)++;

	//c |= kMapChecked;
	MAP_DATA(wp, x, y) = kMapBlank;
	
	takePieceRec(wp, x+1,y);	
	takePieceRec(wp, x-1,y);	
	takePieceRec(wp, x,y+1);	
	takePieceRec(wp, x,y-1);
}


Boolean	takePiece(WindowPtr wp, short x, short y)
{
	GrafPtr	savePort;
	Boolean	takeIt = false;
	unsigned long	score;

	if((x>GAME_VAL(wp,mapX))||(x<0))
		return(takeIt);

	if((y>GAME_VAL(wp,mapY))||(y<0))
		return(takeIt);

	//****************
	// check if the piece is takable
	//****************
	if((MAP_DATA(wp, x, y)&kMapCaraMask) == 0)		//now pos chara is not piece
		return(takeIt);

	//compare surroudings
	WIN_DATA(wp, startCara) = MAP_DATA(wp, x, y);		//save piece of now position

	if(WIN_DATA(wp, startCara) == MAP_DATA(wp, x,y+1))
		takeIt = true;
	else if(WIN_DATA(wp, startCara) == MAP_DATA(wp, x+1,y))
		takeIt = true;
	else if(WIN_DATA(wp, startCara) == MAP_DATA(wp, x, y-1))
		takeIt = true;
	else if(WIN_DATA(wp, startCara) == MAP_DATA(wp, x-1, y))
		takeIt = true;
	else
		return(takeIt);

	setMyCursor(rHandCloseCURS);	

	//first click since game start
	if(!GAME_STATUS(wp, kGameStart))
	{
		//game start flag
		GAME_VAL(wp, gameStatus) |= kGameStart;
	}

	GAME_VAL(wp, get) = 0;
	//back up now status
	setUndoBuffer(wp);
	//
	GetPort(&savePort);
        
#ifdef TARGET_API_MAC_CARBON
	SetPortWindowPort(wp);
#else
	SetPort(wp);
#endif
	
	takePieceRec(wp, x, y);
	closePiece(wp);

	score = (GAME_VAL(wp, get)-2)*(GAME_VAL(wp, get)-2);
	GAME_VAL(wp, score) = GAME_VAL(wp, score) + score;

	showScoreOnWindow(wp);

	SetPort(savePort);
	
	return(takeIt);
}

void	showTakablePiece(void)
{
	WindowPtr	wp = nil;
#ifndef TARGET_API_MAC_CARBON
	OSErr	iErr	= noErr;
#endif
	short	x,y;
	unsigned char		mapData;
	GrafPtr	savePort;
	Boolean	result;

	wp = findMyWindow();
	if(wp == nil)
		return;

	WIN_DATA(wp, clusterCount) = 0;

	GetPort(&savePort);
        
#ifdef TARGET_API_MAC_CARBON
	SetPortWindowPort(wp);
#else
	SetPort(wp);
#endif

	for(y = 1;y<=GAME_VAL(wp,mapY);y++)
	{
		for(x = 1;x<=GAME_VAL(wp,mapX);x++)
		{
			mapData = MAP_DATA(wp, x, y);
			if((mapData & kMapCaraMask) != 0){			//now pos chara is a piece
				mapData &= (unsigned char)kMapUnCheck;		//closed piece value
				result = false;
				if((MAP_DATA(wp, x+1,y)&kMapUnCheck) == mapData)
					result = true;
				else if((MAP_DATA(wp, x, y+1)&kMapUnCheck) == mapData)
					result = true;
				else if((MAP_DATA(wp, x-1,y)&kMapUnCheck) == mapData)
					result = true;
				else if((MAP_DATA(wp, x, y-1)&kMapUnCheck) == mapData)
					result = true;

				if(result)
				{
					mapData |= kMapChecked;
					MAP_DATA(wp, x, y) = mapData;
					drawOnePiece(wp, x, y, mapData);
				}				
			}
		}
	}
	GAME_VAL(wp, gameStatus) |= kShowTake;		//flag for showing takable piece
	showCluster(wp);

	SetPort(savePort);
}

void	packPiece(WindowPtr wp)
{
#ifndef TARGET_API_MAC_CARBON
	OSErr	iErr	=	noErr;
#endif
	short	x,y, z;

	//pack above
	for(x = 1;x<=GAME_VAL(wp,mapX);x++)
	{
		for(y = 1;y<=GAME_VAL(wp,mapY);y++)
		{
			if(( MAP_DATA(wp, x, y) & kMapCaraMask)==0)	//no piece
			{
				//find above piece
				for(z=y;((MAP_DATA(wp, x, z) & kMapCaraMask) == 0)&&z<=GAME_VAL(wp,mapY); z++)
					;
				//move piece
				if((MAP_DATA(wp, x, z) & kMapCaraMask) != 0)		//there is piece
				{
					MAP_DATA(wp, x, y) = MAP_DATA(wp, x, z);
					MAP_DATA(wp, x, z) = kMapBlank;
				}
				
			}
		}
	}

	//pack right column
	for(x = 1;x<=GAME_VAL(wp,mapX);x++)
	{
		if(( MAP_DATA(wp, x, 1) & kMapCaraMask)==0)	//no piece
		{	//find right column piece
			for(z=x;((MAP_DATA(wp, z, 1) & kMapCaraMask) == 0)&&z<=GAME_VAL(wp,mapX); z++)
				;
			//move piece
			if((MAP_DATA(wp, z, 1) & kMapCaraMask) != 0)		//there is piece
			{
				for(y = 1;y<=GAME_VAL(wp,mapY);y++)
				{
					MAP_DATA(wp, x, y) = MAP_DATA(wp, z, y);
					MAP_DATA(wp, z, y) = kMapBlank;
				}				
			}			
		}
	}

	//draw charactors
	for(y = 1;y<=GAME_VAL(wp,mapY);y++)
	{
		for(x = 1;x<=GAME_VAL(wp,mapX);x++)
		{
			if(MAP_DATA_PREV(wp, x, y) != MAP_DATA(wp, x, y))
			{
				drawOnePiece(wp,x,y,MAP_DATA(wp, x, y));
			}
		}
	}
	
	if(isGameEnding(wp))
		doGameEnding(wp);
	
}

#pragma mark -

void	openPieceRec(WindowPtr wp, short x, short y)
{
	unsigned char	c;
	
	c = MAP_DATA(wp, x, y);

	if(c != WIN_DATA(wp, startCara))
		return;

	c |= kMapChecked;
	MAP_DATA(wp, x, y) = c;

	drawOnePiece(wp, x, y, c );
	WIN_DATA(wp, clusterCount)++;

	openPieceRec(wp, x+1,y);	
	openPieceRec(wp, x-1,y);	
	openPieceRec(wp, x,y+1);	
	openPieceRec(wp, x,y-1);
}


Boolean	openPiece(WindowPtr wp, short x, short y)
{
	GrafPtr	savePort;
	Boolean	result = false;
	unsigned char		c;

	c = MAP_DATA(wp, x, y);
	if((c & kMapCaraMask) == 0)		//now pos chara is not piece
	{
		closePiece(wp);
		setMyCursor(kArrowCURS);
		return(result);
	}
	if((c & kMapChecked) != 0)		//now pos chara is  checked
	{
		return(result);
	}
	if((c & kMapChecked) == 0)		//now pos chara is not checked
	{
		closePiece(wp);
		setMyCursor(kArrowCURS);
	}

	WIN_DATA(wp, startCara) = c;
	if(c == MAP_DATA(wp, x,y+1))
		result = true;
	else if(c == MAP_DATA(wp, x+1,y))
		result = true;
	else if(c == MAP_DATA(wp, x, y-1))
		result = true;
	else if(c == MAP_DATA(wp, x-1, y))
		result = true;
	else
		return(result);

	WIN_DATA(wp, clusterCount) = 0;

	GetPort(&savePort);
        
#ifdef TARGET_API_MAC_CARBON
	SetPortWindowPort(wp);
#else
	SetPort(wp);
#endif
	
	openPieceRec(wp, x, y);

	setMyCursor(rHandOpenCURS);
	showCluster(wp);
	
	SetPort(savePort);
	
	return(result);
}

void	closePiece(WindowPtr wp)
{
#ifndef TARGET_API_MAC_CARBON
	OSErr	iErr	=	noErr;
#endif
	short	x,y;
	unsigned char		mapData;
	GrafPtr	savePort;

	if((GAME_VAL(wp, gameStatus) &kShowTake)!=0)				//showing takable piece
		return;

	WIN_DATA(wp, clusterCount) = 0;

	GetPort(&savePort);
        
#ifdef TARGET_API_MAC_CARBON
	SetPortWindowPort(wp);
#else
	SetPort(wp);
#endif

	for(y = 1;y<=GAME_VAL(wp,mapY);y++)
	{
		for(x = 1;x<=GAME_VAL(wp,mapX);x++)
		{
			mapData = MAP_DATA(wp, x, y);
			if((mapData &kMapChecked)!=0)							//if piece is open
			{
				MAP_DATA(wp, x, y) &= (unsigned char)kMapUnCheck;		//close it
				drawOnePiece(wp,x,y,MAP_DATA(wp, x, y));				//draw it
			}
		}
	}
	showCluster(wp);

	SetPort(savePort);

}

#pragma mark -

void	doMouseDownInMap(Point localPt, WindowPtr wp)
{
	short	x,y;
#ifndef TARGET_API_MAC_CARBON
	Boolean	isChecked = false;
#endif


	if(GAME_STATUS(wp, kGameEnd))
		return;

	if((GAME_VAL(wp, gameStatus) &kShowTake)!=0)				//showing takable piece
	{
		GAME_VAL(wp, gameStatus) &= (kFlagFull-kShowTake);		//clear show takable flag
		closePiece(wp);
		return;
	}

	//TumeGame Solusion
	if(showTumeSolution(wp))
		return;

	//calc map point from localPt
#ifdef TARGET_API_MAC_CARBON
	SetPortWindowPort(wp);
#else
	SetPort(wp);
#endif

	mouseToMapXY(wp, localPt, &x, &y);

	takePiece(wp, x,y);
	packPiece(wp);

	WIN_DATA(wp, drawIt) = true;
	WIN_DATA(wp, startY) = y;
	WIN_DATA(wp, drawY) = y;

}

void		doWindowNullEvent(WindowPtr wp)
{
	if(wp == nil)
		return;

	if(isApplicationFront())
	{
		doMousePosCheck();
		drawMaruCharacter(wp);
	}
	else
	{
	}
}

void	calculateMouseMovedRgn(WindowPtr wp, RgnHandle region)
{
	GrafPtr	savePort;
	Rect		theRect;
	Point		mouse;

	GetPort(&savePort);
        
#ifdef TARGET_API_MAC_CARBON
	SetPortWindowPort(wp);
#else
	SetPort(wp);
#endif

	GetMouse(&mouse);

	//set mouse moved region to 8x8 rectangle
	SetRect(&theRect,mouse.h-4,mouse.v-4,mouse.h+4,mouse.v+4);
	LocalToGlobal(&topLeft(theRect));
	LocalToGlobal(&botRight(theRect));
	RectRgn(region,&theRect);
	
	SetPort(savePort);	
}

void		checkPieceAndSetCursorShape(WindowPtr wp)
{
	GrafPtr	savePort;
	short	x,y;
	Point		mouse;

#ifdef TARGET_API_MAC_CARBON
        Rect portRect;
#endif

	if(Button())
		return;

	GetPort(&savePort);
#ifdef TARGET_API_MAC_CARBON
	SetPortWindowPort(wp);
#else
	SetPort(wp);
#endif

	GetMouse(&mouse);			//local coorinate

#ifdef TARGET_API_MAC_CARBON
        GetPortBounds(GetWindowPort(wp),&portRect);

	if(PtInRect(mouse,&portRect))
#else
	if(PtInRect(mouse,&(wp->portRect)))
#endif
	{
		mouseToMapXY(wp, mouse, &x, &y);
		//
		openPiece(wp,x,y);
	}
	else
	{
		closePiece(wp);
		setMyCursor(kArrowCURS);
	}
		
	SetPort(savePort);
}


void		doMousePosCheck(void)
{
	WindowPtr	wp;

	if(!isApplicationFront())
		return;

	wp = FrontWindow();
	if(wp == nil)
		return;

	if(!isAppWindow(wp))
		return;
	//don't change mouse shape, when TumeGame Solution Mode
	if((GAME_VAL(wp, gameStatus) & kTumeSolution) != 0)
		return;

	checkPieceAndSetCursorShape(wp);
}


#pragma mark -

void		mouseToMapXY(WindowPtr wp, Point mouse, short *x, short *y)
{
#ifdef TARGET_API_MAC_CARBON
        Rect portRect;
#endif

	*x = (mouse.h /GAME_VAL(wp,komaSize)) + 1;
	//*y = GAME_VAL(wp, mapY) - (mouse.v - WIN_DATA(wp, headerHeight))/GAME_VAL(wp,komaSize);

#ifdef TARGET_API_MAC_CARBON
        GetPortBounds(GetWindowPort(wp),&portRect);
	*y = (((portRect.bottom - portRect.top) - mouse.v)/GAME_VAL(wp,komaSize)) + 1;
#else
	*y = (((wp->portRect.bottom - wp->portRect.top) - mouse.v)/GAME_VAL(wp,komaSize)) + 1;
#endif

	if(*x< 0)
		*x = 0;
	if(*x > GAME_VAL(wp,mapX))
		*x = 0;

	if(*y< 0)
		*y = 0;
	if(*y > GAME_VAL(wp,mapY))
		*y = 0;

}

void		mapXYToPieceRect(WindowPtr wp, short x, short y, Rect *theRect)
{
#ifdef TARGET_API_MAC_CARBON
        Rect portRect;

        GetPortBounds(GetWindowPort(wp),&portRect);
	SetRect(theRect,(x-1)*GAME_VAL(wp, komaSize),(portRect.bottom - portRect.top)-y*GAME_VAL(wp, komaSize),
		x*GAME_VAL(wp, komaSize),(portRect.bottom - portRect.top)-(y-1)*GAME_VAL(wp, komaSize));

#else
	SetRect(theRect,(x-1)*GAME_VAL(wp, komaSize),(wp->portRect.bottom - wp->portRect.top)-y*GAME_VAL(wp, komaSize),
		x*GAME_VAL(wp, komaSize),(wp->portRect.bottom - wp->portRect.top)-(y-1)*GAME_VAL(wp, komaSize));
#endif
}