/*	doPreferences	*/

#include	"applicationGlobals.h"

#ifdef TARGET_API_MAC_CARBON
extern short	gAppRsrcFRefNum;	//application fRefNum
extern prefVal	gPrefVal;				//globals for pref
#endif

#define	kAppContinue		false
#define	kAppEnd			true
#define	kTimerWindLeft		40
#define	kTimerWindTop		80
#define	kTimerWIndRight	kTimerWindLeft + 200
#define	kTimerWIndBottom	kTimerWindTop + 100
#define	kResultWindowTime	3
#define	kAliasNum			0
#define	kIsAlias			0x8000

#define	kNotOK			1

//pascal	OSErr	SetDialogTrackCursor(DialogPtr theDialog, Boolean tracks)
//					={0x303C,0x0306,0xAA68};

Boolean	checkPrefVersion(short fRefNum);
void		pathNameFromDirID(long dirID, short vRefNum, Str255 fullPathName);
OSErr		readPreference(short fRefNum);
Boolean	checkQTVersion(long ver);
OSErr	deleteAllResource(short dstFRefNum);
Boolean	varidatePref(prefVal *pref);

//
//
//
//
OSErr	saveGlobalToPref(void)
{		//save gVal to pref file rsrc (already open as current)
	OSErr	iErr = noErr;
	Handle	hRsrc;
	//
	hRsrc = Get1Resource(myPrefData,kPrefDataID);
	if(hRsrc != nil)
	{
		RemoveResource(hRsrc);
		showOSError(nil,  errorResourceManager, ResError(), kFatal);
		DisposeHandle(hRsrc);
		showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	}
	hRsrc = NewHandle(sizeof(prefVal));
	if(hRsrc == nil)
		bigBadError(eAppMemSmall);
	HLock(hRsrc);
	*((prefVal *)(*hRsrc)) = gPrefVal ;
	HUnlock(hRsrc);
	AddResource(hRsrc,myPrefData,kPrefDataID,"\pPref");	
	showOSError(nil,  errorResourceManager, ResError(), kFatal);

	return(iErr);
}

Boolean	varidatePref(prefVal *pref)
{
	Boolean	result = true;
	
	if(pref->aimHSAvail < pref->aimHSSelect)
		result = false;

	return(result);
}

OSErr		readPreference(short fRefNum)
{	//caution: make sure the pref file is current
	OSErr	iErr = noErr;
	Handle	hRsrc;
	Boolean	isPrefOK = false;
	

	if(!checkPrefVersion(fRefNum))
	{
		isPrefOK = false;

		//alert "renewing preference file"
		alertTwoSeconds(rDLOG_PrefAlert_Renew,nil, nil, nil, nil);
	}
	else
	{
		//
		//read global data from preference
		//
		hRsrc = Get1Resource(myPrefData,kPrefDataID);
		if(hRsrc == nil)
			isPrefOK = false;
		else if(GetHandleSize((Handle)hRsrc) != sizeof(prefVal))
			isPrefOK = false;
		else
		{	
			HLock((Handle)hRsrc);
			gPrefVal = *((prefVal *)(*hRsrc));
			HUnlock((Handle)hRsrc);
			isPrefOK = varidatePref(&gPrefVal);
		}	


	}
	
	if(!isPrefOK)
	{
		//deleteAllResource(gPrefFRefNum);
		iErr	= copyResource(fRefNum,gAppRsrcFRefNum,'vers',1);
		iErr	= copyResource(fRefNum, gAppRsrcFRefNum, ftPICTFile, kKomaPICT);
		setInternalDefaultToGlogal();
		saveGlobalToPref();
	}

	//
	//varidate MENU data 
	//
	hRsrc = Get1Resource(kMENUType,mHiScoreName);
	if(hRsrc == nil)
	{
		copyResource(fRefNum, gAppRsrcFRefNum, kMENUType, mHiScoreName);
	}

#ifdef TARGET_API_MAC_CARBON
// copy string resource for Menu
#endif
	return(iErr);
}


#pragma mark -

Boolean	isApplicationFront(void)
{
	OSErr	iErr;
	ProcessSerialNumber	curPSN, frontPSN;
	Boolean	result = false;

	iErr = GetCurrentProcess(&curPSN);
	if(iErr == noErr)
		iErr = GetFrontProcess(&frontPSN);
	if(iErr == noErr)
		iErr = SameProcess(&curPSN,&frontPSN,&result);

	return(result);
}

Boolean	checkQTVersion(long ver)
{
	OSErr	iErr = noErr;
	long		version;

	iErr = Gestalt(gestaltQuickTimeVersion,&version);

	if( iErr != noErr)
		bigBadError(eWrongMachine);

	if (version >= ver )
		return( true );
	else
		return( false );
}

#pragma mark -

Boolean	checkPrefVersion(short fRefNum)
{
	OSErr	iErr = noErr;
	short	savedRefNum;
	Boolean	result = true;
	VersRecHndl	appVersH, prefVersH;

	savedRefNum = CurResFile();

	UseResFile(fRefNum);
	prefVersH = (VersRecHndl)Get1Resource( 'vers', 1 );
	iErr = ResError();
	if(iErr == noErr)
	{
		UseResFile(gAppRsrcFRefNum);
		appVersH = (VersRecHndl)Get1Resource( 'vers', 1 );
		//compare version
		if((**appVersH).numericVersion.nonRelRev != (**prefVersH).numericVersion.nonRelRev)
			result = false;
		if((**appVersH).numericVersion.stage != (**prefVersH).numericVersion.stage)
			result = false;
		if((**appVersH).numericVersion.minorAndBugRev != (**prefVersH).numericVersion.minorAndBugRev)
			result = false;
		if((**appVersH).numericVersion.majorRev != (**prefVersH).numericVersion.majorRev)
			result = false;		
		//
	}
	else
		result = false;

	UseResFile(savedRefNum);

	return(result);
}

short	openPreferenceFile(void)
{
	OSErr	iErr = noErr;
	short	fRefNum = kResFileNotOpened;		// -1
	short	foundVRefNum;
	long		foundDirID;
	Str255	fileName, theString;
	FInfo		fndrInfo;
	FSSpec	prefSpec;

	GetIndString(fileName,kAppStatement,kApp_PrefFileName);
	if(fileName[0]>63)
		fileName[0]=63;
		
	iErr = FindFolder(kOnSystemDisk,kPreferencesFolderType,kCreateFolder,&foundVRefNum,&foundDirID);
	showOSError(nil,  errorFileManager, iErr, kFatal);
	if(iErr==noErr)
	{
		iErr = FSMakeFSSpec(foundVRefNum,foundDirID,fileName,&prefSpec);		//FSMakeFSSpecCompat
		if(iErr==noErr)		
		{	//	if old pref file exist
			//
			iErr = FSpGetFInfo(&prefSpec,&fndrInfo);						//FSpGetFInfoCompat
			if(iErr == noErr)
			{
				if(fndrInfo.fdCreator != myCreator)
					bigBadError(eDupPrefName);
				fRefNum = FSpOpenResFile(&prefSpec, fsCurPerm);			//FSpOpenResFileCompat
				iErr = ResError();
				if(iErr != noErr)
					fRefNum = kResFileNotOpened;
			}
		}
		if(iErr!=noErr)		//if old pref file RF doesn't exist, make one
		{
			//
			FSpCreateResFile(&prefSpec,myCreator, kPrefType, smSystemScript);	//FSpCreateResFileCompat
			iErr = ResError();
			if(iErr == noErr)
			{
				
				fRefNum = FSpOpenResFile(&prefSpec,fsCurPerm);			//FSpOpenResFileCompat
				iErr = ResError();
				if(iErr != noErr)
					fRefNum = kResFileNotOpened;
			}
			if(iErr == noErr)
			{
				iErr	= copyResource(fRefNum,gAppRsrcFRefNum,FOUR_CHAR_CODE('vers'),1);
				UpdateResFile(fRefNum);

				//alert "making preference file in preference folder"
				GetIndString(theString,kAppStatement,kApp_PrefFileName);
				alertTwoSeconds(rDLOG_PrefAlert_New,theString, nil, nil, nil);
			}
			if(iErr == noErr)
				iErr = FlushVol(nil, foundVRefNum);
		}
	}

	return(fRefNum);
}

OSErr	closePreferences(short fRefNum)
{
	OSErr	iErr = noErr;
	short	foundVRefNum;
	long		foundDirID;
	
	CloseResFile(fRefNum);
	fRefNum = kResFileNotOpened;
	showOSError(nil,  errorResourceManager, ResError(), kFatal);
	
	iErr = FindFolder(kOnSystemDisk,kPreferencesFolderType,kCreateFolder,&foundVRefNum,&foundDirID);
	showOSError(nil,  errorFileManager, iErr, kFatal);
	iErr = FlushVol(nil,foundVRefNum);	
	showOSError(nil,  errorFileManager, iErr, kFatal);

	return(iErr);
}

OSErr	doPreferences(void)
{		//open and get preferences
	OSErr	iErr = noErr;
#ifndef TARGET_API_MAC_CARBON
	Boolean	isNewPref = true;
#endif
	short	fRefNum;
	
	//
	//setup some globals
	//
	gAppRsrcFRefNum = CurResFile();
	//
	//
//	if(!checkQTVersion(0x2500000))						//check QuickTime is over v2.5
//		bigBadError(eQuickTime);	
	//
	//open or create preference file
	//
	fRefNum = openPreferenceFile();			//make and copy 'vers'
	if(fRefNum != kResFileNotOpened)
	{
		iErr = readPreference(fRefNum);




		closePreferences(fRefNum);
	}
	else
		bigBadError(eWriteDisc);

	return(iErr);
}

#pragma mark -

OSErr setIndString(StringPtr theStr,short resID,short strIndex)
{
	Handle theRes;               /* handle pointing to STR# resource */
	short numStrings;            /* number of strings in STR# */
	short ourString;             /* counter to index up to strIndex */
	char *resStr;                /* string pointer to STR# string to replace */
	long oldSize;                /* size of STR# resource before call */
	long newSize;                /* size of STR# resource after call */
	unsigned long offset;        /* resource offset to str to replace*/

	/* make sure index is in bounds */
	if (resID < 1)
		return -1;

	/* make sure resource exists */
	theRes = GetResource('STR#',resID);
	if (ResError()!=noErr)
		return ResError();

	if (!theRes || !(*theRes))
		return resNotFound;
	
	HLock(theRes);
	HNoPurge(theRes);

	/* get # of strings in STR# */

	BlockMove(*theRes,&numStrings,sizeof(short));
	if (strIndex > numStrings)
		return resNotFound;

	/* get a pointer to the string to replace */

	offset = sizeof(short);
	resStr = (char *) *theRes + sizeof(short);
	for (ourString=1; ourString<strIndex; ourString++) 
	{
		offset += 1+resStr[0];	resStr += 1+resStr[0];
	}

	/* grow/shrink resource handle to make room for new string */
	oldSize = GetHandleSize(theRes);
	newSize = oldSize - resStr[0] + theStr[0];
	HUnlock(theRes);
	SetHandleSize(theRes,newSize);
	if (MemError()!=noErr) 
	{
		ReleaseResource(theRes);
		return -1;
	}
	HLock(theRes);
	resStr = *theRes + offset;

	/* move old data forward/backward to make room */

	BlockMove(resStr+resStr[0]+1, resStr+theStr[0]+1, (long)(oldSize-offset-resStr[0]-1));

	/* move new data in */

	BlockMove(theStr,resStr,theStr[0]+1);

	/* write resource out */

	ChangedResource(theRes);
	WriteResource(theRes);
	HPurge(theRes);
	ReleaseResource(theRes);

	return ResError();
}

DialogPtr	showMyDialog(short dlgRsrcID)
{
	DialogPtr	theDialog = nil;

	theDialog  = findDialog(dlgRsrcID);
	if(theDialog==nil)
		theDialog = createMyDialog(dlgRsrcID);
	
	return(theDialog);
}

void		waitSeconds(unsigned long waitSec)
{
	unsigned long	startSecs, secs;

	GetDateTime(&startSecs);	
	do
	{
		GetDateTime(&secs);
	}
	while((secs - startSecs) < waitSec);
}

void		alertTwoSeconds(short dlgRsrcID, Str255 param0, Str255 param1, Str255 param2, Str255 param3)
{
	DialogPtr	theDialog;
#ifdef TARGET_API_MAC_CARBON	
        RgnHandle visRgn;
#endif

	setMyCursor(kArrowCURS);

	theDialog = GetNewDialog(dlgRsrcID, nil, kMoveToFront);
	if ( theDialog == nil )
		showOSError(nil,  errorResourceManager, resNotFound, kFatal);
	ParamText(param0,param1,param2,param3);

#ifdef TARGET_API_MAC_CARBON
	ShowWindow(GetDialogWindow(theDialog));
	SelectWindow(GetDialogWindow(theDialog));
	
	BeginUpdate(GetDialogWindow(theDialog));
	DrawDialog(theDialog);
	EndUpdate(GetDialogWindow(theDialog));
#else
	ShowWindow(theDialog);
	SelectWindow(theDialog);
	
	BeginUpdate(theDialog);
	DrawDialog(theDialog);
	EndUpdate(theDialog);
#endif
	
#ifdef TARGET_API_MAC_CARBON
        visRgn = NewRgn();
        GetPortVisibleRegion(GetDialogPort(theDialog), visRgn);
        if(QDIsPortBuffered(GetDialogPort(theDialog)))
            QDFlushPortBuffer(GetDialogPort(theDialog), visRgn);
#endif
	waitSeconds(2);

	DisposeDialog(theDialog);
}

OSErr	copyOneRsrcType(short dstFRefNum, short srcFRefNum, ResType rType)
{
	OSErr	iErr	= noErr;
	short	savedRefNum;
	short	i, iCnt;
	ResType	rType2;
	short	rID;
	Str255	rName;
	
	savedRefNum = CurResFile();

	UseResFile(srcFRefNum);

	iCnt = Count1Resources(rType);
	for(i = 1;i <= iCnt; i++)
	{
		GetResInfo(Get1IndResource(rType,i),&rID,&rType2,rName);
		copyResource( dstFRefNum,  srcFRefNum,  rType,  rID);
	}

	UseResFile(savedRefNum);
	return(iErr);

}

OSErr	copyAllResource(short dstFRefNum, short srcFRefNum)
{
	OSErr	iErr	= noErr;
	short	savedRefNum;
	short	i, j, iCnt,iCnt2;
	ResType	rType, rType2;
	short	rID;
	Str255	rName;
	
	savedRefNum = CurResFile();

	UseResFile(srcFRefNum);
	iCnt = Count1Types();
	for(i = 1;i <= iCnt; i++)
	{
		Get1IndType(&rType,i);
		iCnt2 = Count1Resources(rType);
		for(j = 1;j <= iCnt2; j++)
		{
			GetResInfo(Get1IndResource(rType,j),&rID,&rType2,rName);
			copyResource( dstFRefNum,  srcFRefNum,  rType,  rID);
		}
	}

	UseResFile(savedRefNum);
	return(iErr);
}


OSErr	deleteAllResource(short dstFRefNum)
{
	OSErr	iErr	= noErr;
	short	savedRefNum;
	ResType	rType;
	Handle	hRsrc;
	
	savedRefNum = CurResFile();

	UseResFile(dstFRefNum);

	do
	{
		Get1IndType(&rType,1);
		do
		{
			hRsrc = Get1IndResource(rType,1);
			iErr = ResError();
			if(hRsrc != nil)
			{
				RemoveResource(hRsrc);
				showOSError(nil,  errorResourceManager, ResError(), kFatal);
				DisposeHandle(hRsrc);
				showOSError(nil,  errorMemoryManager, MemError(), kFatal);
			}
		}while(iErr == noErr);
	}while(rType != 0);

	UseResFile(savedRefNum);

	return(iErr);
}

OSErr	copyResource(short dstFRefNum, short srcFRefNum, ResType rType, short rID)
{
	Handle	hRsrc, dstRsrc;
	Str255	rName;
	short	savedRefNum;
	OSErr	iErr	= noErr;

	savedRefNum = CurResFile();

	UseResFile(srcFRefNum);
	showOSError(nil,  errorResourceManager, ResError(), kFatal);

	hRsrc = Get1Resource(rType,rID);
	showOSError(nil,  errorResourceManager, ResError(), kFatal);
	if(iErr == noErr)
	{
		GetResInfo(hRsrc,&rID,&rType,rName);
		//
		UseResFile(dstFRefNum);
		showOSError(nil,  errorResourceManager, ResError(), kFatal);
		dstRsrc = Get1Resource(rType,rID);
		showOSError(nil,  errorResourceManager, ResError(), kFatal);
		if(dstRsrc != nil)
		{
			RemoveResource(dstRsrc);
			showOSError(nil,  errorResourceManager, ResError(), kFatal);
			DisposeHandle(dstRsrc);
			showOSError(nil,  errorMemoryManager, MemError(), kFatal);
		}
		dstRsrc = hRsrc;
		iErr = HandToHand(&hRsrc);
		AddResource(hRsrc,rType,rID,rName);
		showOSError(nil,  errorResourceManager, ResError(), kFatal);
		UpdateResFile(dstFRefNum);
		showOSError(nil,  errorResourceManager, ResError(), kFatal);
	}

	UseResFile(savedRefNum);
	return(iErr);
}

short isPressed(unsigned short k )
{	// k =  any keyboard scan code, 0-127
	unsigned char km[16];

	GetKeys( (long *) km);
	return ( ( km[k>>3] >> (k & 7) ) & 1);
}

void		pathNameFromDirID(long dirID, short vRefNum, Str255 fullPathName)
{
	DirInfo	block;
	Str255	directoryName, s;
	OSErr	err;

	fullPathName[0] = '\0';

	block.ioDrParID = dirID;
	block.ioNamePtr = directoryName;
	do 
	{
		block.ioVRefNum = vRefNum;
		block.ioFDirIndex = -1;
		block.ioDrDirID = block.ioDrParID;
		err = PBGetCatInfo((CInfoPBPtr)&block, FALSE);
		copyString(s, directoryName);
		if (directoryName[1] != '/')
			catString(s, "\p/");
		catString(s, fullPathName);
		copyString(fullPathName, s);
	} while (block.ioDrDirID != 2);
}


