/*doSaveOpen.c*/

#include	"applicationGlobals.h"

#ifdef TARGET_API_MAC_CARBON
extern short	gAppRsrcFRefNum;	//application fRefNum
#endif

void		makeTempFileSpec(FSSpecPtr spec);
void		makeDefaultFileName(Str255 theTitle);

#ifdef TARGET_API_MAC_CARBON
extern WindowDataPtr getWindowDataPtr(WindowRef winodw);
extern DialogDataPtr getDialogDataPtr(DialogRef dialog);
Handle MyCreateOpenHandle(OSType theApplicationSignature, short theNumTypes, OSType *theTypeList);
#endif

void		makeTempFileSpec(FSSpecPtr spec)			//make tempFileName in the same dir of spec
{
	OSErr		iErr;
	Str255		tempBody, tempHead;
	FInfo			fndrInfo;
	unsigned long	secs;

	/*make dummy file name*/
	GetDateTime(&secs);
	//
	GetIndString(tempHead,kAppStatement,kApp_TempFileName);
	do{
		secs ++;
		NumToString((long)secs, tempBody);
		copyString(spec->name, tempHead);
		catString(spec->name, tempBody);
		iErr = FSpGetFInfo(spec,&fndrInfo);		//find file with tempFileName
	}while(iErr==noErr);						//if no file, tempFileName is used as temporal file name

}

void	makeDefaultFileName(Str255 theTitle)
{
	unsigned long	secs;
	Str255	theString;
	short	i;

	GetIndString(theString,kAppStatement,kApp_Delimiter);	//samegame - 
	catString(theTitle, theString);
	GetDateTime(&secs);
#ifdef TARGET_API_MAC_CARBON
	DateString((long)secs,shortDate,theString, NULL);				//samegame - 00.08.28
#else
	IUDateString((long)secs,shortDate,theString);				//samegame - 00.08.28
#endif
	catString(theTitle, theString);
	GetIndString(theString,kAppStatement,kApp_Delimiter);	//samegame - 00.08.28 - 
	catString(theTitle, theString);
#ifdef TARGET_API_MAC_CARBON
	TimeString((long)secs,false,theString, NULL);					//samegame - 00.08.28 - 12:00 AM
#else
	IUTimeString((long)secs,false,theString);					//samegame - 00.08.28 - 12:00 AM
#endif
	catString(theTitle, theString);

	//convert ':' to '.'
	for(i = 1; i <= theTitle[0]; i++)
	{
		if( theTitle[i] == ':')
			 theTitle[i] = '.';
	}
}

void	doSaveGame(void)
{
	WindowPtr	theWindow = nil;
	OSErr	iErr = noErr;
	short	savedRefNum, fRefNum = kResFileNotOpened;
	Str255	theTitle, theString;
#ifdef TARGET_API_MAC_CARBON
	OSErr		theErr = noErr;
        NavReplyRecord    theReply;
        NavDialogOptions dialogOptions;
#else
	StandardFileReply	reply;
#endif
	FSSpec	tempSpec;
	Boolean	isFileExist = false;

	theWindow = findMyWindow();
	if(theWindow == nil)
		return;

	//make default file name
	GetWTitle(theWindow,theTitle);						//samegame
	makeDefaultFileName(theTitle);
	//prompt for StandardPutFile dialog
	GetIndString(theString,kAppStatement,kApp_SaveFaleName);
#ifdef TARGET_API_MAC_CARBON
        theReply.validRecord = false;
	theErr = NavGetDefaultDialogOptions(&dialogOptions);
	PLstrcpy((StringPtr)&dialogOptions.savedFileName, theString);
	theErr = NavPutFile(NULL, &theReply, &dialogOptions, NULL, myCreator, myFileType, NULL);        
        if (theReply.validRecord && theErr == noErr)
        {
            FSSpec	finalFSSpec;	
            AEDesc 	resultDesc;	
            resultDesc.dataHandle = 0L;
                            
            if ((theErr = AEGetNthDesc(&(theReply.selection),1,typeFSS,NULL,&resultDesc)) == noErr)
            {
                BlockMoveData(*resultDesc.dataHandle,&finalFSSpec,sizeof(FSSpec));
                iErr = FSMakeFSSpec(finalFSSpec.vRefNum,finalFSSpec.parID,finalFSSpec.name,&tempSpec);
#else
	StandardPutFile(theString, theTitle,&reply);
	if(!reply.sfGood)
		return;
	iErr = FSMakeFSSpec(reply.sfFile.vRefNum,reply.sfFile.parID,reply.sfFile.name,&tempSpec);
#endif
	//check the file with the same name already exist
	if(iErr == noErr)
	{
		isFileExist = true;
	}
	else if(iErr == fnfErr)
	{
		isFileExist = false;
	}
	else
#ifdef TARGET_API_MAC_CARBON
		showOSError(finalFSSpec.name,  errorFileManager, iErr, kFatal);
#else
		showOSError(reply.sfFile.name,  errorFileManager, iErr, kFatal);
#endif
	//if exist, make tempFile
	if(isFileExist)
		makeTempFileSpec(&tempSpec);

	FSpCreateResFile(&tempSpec,myCreator,myFileType,smSystemScript);	//FSpCreateResFile
	showOSError(tempSpec.name,  errorResourceManager, ResError(), kFatal);
	//open temporal file
	savedRefNum = CurResFile();
	fRefNum = FSpOpenResFile(&tempSpec,fsCurPerm);					//FSpOpenResFile
	showOSError(tempSpec.name,  errorResourceManager, ResError(), kFatal);
	//
	saveNowGame(fRefNum);
	iErr	= copyResource(fRefNum,gAppRsrcFRefNum,'vers',1);
	//
	CloseResFile(fRefNum);
	fRefNum = kResFileNotOpened;
	iErr = FlushVol(nil,tempSpec.vRefNum);
	//
	UseResFile(savedRefNum);
	
	if(isFileExist)
	{
#ifdef TARGET_API_MAC_CARBON
		iErr = FSpExchangeFiles(&tempSpec,&finalFSSpec);
#else
		iErr = FSpExchangeFiles(&tempSpec,&(reply.sfFile));
#endif
		iErr = FSpDelete(&tempSpec);
	}
#ifdef TARGET_API_MAC_CARBON
                AEDisposeDesc(&resultDesc);
            }
	}
	NavDisposeReply(&theReply);
#endif
}

void	openGameFile(FSSpecPtr spec)
{
	short	savedRefNum;
	short	fRefNum;
	WindowPtr	wp;
	GrafPtr	savedPort;
        
#ifdef TARGET_API_MAC_CARBON
        Rect portRect;
#endif

	wp = findMyWindow();
	if(wp == nil)
		return;

	savedRefNum = CurResFile();

	fRefNum = FSpOpenResFile(spec,fsCurPerm);
	showOSError(spec->name,  errorResourceManager, ResError(), kFatal);
	UseResFile(fRefNum);
	showOSError(nil,  errorResourceManager, ResError(), kFatal);

	loadGameFromFile(wp);

	CloseResFile(fRefNum);
	fRefNum = kResFileNotOpened;
	UseResFile(savedRefNum);

	setWindowDisplayParts(wp);
	moveInsideMainScreen(wp);
	
	GetPort (&savedPort);
	SetPort (savedPort);
#ifdef TARGET_API_MAC_CARBON
        GetPortBounds(GetWindowPort(wp),&portRect);
        InvalWindowRect(wp, &portRect);
#else
	InvalRect (&wp->portRect);
#endif
	SetPort (savedPort);

}

void	doOpenGame(void)
{
#ifdef TARGET_API_MAC_CARBON
	OSErr		theErr = noErr;
        NavReplyRecord    theReply;
        NavDialogOptions dialogOptions;
	NavTypeListHandle	typeList = NULL;
	OSType        ostypeList[1] = { myFileType };

        theReply.validRecord = false;
        theErr = NavGetDefaultDialogOptions(&dialogOptions);

	typeList = (NavTypeListHandle)MyCreateOpenHandle(kNavGenericSignature,1,ostypeList);
        
	theErr = NavGetFile(NULL,	// use system's default location
				&theReply,
				&dialogOptions,
				NULL,
				NULL,	// no custom previews
				NULL,
				typeList,
				NULL);
        if (theReply.validRecord && theErr == noErr)
        {
            FSSpec	finalFSSpec;	
            AEDesc 	resultDesc;
            resultDesc.dataHandle = 0L;
                            
            if ((theErr = AEGetNthDesc(&(theReply.selection),1,typeFSS,NULL,&resultDesc)) == noErr)
            {
                if ((theErr = AEGetDescData ( &resultDesc, &finalFSSpec, sizeof ( FSSpec ) )) == noErr)
                    openGameFile(&finalFSSpec);
                AEDisposeDesc(&resultDesc);
            }
	}
	NavDisposeReply(&theReply);
#else
	OSErr	iErr = noErr;
	StandardFileReply	reply;
	short	numTypes;
	SFTypeList	typeList;
	
	typeList[0] = myFileType;
	numTypes = 1;
	StandardGetFile(nil,numTypes,typeList,&reply);

	if(!reply.sfGood)
		return;

	openGameFile(&(reply.sfFile));
#endif
}

#ifdef TARGET_API_MAC_CARBON
Handle 
MyCreateOpenHandle(
    OSType theApplicationSignature, 
    short  theNumTypes, 
    OSType *theTypeList
    )
{
    Handle myHandle = NULL;
    
    if (theTypeList == NULL)
        return(myHandle);
    
    if (theNumTypes > 0) {
        myHandle = NewHandle(sizeof(NavTypeList) + (theNumTypes * sizeof(OSType)));
        if (myHandle != NULL) {
            NavTypeListHandle myOpenResHandle = (NavTypeListHandle)myHandle;
            
            (*myOpenResHandle)->componentSignature = theApplicationSignature;
            (*myOpenResHandle)->osTypeCount = theNumTypes;
            BlockMoveData(theTypeList, (*myOpenResHandle)->osType, theNumTypes * sizeof(OSType));
        }
    }
    
    return(myHandle);
}
#endif