/*	*/
#include	"applicationGlobals.h"

void	eraseLeft(short rightLimit, short topPos);
void	writeScoreStringOnWindow(unsigned long theNum, short preStrID, short postStrID);

long	countOpenChara(WindowPtr theWindow, short *i);
void	moveToAlertPos(WindowPtr wp, Str255 theString, short tSize);

#ifdef TARGET_API_MAC_CARBON
extern WindowDataPtr getWindowDataPtr(WindowRef winodw);
extern DialogDataPtr getDialogDataPtr(DialogRef dialog);
#endif

void	drawMyWindow(WindowPtr theWindow)
{
	drawAllCharactersOnWindow(theWindow);
	showScoreOnWindow(theWindow);
	DrawControls(theWindow);
	showGameEndComment(theWindow);
}

void		drawMaruCharacter(WindowPtr wp)
{
	short	x;
	unsigned char		mapData;
	GrafPtr		savePort;

	if(WIN_DATA(wp, charaType) != fMaru)
		return;
	if(!WIN_DATA(wp, drawIt))
		return;

	GetPort(&savePort);
        
#ifdef TARGET_API_MAC_CARBON
	SetPortWindowPort(wp);
#else
	SetPort(wp);
#endif

	for(x = 1;x<=GAME_VAL(wp,mapX);x++)
	{
		mapData = MAP_DATA(wp, x, WIN_DATA(wp, drawY));
		if((mapData&kMapCaraMask) != 0)		//now pos chara is piece
			drawOnePiece(wp,x,WIN_DATA(wp, drawY), mapData);
	}

	WIN_DATA(wp, drawY) ++;
	if(WIN_DATA(wp, drawY) > GAME_VAL(wp,mapY))
		WIN_DATA(wp, drawY) = 1;

	if(WIN_DATA(wp, drawY) == WIN_DATA(wp, startY))
		WIN_DATA(wp, drawIt) = false;
	
	SetPort(savePort);

}

#pragma mark -

void	moveToAlertPos(WindowPtr wp, Str255 theString, short tSize)
{
	short	iWidth;
#ifdef TARGET_API_MAC_CARBON
        Rect portRect;
#endif
	
	iWidth = StringWidth(theString);

#ifdef TARGET_API_MAC_CARBON
        GetPortBounds(GetWindowPort(wp),&portRect);
	MoveTo((portRect.right - portRect.left)/2, (portRect.bottom - portRect.top)/2);
#else
	MoveTo((wp->portRect.right - wp->portRect.left)/2, (wp->portRect.bottom - wp->portRect.top)/2);
#endif
	Move(-iWidth/2, -tSize);

}
void	showGameEndComment(WindowPtr wp)
{
	Str255	theString;
	long		theNum;
	GrafPtr		savePort;
	PenState	savePnState;
	Style	saveFace;
	short	saveSize;
//	RGBColor	saveColor;
#ifdef TARGET_API_MAC_CARBON	
        RgnHandle visRgn;
#endif
	
	if(!GAME_STATUS(wp, kGameEnd))
		return;

	GetPort(&savePort);
#ifdef TARGET_API_MAC_CARBON
	SetPortWindowPort(wp);
#else
	SetPort(wp);
#endif
			
	GetIndString(theString,strGameEnding,strGameEnding_Size);
	StringToNum(theString, &theNum);
	//save current text setting
	GetPenState(&savePnState);
#ifdef TARGET_API_MAC_CARBON
	saveFace = GetPortTextFace(GetWindowPort(wp));
	saveSize = GetPortTextSize(GetWindowPort(wp));
#else
	saveFace = wp->txFace;
	saveSize = wp->txSize;
#endif
//	GetForeColor(&saveColor);
	//change setting
	TextSize((short)theNum);
	TextMode(srcOr);
	TextFace(bold);
	//
	if(GAME_VAL(wp, remain) == 0)
		GetIndString(theString,strGameEnding,strGameEnding_Perfect);	//perfect
	else
		GetIndString(theString,strGameEnding,strGameEnding_Normal);	//game end
	//
//	ForeColor(blackColor);
	TextFace(shadow);
	moveToAlertPos(wp, theString, (short)theNum);
	DrawString(theString);

#ifdef TARGET_API_MAC_CARBON
        visRgn = NewRgn();
        GetPortVisibleRegion(GetWindowPort(wp), visRgn);
        if(QDIsPortBuffered(GetWindowPort(wp)))
            QDFlushPortBuffer(GetWindowPort(wp), visRgn);
#endif
	//restore text setting
//	RGBForeColor(&saveColor);
	TextFace(saveFace);
	TextSize(saveSize);
	SetPenState(&savePnState);
	SetPort(savePort);
}

#pragma mark -

long	countCharactors(WindowPtr theWindow, long *cCount)
{	//return the count of remain piece
	long	remain = 0;
	long	x,y;

	cCount[1] = cCount[2] = cCount[3] = cCount[4] = cCount[5] = 0;

	for(y = 1;y<=GAME_VAL(theWindow,mapY);y++)
	{
		for(x = 1;x<=GAME_VAL(theWindow,mapX);x++)
		{
			cCount[MAP_DATA(theWindow, x, y)&kMapCaraMask]++;
			if((MAP_DATA(theWindow, x, y)&kMapCaraMask) != kMapBlank)
				remain ++;
		}
	}

	return(remain);
}

long	countOpenChara(WindowPtr theWindow, short *i)
{
	long	cOpen = 0;
	long	x,y;
	
	*i = 0;

	for(y = 1;y<=GAME_VAL(theWindow,mapY);y++)
	{
		for(x = 1;x<=GAME_VAL(theWindow,mapX);x++)
		{
			if((MAP_DATA(theWindow, x, y)&kMapChecked) != 0)
			{
				*i = (MAP_DATA(theWindow, x, y)&kMapCaraMask);
				cOpen ++;
			}
		}
	}

	return(cOpen);
}

#pragma mark -

void	eraseLeft(short rightLimit, short topPos)
{
	Point		penPt;
	Rect		dstRect;
	
	GetPen(&penPt);		//remenber pen position

	SetRect(&dstRect, penPt.h, topPos, rightLimit, topPos + kHeaderHeight);
	EraseRect(&dstRect);

}

void	writeScoreStringOnWindow(unsigned long theNum, short preStrID, short postStrID)
{
	Str255	theString;
	long tSize;
	
	if(preStrID!=shNull)
	{
		GetIndString(theString,strHeaderJ,shSize1J);
		StringToNum(theString, &tSize);
		TextSize((short)tSize);
		GetIndString(theString,strHeaderJ,preStrID);
		DrawString(theString);
	}

	GetIndString(theString,strHeaderJ,shSize2J);
	StringToNum(theString, &tSize);
	TextSize((short)tSize);
	NumToString((long)theNum,theString);
	DrawString(theString);

	if(postStrID!=shNull)
	{
		GetIndString(theString,strHeaderJ,shSize1J);
		StringToNum(theString, &tSize);
		TextSize((short)tSize);
		GetIndString(theString,strHeaderJ,postStrID);
		DrawString(theString);
	}

}

#pragma mark -

void	showCluster(WindowPtr theWindow)
{
	Str255	theString;
	Rect		srcRect, dstRect;
	Point		penPt;
	short	i = 1;
	long		cNum;

#ifdef TARGET_API_MAC_CARBON
        Rect portRect;
#endif	

	GrafPtr	savePort;

	GetPort(&savePort);
#ifdef TARGET_API_MAC_CARBON
	SetPortWindowPort(theWindow);
#else
	SetPort(theWindow);
#endif

	TextMode(srcCopy);
	MoveTo(WIN_DATA(theWindow, clusterH),WIN_DATA(theWindow, thumbTop)+kHeaderPosV);

	GetIndString(theString,strHeaderJ,shClusterJ);		//"Cluster"
	DrawString(theString);

	//show count of open piece
	if((GAME_VAL(theWindow, gameStatus)& kShowTake)!=0)		//showing takable piece
		cNum = 0;
	else
		cNum = countOpenChara(theWindow, &i);

	if(cNum>0)
	{
		//show icon
		GetPen(&penPt);
		SetRect(&dstRect,penPt.h,WIN_DATA(theWindow, thumbTop)+2,penPt.h+kHeaderThumbSize,WIN_DATA(theWindow, thumbTop)+kHeaderThumbSize+2);
		SetRect(&srcRect,(i-1)*kHeaderThumbSize,0,i*kHeaderThumbSize,kHeaderThumbSize);		//draw thumb nail
#ifdef TARGET_API_MAC_CARBON
		CopyBits((BitMap *)(*WIN_DATA(theWindow, scorePm)), GetPortBitMapForCopyBits(GetWindowPort(theWindow)), 
                                  &srcRect,&dstRect,srcCopy,nil);	
#else
		CopyBits((BitMap *)(*WIN_DATA(theWindow, scorePm)),&(theWindow->portBits),&srcRect,&dstRect,srcCopy,nil);
#endif
		MoveTo(dstRect.right,WIN_DATA(theWindow, thumbTop) + kHeaderPosV);				//show count of cluster
		//show number
		NumToString(cNum,theString);
		DrawString(theString);
	}
	else
	{
		GetIndString(theString,strHeaderJ,shNoCluster);		//no cluster "---"
		DrawString(theString);
	}

#ifdef TARGET_API_MAC_CARBON
        GetPortBounds(GetWindowPort(theWindow),&portRect);
	eraseLeft((portRect.right - portRect.left), WIN_DATA(theWindow, thumbTop));
#else
	eraseLeft((theWindow->portRect.right - theWindow->portRect.left), WIN_DATA(theWindow, thumbTop));
#endif

	SetPort(savePort);
}


void	showScoreOnWindow(WindowPtr theWindow)
{
	Str255	theString;
	Rect		srcRect, dstRect;
	Point		penPt;
	short	i;
	long		tPosition;
	long		remain;
	long		cCount[6];

#ifdef TARGET_API_MAC_CARBON
        Rect portRect;
#endif

	GrafPtr	savePort;

	GetPort(&savePort);
        
#ifdef TARGET_API_MAC_CARBON
	SetPortWindowPort(theWindow);
#else
	SetPort(theWindow);
#endif

	PenNormal();
	TextMode(srcCopy);
	//set pen position
	MoveTo(0, WIN_DATA(theWindow, scoreTop) + kHeaderPosV);
	//***********
	//score
	//***********
	//show count of get piece
	GetIndString(theString,strHeaderJ,shPosition);
	StringToNum(theString, &tPosition);
	eraseLeft((short)tPosition, WIN_DATA(theWindow, scoreTop));
	MoveTo(kHeaderGetH, WIN_DATA(theWindow, scoreTop) + kHeaderPosV);
	writeScoreStringOnWindow(GAME_VAL(theWindow, get), shGetJ, shNull);
	//show get points
	if(GAME_VAL(theWindow, get)>1)
		writeScoreStringOnWindow((GAME_VAL(theWindow, get)-2)*(GAME_VAL(theWindow, get)-2), shPoint1J, shPoint2J);
	else
		writeScoreStringOnWindow(0, shPoint1J, shPoint2J);
	//show total score
	writeScoreStringOnWindow(GAME_VAL(theWindow, score), shScore1J, shScore2J);
	//show remain count
	remain = countCharactors(theWindow, cCount);
	writeScoreStringOnWindow((unsigned long)remain, shRemain1J, shRemain2J);
	if(WIN_DATA(theWindow, scoreTop) != WIN_DATA(theWindow, thumbTop))
#ifdef TARGET_API_MAC_CARBON
        {
        GetPortBounds(GetWindowPort(theWindow),&portRect);

		eraseLeft((portRect.right - portRect.left), WIN_DATA(theWindow, scoreTop));
        }
#else
		eraseLeft((theWindow->portRect.right - theWindow->portRect.left), WIN_DATA(theWindow, scoreTop));
#endif
	//thumb nail picture
	eraseLeft(WIN_DATA(theWindow, thumbH), WIN_DATA(theWindow, thumbTop));
	TextSize(kHeaderThumbSize);
	SetRect(&dstRect,WIN_DATA(theWindow, thumbH),WIN_DATA(theWindow, thumbTop)+2,
		WIN_DATA(theWindow, thumbH) + kHeaderThumbSize,  WIN_DATA(theWindow, thumbTop)+kHeaderThumbSize+2);
	for(i = 1; i<=5; i++)
	{
		//draw thumb nail
		SetRect(&srcRect,(i-1)*kHeaderThumbSize,0,i*kHeaderThumbSize,kHeaderThumbSize);
#ifdef TARGET_API_MAC_CARBON
		CopyBits((BitMap *)(*WIN_DATA(theWindow, scorePm)), GetPortBitMapForCopyBits(GetWindowPort(theWindow)), 
                                  &srcRect,&dstRect,srcCopy,nil);	
#else
		CopyBits((BitMap *)(*WIN_DATA(theWindow, scorePm)),&(theWindow->portBits),&srcRect,&dstRect,srcCopy,nil);
#endif
		//draw each count
		MoveTo(dstRect.right,WIN_DATA(theWindow, thumbTop)+kHeaderPosV);
		NumToString(cCount[i],theString);
		if(cCount[i]>((GAME_VAL(theWindow, mapX)*GAME_VAL(theWindow, mapY)/20)*5))		// >5/20 blue string
			ForeColor(blueColor);
		if(cCount[i]>((GAME_VAL(theWindow, mapX)*GAME_VAL(theWindow, mapY)/20)*6))		// >6/20 red string
			ForeColor(redColor);
		DrawString(theString);
		ForeColor(blackColor);
		//move to next dstRect
		GetPen(&penPt);
		eraseLeft(penPt.h+4, WIN_DATA(theWindow, thumbTop));
		OffsetRect(&dstRect,penPt.h+4 - dstRect.left,0);
	}
	GetPen(&penPt);
	WIN_DATA(theWindow, clusterH) = penPt.h;
	//show cluster
	showCluster(theWindow);
	//eraseLeft(WIN_DATA(theWindow, winH));
	SetPort(savePort);
}
