
#ifndef TRAGET_API_MAC_CARBON
#define	_global
#endif

#include	"applicationGlobals.h"

#ifndef TRAGET_API_MAC_CARBON
#include <TextServices.h>
#endif

#define	kSysEnvironsVersion		1
#define	kMinHeap				(29 * 1024)
#define	KMAXLONG 			-1
#define	kNoEvents				0		// no events mask

#ifdef TARGET_API_MAC_CARBON
void setArrowCursor();
#else
static void checkForTextServices(void);
static Boolean isBitSet(long value, short bit);
#endif

#ifdef TARGET_API_MAC_CARBON
extern WindowDataPtr getWindowDataPtr(WindowRef winodw);
extern DialogDataPtr getDialogDataPtr(DialogRef dialog);
#endif

#ifdef TARGET_API_MAC_CARBON
short	gAppRsrcFRefNum;	//application fRefNum
prefVal	gPrefVal;		//globals for pref
Boolean	gDone;
short	gCursorCount;
unsigned long	gCursorTicks;
#endif

#ifdef TRAGET_API_MAC_CARBON
int main(void)
#else
void	main(void)
#endif
{
#ifndef TARGET_API_MAC_CARBON
	SetApplLimit(GetApplLimit() - 0x8000);	//expand stack for 32K
	if(MemError()!=noErr)
	{
		bigBadError(eAppMemSmall);
	}	
	MaxApplZone();
#endif
	MoreMasters(); 					// 64 more masters
	MoreMasters(); 					// 64 more masters
	initialize();
	doStart();

	eventLoop();

	doEnd();
	terminate();
        
#ifdef TARGET_API_MAC_CARBON
        return 0;
#endif
}

void initialize(void)
{
    Handle	menuBar;
#ifndef TARGET_API_MAC_CARBON
    EventRecord event;
    short	count;
#endif

#ifdef TRAGET_API_MAC_CARBON
    MenuRef	menu;
    long	response;
    OSErr	err;
    unsigned long randomSeed;

    FlushEvents(everyEvent,0);
#else
	InitGraf(&qd.thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(nil);
#endif
	InitCursor();

	installRequiredAppleEvent();		//install Apple Event:OpenDocument,OpenApp,Print,Quit
//	initDragAndDrop();

#ifdef TARGET_API_MAC_CARBON
        err = Gestalt(gestaltCarbonVersion, &response);
	if (( err != noErr ) || ( response < 0x110 ))
        {
            bigBadError(eWrongMachine);
        }
#endif
                
#ifndef TRAGET_API_MAC_CARBON
	for (count = 1; count <= 3; count++)
		EventAvail(everyEvent, &event);

	//check environment
	SysEnvirons(kSysEnvironsVersion, &gMac);	
	if (gMac.machineType < 0)
		bigBadError(eWrongMachine);
	gHasWaitNextEvent = trapAvailable(_WaitNextEvent, ToolTrap);
	if ((long) GetApplLimit() - (long) ApplicationZone() < kMinHeap)
		bigBadError(eAppMemSmall);
#endif

	//initialize menu bar
	menuBar = GetNewMBar(kMenuBarID);
	if ( menuBar == nil )
		bigBadError(eNoMemory);
	SetMenuBar(menuBar);
	DisposeHandle(menuBar);
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
        
#ifdef TRAGET_API_MAC_CARBON
        err = Gestalt(gestaltMenuMgrAttr, &response);
	if ((err == noErr) && (response & gestaltMenuMgrAquaLayoutMask))
        {
            menu = GetMenuHandle( mFile );
            DeleteMenuItem( menu, iQuit );
            DeleteMenuItem( menu, iQuitSeparator );
            
            DeleteMenuItem( menu, iSetting );
            DeleteMenuItem( menu, iSettingSeparator );
           
            EnableMenuCommand(NULL, kHICommandPreferences);            
        }
#endif

#ifndef TRAGET_API_MAC_CARBON
	AppendResMenu(GetMenuHandle(mApple), 'DRVR');	/* add DA names to Apple menu */	

	//prepare for inline input of dialog
	checkForTextServices();
	if (!(gHasTSMTE && InitTSMAwareApplication() == noErr))
	{
		// if this happens, just move on without text services
		gHasTextServices = false;
		gHasTSMTE = false;
	};
#endif

//	macigame doesn't use font menu
//
//	InsertMenu(GetMenu(mFont),hierMenu);
//	AddResMenu(GetMHandle(mFont),'FONT');
//	InsertMenu(GetMenu(mSize),hierMenu);

	DrawMenuBar();
        
	//randomize seed for random
#ifdef TRAGET_API_MAC_CARBON
	GetDateTime(&randomSeed);
        SetQDGlobalsRandomSeed(randomSeed);
#else
	GetDateTime((unsigned long*)(&qd.randSeed));
#endif
}

void		terminate(void)
{
#ifdef TRAGET_API_MAC_CARBON
    disposeAEEventHandler();

#else
	if (gHasTextServices)
		(void) CloseTSMAwareApplication();
#endif
}

void	eventLoop(void)
{
	RgnHandle	cursorRgn;
	Boolean		gotEvent;
	EventRecord	event;
	
	gDone = false;

	cursorRgn = NewRgn();

	while(!gDone){
#ifdef TRAGET_API_MAC_CARBON
		adjustCursor(cursorRgn);
                gotEvent = WaitNextEvent(everyEvent, &event, KMAXLONG, nil);
#else
		if ( gHasWaitNextEvent ) 
		{
			//gotEvent = WaitNextEvent(everyEvent, &event, KMAXLONG, nil);
			adjustCursor(cursorRgn);
			gotEvent = WaitNextEvent(everyEvent, &event, KMAXLONG, cursorRgn);
		}
		else 
		{
			SystemTask();
			gotEvent = GetNextEvent(everyEvent, &event);
		}
#endif
                
		if ( gotEvent ) 
		{
			//adjustCursor(event.where, cursorRgn);
			doEvent(&event);
		}
		else
		{
			//DoIdle();
			doNullEvent(&event);
		}
	}
}

void	doEvent(EventRecord *eventPtr)
{
	char	theChar;

	if ( IsDialogEvent(eventPtr) == true )
		doDialogEvent(eventPtr);
	else
	{
		switch(eventPtr->what)
		{
			case	kHighLevelEvent:
				AEProcessAppleEvent(eventPtr);
				break;
			case	mouseDown:
				doMouseDown(eventPtr);
				break;
			case mouseUp:
				break;
			case	keyUp:
				break;
			case	keyDown:
			case	autoKey:
				theChar = (char)(eventPtr->message & charCodeMask);
				if ((eventPtr->modifiers & cmdKey) != 0)
				{
					adjustMenus();	/* bring them up-to-date */
					doMenuCommand(MenuKey(theChar));
				}
				else
					doKeyDown((short)((eventPtr->message & keyCodeMask)>>8));
				break;
			case	updateEvt:
				doUpdate(eventPtr);
				break;
			case	osEvt:
				switch ((eventPtr->message >> 24) & 0x0FF)	// high byte of message
				{
					case mouseMovedMessage:
						doMousePosCheck();		//global coodinate
					break;
					case suspendResumeMessage:
						if((eventPtr->message & resumeFlag))
							resumeEvent();		//resume
						else
							suspendEvent();	//suspend
					break;
				}
				break;
			case	activateEvt:
				doActivate((WindowPtr)eventPtr->message,   ((eventPtr->modifiers & activeFlag) == activeFlag));
				break;
			case nullEvent:
				doNullEvent(eventPtr);
				break;
		}
	}
}

/*	HandleMouseDown	*/

void	doMouseDown(EventRecord *eventPtr)
{
	WindowPtr	whichWindow;
	short		thePart;

#ifdef TARGET_API_MAC_CARBON
        BitMap screenBits;
        Rect bounds;
#endif

	thePart = FindWindow(eventPtr->where, &whichWindow);
	switch (thePart)
	{
		case	inMenuBar:
			adjustMenus();	/* bring them up-to-date */
			doMenuCommand(MenuSelect(eventPtr->where));
			break;
		case	inSysWindow:
#ifndef TARGET_API_MAC_CARBON
			SystemClick(eventPtr, whichWindow);
#endif
			break;
		case	inDrag:
#ifdef TARGET_API_MAC_CARBON
                        GetQDGlobalsScreenBits(&screenBits);
                        bounds = screenBits.bounds;
			DragWindow(whichWindow, eventPtr->where, &bounds);
#else
			DragWindow(whichWindow, eventPtr->where, &qd.screenBits.bounds);
#endif
			break;
		case	inZoomIn:
		case	inZoomOut:
			SelectWindow(whichWindow);
			if(TrackBox(whichWindow, eventPtr->where, thePart))
				MoveWindow(whichWindow, kAppWindLeft, kAppWindTop, true);
			break;
		case	inContent:		
			// check to see if the user is starting a drag
	//		if (gDragAndDropAvailable && WaitMouseMoved(eventPtr->where))				
	//			// if so, do the drag magic
	//			doWindowContentDrag(whichWindow, eventPtr);				
			if (whichWindow != FrontWindow())
				SelectWindow(whichWindow);
			else
			{		
				SelectWindow(whichWindow);
#ifdef TARGET_API_MAC_CARBON
				SetPortWindowPort(whichWindow);
#else
				SetPort(whichWindow);
#endif
				GlobalToLocal(&eventPtr->where);
				doContentClick(eventPtr, whichWindow);
			}
			break;
		case inGrow:
			doInGrow(eventPtr, whichWindow);
			break;
		case inGoAway:
			if ( TrackGoAway(whichWindow, eventPtr->where) == true )
			{
				if(isDialogWindow(whichWindow))
#ifdef TARGET_API_MAC_CARBON
					disposeMyDialog(GetDialogFromWindow(whichWindow));
#else
					disposeMyDialog(whichWindow);
#endif
				//disposeMyWindow(whichWindow);
			}
			break;
	}
}

/*	HandleMenuChoice	*/

Boolean	doMenuCommand(long menuChoice)
{
	Boolean 	processDone = false;
	short	menu;
	short	item;
#ifndef TARGET_API_MAC_CARBON
	Str255	accName;
	short	accNumber;
#endif
	
	if (menuChoice != 0)
	{
		menu = HiWord(menuChoice);
		item = LoWord(menuChoice);
		
		switch (menu)
		{
			case	mApple:
				switch(item)
				{
					case	iAbout:
#ifdef TARGET_API_MAC_CARBON
						SelectWindow(GetDialogWindow(showMyDialog(rShowAbout)));
#else
						SelectWindow(showMyDialog(rShowAbout));
#endif
					break;
					case	iHelp:
						showModelessExplanationDLG();
					break;
					default:
#ifndef TARGET_API_MAC_CARBON
						GetMenuItemText(GetMenuHandle(mApple), item, accName);
						accNumber = OpenDeskAcc(accName);
#endif
					break;
				}
				break;
			case	mFile:
				processDone = doMenu_File(item);
				break;			
			case	mEdit:
				processDone = doMenu_Edit(item);
				break;
			case mGameType:
				doGameTypeMenu(item);
				break;
			case mOther:
				doOtherMenu(item);
				break;
		}
		HiliteMenu(0);
	}

	return(processDone);
}

/*	showAbout & help	*/

#ifndef TARGET_API_MAC_CARBON
short	showAbout(void)
{
	DialogPtr	dialog;
	Boolean	dialogDone = false;
	short	itemHit;
	
	dialog = GetNewDialog(rShowAbout, nil, kMoveToFront);
	if (dialog == nil)
		alertUser(eNoWindow);
	SetDialogDefaultItem(dialog,ok);
	SetDialogCancelItem(dialog,cancel);
//	SetDialogTrackCursor(dialog,true);
	ShowWindow((WindowPtr)dialog);
	SelectWindow((WindowPtr)dialog);	
	while(! dialogDone)
	{
		ModalDialog(nil, &itemHit);	
		
		switch(itemHit)
		{
			case	ok:
			case	cancel:
				dialogDone = true;
				break;
		}
	}
	
	DisposeDialog(dialog);

	return(itemHit);
}
#endif

void	resumeEvent(void)
{
#ifdef TARGET_API_MAC_CARBON
	WindowRef    	window;
#else
	CWindowRecord    *window;
#endif
	GrafPtr          saveport;

	GetPort(&saveport);
#ifdef TARGET_API_MAC_CARBON
	for(window=GetWindowList();window != NULL;window=GetNextWindow(window))
#else
	for(window=(CWindowRecord *)LMGetWindowList();window!=0;window=window->nextWindow)
#endif
	{
		//activate item on window and dialog
#ifdef TARGET_API_MAC_CARBON
		SetPortWindowPort(window);
		if(isDialogWindow(window))
			hiliteAllControls(GetDialogFromWindow(window), kEnableItem);
		else if(isAppWindow(window))
			activateAppWindow(window, true);
#else
		SetPort((GrafPtr)window);
		if(isDialogWindow((WindowPtr)window))
			hiliteAllControls((DialogPtr)window, kEnableItem);
		else if(isAppWindow((WindowPtr)window))
			activateAppWindow((WindowPtr)window, true);
#endif
	}
	SetPort(saveport);
	setMyCursor(kArrowCURS);
}

void	suspendEvent(void)
{
#ifdef TARGET_API_MAC_CARBON
	WindowRef    	window;
#else
	CWindowRecord    *window;
#endif
	GrafPtr          saveport;
	
	setMyCursor(kArrowCURS);

	GetPort(&saveport);
#ifdef TARGET_API_MAC_CARBON
	for(window=GetWindowList();window!=NULL;window=GetNextWindow(window))
#else
	for(window=(CWindowRecord *)LMGetWindowList();window!=0;window=window->nextWindow)
#endif
	{
		//de-activate item on window and dialog
#ifdef TARGET_API_MAC_CARBON
		SetPortWindowPort(window);
		if(isDialogWindow(window))
			hiliteAllControls(GetDialogFromWindow(window), kDisableItem);
		else if(isAppWindow(window))
			activateAppWindow(window, false);
#else
		SetPort((GrafPtr)window);
		if(isDialogWindow((WindowPtr)window))
			hiliteAllControls((DialogPtr)window, kDisableItem);
		else if(isAppWindow((WindowPtr)window))
			activateAppWindow((WindowPtr)window, false);
#endif
	}
	SetPort(saveport);
}

#ifndef TARGET_API_MAC_CARBON
static void checkForTextServices(void)
{
	long gestaltResponse;
	
	gHasTextServices = false;		// unless proven otherwise
	gHasTSMTE = false;				// unless proven otherwise
	
	if ((Gestalt(gestaltTSMgrVersion, &gestaltResponse) == noErr) && (gestaltResponse >= 1))
	{
		gHasTextServices = true;
		if (Gestalt(gestaltTSMTEAttr, &gestaltResponse) == noErr)
			gHasTSMTE = isBitSet(gestaltResponse, gestaltTSMTEPresent);
	}
}

static Boolean isBitSet(long value, short bit)
{
	long mask = 1L << bit;
	
	return ((value & mask) == mask);
}
#endif

#ifndef TARGET_API_MAC_CARBON
Boolean trapAvailable(unsigned short tNumber,TrapType tType)
{
	if ( ( tType == (unsigned char) ToolTrap ) &&
		( gMac.machineType > envMachUnknown ) &&
		( gMac.machineType < envMacII ) )	// it's a 512KE, Plus, or SE
	{
		tNumber = tNumber & 0x03FF;
		if ( tNumber > 0x01FF )					// which means the tool traps
			tNumber = _Unimplemented;			// only go to 0x01FF
	}
	return(NGetTrapAddress(tNumber, tType) != GetToolTrapAddress(_Unimplemented));
}
#endif

#pragma mark -

void	doActivate(WindowPtr wp, Boolean becomingActive)
{
	if(wp == nil)
		return;

	if(isDialogWindow(wp))
		;
	else if(isAppWindow(wp))
		activateAppWindow(wp, becomingActive);
}

void adjustMenus(void)
{
	MenuHandle	menuHandle;
	WindowPtr	pWindow;
	
	pWindow = FrontWindow();

	if(isAppWindow(pWindow))
	{
		adjustMenu4Window(pWindow);
	}
	else if (isDialogWindow(pWindow))
	{
		adjustMenu4Dialogs(pWindow);
	}

	//***************************
	//common for window and dialog
	//***************************
	//File Menu
	menuHandle = GetMenuHandle(mFile);
#ifdef TARGET_API_MAC_CARBON
	if(pWindow == GetDialogWindow(findDialog(rHiScoreDialog)))
		DisableMenuItem(menuHandle, iSetting);
	else
		EnableMenuItem(menuHandle, iSetting);
#else
	if(pWindow == findDialog(rHiScoreDialog))
		DisableItem(menuHandle, iSetting);
	else
		EnableItem(menuHandle, iSetting);
#endif
	//Other Menu
	menuHandle = GetMenuHandle(mOther);
#ifdef TARGET_API_MAC_CARBON
	if(pWindow == GetDialogWindow(findDialog(rHiScoreDialog)))
		DisableMenuItem(menuHandle, mOther_HiScore);
	else
		EnableMenuItem(menuHandle, mOther_HiScore);
	//
	CheckMenuItem(menuHandle,mOther_Monkey,gPrefVal.isMonkeyMode);
#else
	if(pWindow == findDialog(rHiScoreDialog))
		DisableItem(menuHandle, mOther_HiScore);
	else
		EnableItem(menuHandle, mOther_HiScore);
	//
	CheckItem(menuHandle,mOther_Monkey,gPrefVal.isMonkeyMode);
#endif

}

void	adjustFontMenu(WindowPtr window)
{
	#pragma unused(window)

}

void adjustCursor( RgnHandle region)
{	//mouse; global mouse
	//set cursor shape
	//calculate region: null event occur when cursor is out of region

	WindowPtr theWindow;
	Rect		theRect;
        
#ifdef TARGET_API_MAC_CARBON
        BitMap screenBits;
#endif

	//set up mouseMoved region
	if(region == nil)
		return;

	if(!isApplicationFront())
	{
#ifdef TARGET_API_MAC_CARBON
                GetQDGlobalsScreenBits(&screenBits);
                theRect = screenBits.bounds;
#else
		theRect = qd.screenBits.bounds;
#endif
		RectRgn(region,&theRect);
		return;
	}

	theWindow = FrontWindow();
	if(isAppWindow(theWindow))
	{	//when my window is front, calculate region for mouse moved event
		calculateMouseMovedRgn(theWindow, region);
	}
	else
	{	//when my window is not front, mouse moved event is not needed
#ifdef TARGET_API_MAC_CARBON
                GetQDGlobalsScreenBits(&screenBits);
                theRect = screenBits.bounds;
#else
		theRect = qd.screenBits.bounds;
#endif
		RectRgn(region,&theRect);
	}
}

void	doInGrow(EventRecord *eventPtr, WindowPtr whichWindow)
{
	long		windSize;
	GrafPtr	savedPort;
	Rect		sizeRect;
	Rect		oldWindowRect;
        
#ifdef TARGET_API_MAC_CARBON
        BitMap screenBits;

        GetQDGlobalsScreenBits(&screenBits);
	SetRect (&sizeRect, 250, 250,
		screenBits.bounds.right - screenBits.bounds.left,
		screenBits.bounds.bottom - screenBits.bounds.top);

	GetPortBounds(GetWindowPort(whichWindow),&oldWindowRect);
#else
	SetRect (&sizeRect, 250, 250,
		qd.screenBits.bounds.right - qd.screenBits.bounds.left,
		qd.screenBits.bounds.bottom - qd.screenBits.bounds.top);

	oldWindowRect = whichWindow->portRect;
#endif

	windSize = GrowWindow (whichWindow,eventPtr->where, &sizeRect);
	
	if (windSize)
	{
#ifdef TARGET_API_MAC_CARBON
                Rect rect;
#endif
		GetPort (&savedPort);
#ifdef TARGET_API_MAC_CARBON
		SetPortWindowPort(whichWindow);
                GetPortBounds(GetWindowPort(whichWindow),&rect);
		EraseRect (&rect);
		SizeWindow (whichWindow,LoWord (windSize),HiWord(windSize), true);

		InvalWindowRect (whichWindow, &rect);
#else        
		SetPort (whichWindow);
		EraseRect (&whichWindow->portRect);
		SizeWindow (whichWindow,LoWord (windSize),HiWord(windSize), true);

		InvalRect (&whichWindow->portRect);
#endif
		SetPort (savedPort);
	}

}

void	doUpdate(EventRecord *eventPtr)
{
	WindowPtr	wp;
	GrafPtr	savePort;

	GetPort(&savePort);
	wp = (WindowPtr)eventPtr->message;
        
#ifdef TARGET_API_MAC_CARBON	
	SetPortWindowPort(wp);
#else
	SetPort(wp);
#endif
	BeginUpdate(wp);

	if(isAppWindow(wp))
		drawMyWindow(wp);
	else if(isDialogWindow(wp))
#ifdef TARGET_API_MAC_CARBON	
		drawMyDialog(GetDialogFromWindow(wp));
#else
		drawMyDialog(wp);
#endif

	EndUpdate(wp);
	SetPort(savePort);
}

void	doContentClick(EventRecord *eventPtr, WindowPtr whichWindow)
{
//	#pragma unused(eventPtr,whichWindow )
	
	short		iCtlPart;
	ControlHandle	whichCtl;
	
	if(isAppWindow(whichWindow))
	{
#ifdef TARGET_API_MAC_CARBON	
		SetPortWindowPort(whichWindow);
#else
		SetPort(whichWindow);
#endif

		iCtlPart = FindControl(eventPtr->where, whichWindow, &whichCtl);
		if(iCtlPart==kControlButtonPart)
		{
			if(TrackControl(whichCtl,eventPtr->where,0)!=0)
			{
				handleWindowMenu(whichWindow, GetControlReference(whichCtl));
			}
		}
		else			
			doMouseDownInMap(eventPtr->where, whichWindow);

		adjustMenuButton(whichWindow);
	}
}

Boolean	doMenu_File(short item)
{
	Boolean	processDone = false;
	extern	Boolean	gDone;
	WindowPtr	theWindow;

	switch(item)
	{
		case	iNew:
			theWindow = findMyWindow();
			if(theWindow != nil)
			{
				GAME_VAL(theWindow, canGameUndo) = true;
				newGame(theWindow);
			}
		break;
		case	iClose:
			theWindow = FrontWindow();
			if(isDialogWindow(theWindow))
			{
#ifdef TARGET_API_MAC_CARBON	
				disposeMyDialog(GetDialogFromWindow(theWindow));
#else
				disposeMyDialog(theWindow);
#endif
				processDone = true;
			}
		break;
 		case	iOpen:
			doOpenGame();
		break;
		case	iSave:
			doSaveGame();
		break;
		case	iSetting:
#ifdef TARGET_API_MAC_CARBON	
			theWindow = GetDialogWindow(showMyDialog(rPrefDLG));
#else
			theWindow = showMyDialog(rPrefDLG);
#endif
			SelectWindow(theWindow);
		break;
		case	iQuit:
			gDone = true;
		break;
	}
	
	return(processDone);
}

Boolean	doMenu_Edit(short item)
{	
	Boolean 	processDone = false;
	WindowPtr	theWindow;

	theWindow = FrontWindow();
	
	
	if(theWindow == nil)
		return(processDone);
	
	if(isDialogWindow(theWindow))			//when theWindow is dialog
	{	
		HiliteMenu(mEdit);			
		switch ( item )
		{
			case	iUndo:
			break;
			case iCut:
#ifdef TARGET_API_MAC_CARBON 
				doCut(GetDialogFromWindow(theWindow));
#else                       
				doCut(theWindow);
#endif
				processDone = true;
			break;
			case iCopy:
#ifdef TARGET_API_MAC_CARBON
				doCopy(GetDialogFromWindow(theWindow));
#else
				doCopy(theWindow);
#endif
				processDone = true;
			break;
			case iPaste:
#ifdef TARGET_API_MAC_CARBON
				doPaste(GetDialogFromWindow(theWindow));
#else
				doPaste(theWindow);
#endif
				processDone = true;
			break;
			case iClear:
#ifdef TARGET_API_MAC_CARBON
				doClear(GetDialogFromWindow(theWindow));
#else
				doClear(theWindow);
#endif
				processDone = true;
			break;
		}
	}
	else if(isAppWindow(theWindow))
	{
		HiliteMenu(mEdit);			
		switch ( item )
		{
			case	iUndo:
				doUndo(theWindow);
			break;
			case iCut:
			break;
			case iCopy:
			//	putDigicameInfo2Scrap(theWindow);
			//	performedEdit = true;
			break;
			case iPaste:
			break;
			case iClear:
			break;
		}
	}

	return(processDone);
}

void	doMenu_Font(WindowPtr window,short menuItem)
{
	#pragma unused(window, menuItem)
}

void	doMenu_Size(WindowPtr window,short menuItem)
{
	#pragma unused(window, menuItem)
}

void	doKeyDown(short theKey)
{
	#pragma unused(theKey)
}

void	doNullEvent(EventRecord *eventPtr)
{
	WindowPtr	wp;

	wp = FrontWindow();
	while(wp != nil)
	{
#ifdef TARGET_API_MAC_CARBON
		if((GetWindowKind(wp) == kDialogWindowKind))
			doDialogNullEvent(eventPtr);
		else if((GetWindowKind(wp) == kApplicationWindowKind))
			doWindowNullEvent(wp);
#else
		if((((WindowPeek) wp)->windowKind == dialogKind))
			doDialogNullEvent(eventPtr);
		else if((((WindowPeek) wp)->windowKind == userKind))
			doWindowNullEvent(wp);
#endif
			
		wp = GetNextWindow(wp);
	}
	
	doMonkeyMode();
}

void	updateAllWindows(void)
{
#ifdef TARGET_API_MAC_CARBON
	WindowRef    window;
#else
	CWindowRecord    *window;
#endif
	GrafPtr          saveport;
	
	GetPort(&saveport);
#ifdef TARGET_API_MAC_CARBON
	for(window=GetWindowList();window!= NULL;window=GetNextWindow(window))
#else        
	for(window=(CWindowRecord *)LMGetWindowList();window!=0;window=window->nextWindow)
#endif
	{
#ifdef TARGET_API_MAC_CARBON
            Rect portRect;

	    SetPortWindowPort(window);            
            GetPortBounds(GetWindowPort(window),&portRect);
	    InvalWindowRect(window, &portRect);
#else
	    SetPort((GrafPtr)window);            
            InvalRect(&(((GrafPtr)window)->portRect));
#endif
	}
	SetPort(saveport);
}



#pragma mark -

OSErr	setMyCursor(short rID)
{
	CursHandle	cursH;
	Cursor		cursRec;
	OSErr		iErr = noErr;
        
	if(rID == kArrowCURS)
#ifdef TARGET_API_MAC_CARBON
                setArrowCursor();
#else
		SetCursor(&qd.arrow);
#endif
	else
	{
		cursH = GetCursor( rID );
		HLock ((Handle) cursH);
		cursRec = **cursH;				/* copy the data */
		HUnlock ((Handle) cursH);
		SetCursor( &cursRec );
	}
	
	return(iErr);
}

void alertUser(short error)
{
	short		itemHit;
	Str255		message;

	setMyCursor(kArrowCURS);
	GetIndString(message, kErrStrings, error);
	ParamText(message, nil, nil, nil);
	itemHit = Alert(rUserAlert, nil);
}

void bigBadError(short error)
{
	alertUser(error);
	ExitToShell();
}

void getGlobalMouse(Point *mouse)
{
	EventRecord	event;
        
#ifdef TARGET_API_MAC_CARBON
        EventAvail(kNoEvents, &event);		// not interested in any events
#else
        OSEventAvail(kNoEvents, &event);		// not interested in any events
#endif
	*mouse = event.where;				//just the mouse position
}

void	animateCursor(void)
{
	short		cursorID;
	unsigned long	lTicks;
	Cursor		cursRec;
	CursHandle	cursH;

	lTicks = TickCount();
	lTicks /= 30;
	//GetDateTime(&secs);

	if(lTicks == gCursorTicks)
		return;

	gCursorTicks = lTicks;

	gCursorCount ++;
	gCursorCount %=4;
	cursorID = gCursorCount + 128;

	//draw cursor
	cursH = GetCursor( cursorID );
	if(cursH != nil)
	{
		HLock ((Handle) cursH);
		cursRec = **cursH;				/* copy the data */
		HUnlock ((Handle) cursH);
		SetCursor( &cursRec );
	}
}

void	catString(Str255 destStr,Str255 srcStr)
{
	unsigned char	byteCount;

	byteCount = srcStr[0];
	if((destStr[0] + srcStr[0]) >255)
		byteCount = (unsigned char)(255 - destStr[0]);

	BlockMoveData(srcStr+1,destStr + destStr[0]+1,(Size)byteCount);
	destStr[0] += byteCount;
}

void	copyString(Str255 destStr,Str255 srcStr)
{
	BlockMoveData(srcStr,destStr,srcStr[0]+1);
}

#ifdef TARGET_API_MAC_CARBON
void setArrowCursor()
{
    Cursor arrow;
    
    GetQDGlobalsArrow(&arrow);
    SetCursor(&arrow);
}
#endif