/*	doSetting	*/

#include	"applicationGlobals.h"

#ifdef TARGET_API_MAC_CARBON
extern prefVal	gPrefVal;				//globals for pref
#endif

void		saveWindowPosition(void);
void		savePtrToResource(Ptr srcDataPtr, long dataSize, ResType rType, short rID, ConstStr255Param rName);
Boolean	checkDataSize(ResType rType, short rID, long dataSize);
void		loadResourceToPtr(ResType rType, short rID, Ptr dstDataPtr);

#ifdef TARGET_API_MAC_CARBON
WindowDataPtr getWindowDataPtr(WindowRef winodw);
void setWindowDataPtr(WindowRef winodw, Ptr ptr);
DialogDataPtr getDialogDataPtr(DialogRef dialog);
void setDialogDataPtr(DialogRef dialog, Ptr ptr);
#endif

void		loadResourceToPtr(ResType rType, short rID, Ptr dstDataPtr)
{
	Handle	hRsrc;

	hRsrc = Get1Resource(rType, rID);
	HLock(hRsrc);
	BlockMoveData(*hRsrc, dstDataPtr, GetHandleSize(hRsrc));
	HUnlock(hRsrc);
}


void		savePtrToResource(Ptr srcDataPtr, long dataSize, ResType rType, short rID, ConstStr255Param rName)
{
	Handle	hRsrc;
	OSErr	iErr = noErr;

	hRsrc = Get1Resource(rType, rID);
	if(hRsrc != nil)
	{
		RemoveResource(hRsrc);
		showOSError(nil,  errorResourceManager, ResError(), kFatal);
		DisposeHandle(hRsrc);
		showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	}
	iErr = PtrToHand(srcDataPtr, &hRsrc, dataSize);
	showOSError(nil,  errorMemoryManager, iErr, kFatal);
	AddResource(hRsrc, rType, rID, rName);
	showOSError(nil,  errorResourceManager, ResError(), kFatal);
}

Boolean	checkDataSize(ResType rType, short rID, long dataSize)
{
	Boolean	result = true;
	Handle	hRsrc;

	hRsrc = Get1Resource(rType, rID);
	if(hRsrc == nil)	
		result = false;
	else
	{
		if(GetHandleSize(hRsrc) != dataSize)
			result = false;
	}

	return(result);
}

#pragma mark -

Handle	getHiScore(short gameID, ResType scoreType)
{
	Handle	hRsrc = nil;
	Boolean	makeIt = false;

	//
	hRsrc = Get1Resource(scoreType, gameID);
	if(hRsrc == nil)
		makeIt = true;
	else if(GetHandleSize(hRsrc) != sizeof(scoreVal)*(kRankMax+1))
		makeIt = true;

	if(makeIt)
	{
		saveHiScoreToPref(scoreType, gameID, nil);
		hRsrc = Get1Resource(scoreType,gameID);
		if(hRsrc == nil)
			showOSError(nil,  errorResourceManager, ResError(), kFatal);
	}
	//

	return(hRsrc);
}

OSErr	saveHiScoreToPref(ResType scoreType, short gameID, Ptr theScorePtr)
{
	OSErr	iErr = noErr;
	Handle	hRsrc;
#ifndef TARGET_API_MAC_CARBON
	short	prefFlag = ok;
#endif
	Size		lByteCnt;
	short	i;

	//delete pre existing rsrc
	hRsrc = Get1Resource(scoreType,gameID);
	if(hRsrc != nil)
	{
		RemoveResource(hRsrc);
		showOSError(nil,  errorResourceManager, ResError(), kFatal);
		DisposeHandle(hRsrc);
		showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	}
	//create handle
	if(theScorePtr == nil)
	{
		hRsrc = NewHandleClear(sizeof(scoreVal)*(kRankMax+1));
		if(hRsrc == nil)
			bigBadError(eAppMemSmall);
		HLock(hRsrc);
		for(i=1; i<=kRankMax;i++)
		{
			SCORE_VAL(hRsrc, i, remain) = kRemainMax;
		}
		HUnlock(hRsrc);
	}
	else
	{
		lByteCnt = GetPtrSize(theScorePtr);
		iErr = PtrToHand(theScorePtr,&hRsrc,lByteCnt);
		showOSError(nil,  errorMemoryManager, iErr, kFatal);
	}
	//change handle to rsrc
	AddResource(hRsrc,scoreType,gameID,"\p");	
	showOSError(nil,  errorResourceManager, ResError(), kFatal);
	WriteResource(hRsrc);
	showOSError(nil,  errorResourceManager, ResError(), kFatal);

	return(iErr);
}

#pragma mark -

Boolean	loadGameFromFile(WindowPtr wp)
{
	Boolean	result = false;

	//check data size
	if(!checkDataSize(kGameDataType, kGameValue, sizeof(gameVal)))
		return(result);
	if(!checkDataSize(kGameDataType, kGameValue_bak, sizeof(gameVal)))
		return(result);
	if(!checkDataSize(kGameDataType, kMapData, kMapMemorySize))
		return(result);
	if(!checkDataSize(kGameDataType, kMapData_bak, kMapMemorySize))
		return(result);
	if(!checkDataSize(kGameDataType, kMapDataOrg, kMapMemorySize))
		return(result);
	if(!checkDataSize(kGameDataType, kMapDataOrg_bak, kMapMemorySize))
		return(result);
	//size is OK
	result = true;
	//read gameVal
	loadResourceToPtr(kGameDataType, kGameValue, (Ptr)&WIN_DATA(wp, gv));
	loadResourceToPtr(kGameDataType, kGameValue_bak, (Ptr)&WIN_DATA(wp, gv_bak));
	//read map
	loadResourceToPtr(kGameDataType, kMapData, WIN_DATA(wp, mapData));
	loadResourceToPtr(kGameDataType, kMapData_bak, WIN_DATA(wp, mapData_bak));
	loadResourceToPtr(kGameDataType, kMapDataOrg, WIN_DATA(wp, mapDataOrg));
	loadResourceToPtr(kGameDataType, kMapDataOrg_bak, WIN_DATA(wp, mapDataOrg_bak));
	//	
	return(result);
}


void		saveNowGame(short dstFRefNum)
{
	WindowPtr	theWindow = nil;
#ifndef TARGET_API_MAC_CARBON
	OSErr	iErr = noErr;
#endif
	short	savedRefNum;

	theWindow = findMyWindow();
	if(theWindow == nil)
		return;

	savedRefNum = CurResFile();
	UseResFile(dstFRefNum);
	showOSError(nil,  errorResourceManager, ResError(), kFatal);
	//save game value
	savePtrToResource((Ptr)&WIN_DATA(theWindow, gv), sizeof(gameVal), kGameDataType, kGameValue, "\pPlaying Value");
	savePtrToResource((Ptr)&WIN_DATA(theWindow, gv_bak), sizeof(gameVal), kGameDataType, kGameValue_bak, "\pPlaying Value bak");
	//save  map
	savePtrToResource(WIN_DATA(theWindow, mapData), kMapMemorySize, kGameDataType, kMapData, "\pMap");
	savePtrToResource(WIN_DATA(theWindow, mapData_bak), kMapMemorySize, kGameDataType, kMapData_bak, "\pMap Bak");
	savePtrToResource(WIN_DATA(theWindow, mapDataOrg), kMapMemorySize, kGameDataType, kMapDataOrg, "\pOriginal");
	savePtrToResource(WIN_DATA(theWindow, mapDataOrg_bak), kMapMemorySize, kGameDataType, kMapDataOrg_bak, "\pOriginal Bak");
	//
	UpdateResFile(dstFRefNum);
	UseResFile(savedRefNum);
}

void		moveInsideMainScreen(WindowPtr theWindow)
{
	Rect		theRect;
	Point		thePoint;

#ifdef TARGET_API_MAC_CARBON
        BitMap screenBits;
        Rect portRect;

        GetPortBounds(GetWindowPort(theWindow), &portRect);
#endif

	//move inside the main screen
	//theRect = qd.screenBits.bounds;
	
	//move into multi monitor
#ifdef TARGET_API_MAC_CARBON
	theRect = GetQDGlobalsScreenBits(&screenBits)->bounds;
#else
	theRect = (**GetGrayRgn ()).rgnBBox; 
#endif

	//menu bar
#ifdef TARGET_API_MAC_CARBON
	theRect.top += GetMBarHeight()*2;
#else
	theRect.top += LMGetMBarHeight()*2;
#endif
	
	InsetRect(&theRect,8,8);
	thePoint = topLeft(gPrefVal.windowPos);
	if(gPrefVal.windowPos.right<theRect.left)		//over left
		thePoint.h = theRect.left ;
	if(gPrefVal.windowPos.left>theRect.right)		//over right
#ifdef TARGET_API_MAC_CARBON
		thePoint.h = theRect.right - (portRect.right - portRect.left);
#else
		thePoint.h = theRect.right - (theWindow->portRect.right - theWindow->portRect.left);
#endif
	if(gPrefVal.windowPos.top>theRect.bottom)	//
#ifdef TARGET_API_MAC_CARBON
		thePoint.v = theRect.bottom - (portRect.bottom - portRect.top);
#else
		thePoint.v = theRect.bottom - (theWindow->portRect.bottom - theWindow->portRect.top);
#endif
	if(gPrefVal.windowPos.top<theRect.top)
		thePoint.v = theRect.top;

	MoveWindow(theWindow,thePoint.h,thePoint.v,false);
}

void		saveWindowPosition(void)
{
        
	WindowPtr	theWindow = nil;
#ifdef TARGET_API_MAC_CARBON
        Rect portRect;
#else
	OSErr	iErr = noErr;
#endif

	theWindow = findMyWindow();
	if(theWindow == nil)
		return;

#ifdef TARGET_API_MAC_CARBON
	SetPortWindowPort(theWindow);
        GetPortBounds(GetWindowPort(theWindow),&portRect);
	gPrefVal.windowPos = portRect;
#else
	SetPort(theWindow);
	gPrefVal.windowPos = theWindow->portRect;
#endif
	LocalToGlobal(&topLeft(gPrefVal.windowPos));
	LocalToGlobal(&botRight(gPrefVal.windowPos));

	saveGlobalToPref();
}

#pragma mark -

void		doStart(void)
{
	WindowPtr	theWindow;
	short		fRefNum;
	short		savedRefNum;
	Boolean		result;

	savedRefNum = CurResFile();

	theWindow = createGameWindow();

	doPreferences();
	setupDefaultData(theWindow);
	
	fRefNum = openPreferenceFile();
	if(fRefNum != kResFileNotOpened)
	{
		result = loadGameFromFile(theWindow);
		closePreferences(fRefNum);
	}
	
	if(result)
	{
		setWindowDisplayParts(theWindow);
		moveInsideMainScreen(theWindow);
	}
	else
	{
		setWindowDisplayParts(theWindow);
		newGame(theWindow);
	}

	readHiScoreDataToWindowRec(GAME_VAL(theWindow, gameID), theWindow);
	GAME_VAL(theWindow, canGameUndo) = false;

	ShowWindow(theWindow);
	SelectWindow(theWindow);
}

void		doEnd(void)
{
	short fRefNum;

	fRefNum = openPreferenceFile();
	if(fRefNum != kResFileNotOpened)
	{
		saveWindowPosition();
		saveNowGame(fRefNum);	
		closePreferences(fRefNum);
	}
}

#pragma mark -


OSErr	savePICT2Pref(PicHandle	hPic)
{
	OSErr	iErr = noErr;
	Handle	hRsrc;
	short	fRefNum = kResFileNotOpened;
	
	fRefNum = openPreferenceFile();
	if(fRefNum != kResFileNotOpened)
	{
		//check the picture in preference file
		hRsrc = Get1Resource(ftPICTFile,kKomaPICT);
		if(hRsrc != nil)
		{	//if there is picture, delete it
			RemoveResource(hRsrc);
			showOSError(nil,  errorResourceManager, ResError(), kFatal);
			DisposeHandle(hRsrc);
			showOSError(nil,  errorMemoryManager, MemError(), kFatal);
		}
		hRsrc = (Handle)hPic;
		iErr = HandToHand(&hRsrc);
		if(iErr != noErr)
			bigBadError(eAppMemSmall);
		AddResource(hRsrc,ftPICTFile,kKomaPICT,"\pKoma");
		showOSError(nil,  errorResourceManager, ResError(), kFatal);
		closePreferences(fRefNum);
	}

	return(iErr);
}

void	setupDefaultData(WindowPtr wp)
{	//preference file must open
	//
	OSErr	iErr = noErr;
	PicHandle	hPic = nil;
	short	fRefNum = kResFileNotOpened;
	
	//
	GAME_VAL(wp, gameID) = rSame; 	
	setGameBoardSize(wp);
	GAME_VAL(wp,komaSize) = (short)kIconSize;
	//
	//check the picture data in preference file
	//
	fRefNum = openPreferenceFile();
	if(fRefNum != kResFileNotOpened)
	{
		//read koma PICT
		hPic = (PicHandle)Get1Resource(ftPICTFile,kKomaPICT);
		closePreferences(fRefNum);
	}
	//if there is no picture data in preference, duplicate picture from application recource
	if(hPic == nil)
	{
		hPic = GetPicture(kKomaPICT);
		iErr = savePICT2Pref(hPic);
	}

}


void	moveCenterOfMainScreen(WindowPtr theWindow)
{
	Rect	theRect;
	short	newH, newV;

#ifdef TARGET_API_MAC_CARBON
        BitMap screenBits;
        Rect portRect;
#endif
	
#ifdef TARGET_API_MAC_CARBON
        GetQDGlobalsScreenBits(&screenBits);
        theRect = screenBits.bounds;
        GetPortBounds(GetWindowPort(theWindow), &portRect);

	newH = ((theRect.right - theRect.left) - (portRect.right - portRect.left))/2;
	newV = ((theRect.bottom - theRect.top)- (portRect.bottom - portRect.top))/2;

	if(newV < GetMBarHeight()*2)
		newV = GetMBarHeight()*2;
#else
	theRect = qd.screenBits.bounds;

	//theRect.top += LMGetMBarHeight();
	
	newH = ((theRect.right - theRect.left) - (theWindow->portRect.right - theWindow->portRect.left))/2;
	newV = ((theRect.bottom - theRect.top)- (theWindow->portRect.bottom - theWindow->portRect.top))/2;

	if(newV < LMGetMBarHeight()*2)
		newV = LMGetMBarHeight()*2;
#endif

	MoveWindow(theWindow,newH,newV,false);
}

OSErr	disposeGameWindow(WindowPtr theWindow)
{
	OSErr		iErr = noErr;

	//
	DisposePtr(WIN_DATA(theWindow, mapDataOrg_bak));
	DisposePtr(WIN_DATA(theWindow, mapDataOrg));
	DisposePtr(WIN_DATA(theWindow, mapData_bak));
	DisposePtr(WIN_DATA(theWindow, mapData));
	//
	UnlockPixels(WIN_DATA(theWindow, scorePm));
	DisposeGWorld(WIN_DATA(theWindow, scoreGWPtr));
	//
	UnlockPixels(WIN_DATA(theWindow, charaPm));
	DisposeGWorld(WIN_DATA(theWindow, charaGWPtr));
	//
	DisposeHandle(WIN_DATA(theWindow, hiscoreData));
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	DisposeHandle(WIN_DATA(theWindow, hiscoreRemain));
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	//
        
#ifdef TARGET_API_MAC_CARBON
        DisposePtr((Ptr)getWindowDataPtr(theWindow)); 
#endif
	DisposeWindow(theWindow);

	return(iErr);
}

WindowPtr	createGameWindow(void)
{
#ifndef TARGET_API_MAC_CARBON
	OSErr		iErr = noErr;
#endif
	QDErr		qdErr = noErr;
	WindowPtr	theWindow = nil;
	Ptr		storage = nil;
	long		lFreeBytes;
	Rect		theRect;

#ifdef TARGET_API_MAC_CARBON
        Rect wRect;
#endif
	//check for free heap
	lFreeBytes = MaxBlock();
	if(lFreeBytes < k128K)
		bigBadError(eAppMemSmall);		

#ifdef TARGET_API_MAC_CARBON
	SetRect(&wRect,69,38,269,278); /* left, top, right, bottom */
	storage = NewPtrClear(sizeof(WindowDataRec));
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);

        CreateNewWindow(kDocumentWindowClass, kWindowCollapseBoxAttribute, &wRect, &theWindow);
        setWindowDataPtr(theWindow, storage);
//        SetWindowProperty(theWindow, myCreator, 'WDat', sizeof(Ptr), &storage);
#else
	storage = NewPtr(sizeof(myWindowRec));
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);

	theWindow = GetNewCWindow(rGameWindow,storage, kMoveToFront);
#endif
	if(theWindow == nil)
		bigBadError(eAppMemSmall);		

	//***************************************
	//alocate memory
	//***************************************

	//make GWorld for character
	SetRect(&theRect,0,0,kGWorldH,kGWorldV);
	qdErr = NewGWorld(&WIN_DATA(theWindow, charaGWPtr),0,&theRect,nil,nil,0);
	if(qdErr != noErr)
		bigBadError(eAppMemSmall);		
	WIN_DATA(theWindow, charaPm) = GetGWorldPixMap(WIN_DATA(theWindow, charaGWPtr));
	if(!LockPixels(WIN_DATA(theWindow, charaPm)))
		bigBadError(eAppMemSmall);

	//make GWorld for thumb display
	SetRect(&theRect,0,0,kHeaderThumbSize*5,kHeaderThumbSize);
	qdErr = NewGWorld(&WIN_DATA(theWindow, scoreGWPtr),0,&theRect,nil,nil,0);
	if(qdErr != noErr)
		bigBadError(eAppMemSmall);		
	WIN_DATA(theWindow, scorePm) = GetGWorldPixMap(WIN_DATA(theWindow, scoreGWPtr));
	if(!LockPixels(WIN_DATA(theWindow, scorePm)))
		bigBadError(eAppMemSmall);
	
	//allocate memory for map
	WIN_DATA(theWindow, mapData) = NewPtr(kMapMemorySize);
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	WIN_DATA(theWindow, mapData_bak) = NewPtr(kMapMemorySize);
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);	
	WIN_DATA(theWindow, mapDataOrg) = NewPtr(kMapMemorySize);
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	WIN_DATA(theWindow, mapDataOrg_bak) = NewPtr(kMapMemorySize);
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);
	
	//allocate memory(handle) for Hiscore data of the game kind
	WIN_DATA(theWindow, hiscoreData) = NewHandle(kHandleTempSize);
	WIN_DATA(theWindow, hiscoreRemain) = NewHandle(kHandleTempSize);

	//set up game window globals
	GAME_VAL(theWindow, gameStatus) = kNoFlag;
	WIN_DATA(theWindow, clusterCount) = 0;

	//add button to window
	setupMenuButton(theWindow);

	return(theWindow);
}

#pragma mark -

void	doOtherMenu(short item)
{
	switch(item)
	{
		case	mOther_HiScore:
			showHiScoreDialog();
		break;
		case	mOther_Find:
			showTakablePiece();
		break;
		case	mOther_ResetMap:
			resetMap();
		break;
		case	mOther_CharaDefault:
			setDefaultPicture();
		break;
		case	mOther_CharaOther:
			openCustumCharacter();
		break;
		case	mOther_Monkey:
			gPrefVal.isMonkeyMode = !gPrefVal.isMonkeyMode;
			if(gPrefVal.isMonkeyMode)
				alertTwoSeconds(rDLOG_MonkeyMode, nil, nil, nil, nil);	
		break;
		case	mOther_Solution:
			setTumeSolution();		//hidden function: show solution of TumeGame
		break;
	}
}

#pragma mark -


void		drawCharaPICTtoGWorld(WindowPtr wp, PicHandle hPic)
{
#ifndef TARGET_API_MAC_CARBON
	OSErr		iErr = noErr;
#endif
	QDErr		qdErr = noErr;
	Rect			srcRect, dstRect;
	GWorldPtr		tempGWPtr;
	PixMapHandle	pm;
	GrafPtr		savePort;
	CGrafPtr		savedPort;
	GDHandle		savedGdh;
	short		komaFormat;
	short		i;

	if(hPic == nil)
		return;
	if(wp == nil)
		return;

	srcRect = (*hPic)->picFrame;
	komaFormat = getCharacterType(&srcRect);
	if(komaFormat == fError)
		return;

	WIN_DATA(wp, charaType) = komaFormat;

	//make GWorld for full size character
	SetRect(&dstRect,0,0,kGWorldH,kGWorldV);
	qdErr = NewGWorld(&tempGWPtr,32,&dstRect,nil,nil,0);
	if(qdErr != noErr)
		bigBadError(eAppMemSmall);		

	pm = GetGWorldPixMap(tempGWPtr);
	if(!LockPixels(pm))
		bigBadError(eAppMemSmall);

	GetPort(&savePort);
	GetGWorld(&savedPort,&savedGdh);
	SetGWorld(tempGWPtr,0);
	//
	srcRect = (*hPic)->picFrame;
	OffsetRect(&srcRect, -srcRect.left, -srcRect.top);
	DrawPicture(hPic,&srcRect);
	//
	switch(komaFormat)
	{
		case fSame:
			//make picture to display ; shrink it
			SetRect(&dstRect,0,0,GAME_VAL(wp, komaSize)*kSameIconH,GAME_VAL(wp, komaSize)*kSameIconV);
			SetGWorld(WIN_DATA(wp, charaGWPtr),0);
			CopyBits((BitMap *)(* pm), (BitMap *)(*WIN_DATA(wp, charaPm)),&srcRect,&dstRect,ditherCopy,nil);
			//make thumb nail picture
			SetRect(&dstRect,0,0,kHeaderThumbSize*kNumOfKind,kHeaderThumbSize);
			SetGWorld(WIN_DATA(wp, scoreGWPtr),0);
			srcRect.bottom -= kIconSize;
			CopyBits((BitMap *)(* pm), (BitMap *)(*WIN_DATA(wp, scorePm)),&srcRect,&dstRect,ditherCopy,nil);			
		break;
		case	fSame2:
			//make picture to display ; shrink it
			SetRect(&dstRect,0,0,GAME_VAL(wp, komaSize)*kSame2IconH,GAME_VAL(wp, komaSize)*kSame2IconV);
			SetGWorld(WIN_DATA(wp, charaGWPtr),0);
			CopyBits((BitMap *)(* pm), (BitMap *)(*WIN_DATA(wp, charaPm)),&srcRect,&dstRect,ditherCopy,nil);
			//make thumb nail picture
			SetRect(&dstRect,0,0,kHeaderThumbSize*kNumOfKind,kHeaderThumbSize);
			SetGWorld(WIN_DATA(wp, scoreGWPtr),0);
			srcRect.left += kIconSize;			
			srcRect.bottom -= kIconSize;
			CopyBits((BitMap *)(* pm), (BitMap *)(*WIN_DATA(wp, scorePm)),&srcRect,&dstRect,ditherCopy,nil);			
		break;
		case	fMaru:
			//get back color
			GetCPixel(255,0,&(WIN_DATA(wp, backColor)));	
			//make Saru Character
			makeMaruCharacter(pm);
			//make picture to display ; shrink it
			SetRect(&srcRect,0,1,kMaruH,kIconSize*kMaruIconV*kNumOfKind+1);
			SetRect(&dstRect,0,0,GAME_VAL(wp, komaSize)*kMaruIconH,GAME_VAL(wp, komaSize)*kMaruIconV*kNumOfKind);
			SetGWorld(WIN_DATA(wp, charaGWPtr),0);
			CopyBits((BitMap *)(* pm), (BitMap *)(*WIN_DATA(wp, charaPm)),&srcRect,&dstRect,ditherCopy,nil);
			//make thumb nail picture
			SetGWorld(WIN_DATA(wp, scoreGWPtr),0);
			for(i=0; i<kNumOfKind; i++)
			{
				SetRect(&srcRect,0,kIconSize*i*2+1,kIconSize,kIconSize*(i*2+1)+1);
				SetRect(&dstRect,kHeaderThumbSize*i,0,kHeaderThumbSize*(i+1),kHeaderThumbSize);
				CopyBits((BitMap *)(* pm), (BitMap *)(*WIN_DATA(wp, scorePm)),&srcRect,&dstRect,ditherCopy,nil);			
			}
		break;
		case	fError:
			return;
		break;
	}
	//clean up
	SetGWorld(savedPort, savedGdh);
	SetPort(savePort);
	UnlockPixels(pm);
	DisposeGWorld(tempGWPtr);
}

#pragma mark -

OSErr	doOpenSpec(FSSpecPtr spec)
{
	Boolean	isFolder, wasAliased;
	OSErr	iErr = noErr;
	FInfo		fndrInfo;

	// get origianl in case it is an alias
	iErr = ResolveAliasFile(spec, true, &isFolder, &wasAliased);
	if(wasAliased)			//if alias, return : don't make change
		;
	else if (iErr == noErr) 
	{
		if (isFolder)	//when spec points to folder
		{
			;		//do nothing
		}
		else
		{	//when spec points to file
			iErr = FSpGetFInfo(spec,&fndrInfo);
			if(iErr == noErr){
				switch(fndrInfo.fdType)
				{
					case	ftPICTFile:
						fspChangeCharacter(spec);
					break;
					case	myFileType:
						openGameFile(spec);
					break;
					case kPrefType:
						//do nothing, proceed for normal open
					break;
					default:
						alertTwoSeconds(rDLOG_FileOfPrevVersion, spec->name, nil, nil, nil);
					break;
				}
			}
			else
				showOSError(spec->name,  errorFileManager, iErr, kFatal);
		}
	}

	return (iErr);
}

#ifdef TARGET_API_MAC_CARBON

WindowDataPtr getWindowDataPtr(WindowRef winodw)
{
    Ptr ptr;
    OSStatus status;
    
    status = GetWindowProperty(winodw, myCreator, 'WDat', sizeof(Ptr), NULL, &ptr);
    if(status == noErr)
    {
        return (WindowDataPtr)ptr;
    }
    return NULL;
}

void setWindowDataPtr(WindowRef winodw, Ptr ptr)
{
    SetWindowProperty(winodw, myCreator, 'WDat', sizeof(Ptr), &ptr);
}

DialogDataPtr getDialogDataPtr(DialogRef dialog)
{
    Ptr ptr;
    OSStatus status;
    
    status = GetWindowProperty(GetDialogWindow(dialog), myCreator, 'DDat', sizeof(Ptr), NULL, &ptr);
    if(status == noErr)
    {
        return (DialogDataPtr)ptr;
    }
    return NULL;
} 

void setDialogDataPtr(DialogRef dialog, Ptr ptr)
{
    SetWindowProperty(GetDialogWindow(dialog), myCreator, 'DDat', sizeof(Ptr), &ptr);
}

#endif
